<?php

require_once(PATH_t3lib.'class.t3lib_page.php');

class ux_t3lib_pageSelect extends t3lib_pageSelect {

	/**
	 * 
	 * ingmar_accessctrl functions
	 * 
	 **/

	/**
	 * Extending function for enableFields()
	 */
	function enableFields($table,$show_hidden=-1,$ignore_array=array())	{
		global $TCA;

		if(!strcmp($table,'tt_content') || !strcmp($table,'pages')) {
			unset($TCA[$table]['ctrl']['enablecolumns']['fe_group']);
			$TCA[$table]['ctrl']['enablecolumns']['ingmar_accessctrl_multigroup'] = 'fe_group';
		}
		

		
			// Call parent function (the original!)
		$return_value = parent::enableFields($table,$show_hidden,$ignore_array);
			// Check for our custom enable-column, "ingmar_accessctrl_multigroup":
		if (is_array($TCA[$table]) && $TCA[$table]['ctrl']['enablecolumns']['ingmar_accessctrl_multigroup'])	{
			$field = $table.'.'.$TCA[$table]['ctrl']['enablecolumns']['ingmar_accessctrl_multigroup'];
			$return_value .= $this->getMultipleGroupsWhereClause($field);
		}

			// Return the value:
		return $return_value;
	}
	
	function getMultipleGroupsWhereClause($field) {
		$memberGroups = t3lib_div::intExplode(",",$GLOBALS['TSFE']->gr_list);
		$orChecks=array();
		$orChecks[]=$field.'=""';	// If the field is empty, then OK
		$orChecks[]=$field.'="0"';	// If the field contsains zero, then OK
		foreach($memberGroups as $value)	{
			//if ($value > 0)	{	// outcommented by Ingmar because we want those pseudo groups like "hide at login" etc to work. Original comment from Kasper was: "If user is member of a real group, not zero or negative pseudo group"
				$orChecks[]='('.$field.' LIKE "%,'.$value.',%" OR '.
								$field.' LIKE "'.$value.',%" OR '.
								$field.' LIKE "%,'.$value.'" OR '.
								$field.'="'.$value.'")';
			//}
		}
		
		return ' AND ('.implode(' OR ',$orChecks).')';
	}
	
	
	
	
	
	
	
	
	
	
	/**
	 * 
	 * smile_workflow functions
	 * 
	 **/

	/**
	 * Returns an array with pagerows for subpages with pid=$uid (which is pid here!). This is used for menus.
	 * If there are mount points in overlay mode the _MP_PARAM field is set to the corret MPvar.
	 * If the $uid being input does in itself require MPvars to define a correct rootline these must be handled externally to this function.
	 *
	 * @param	integer		The page id for which to fetch subpages (PID)
	 * @param	string		List of fields to select. Default is "*" = all
	 * @param	string		The field to sort by. Default is "sorting"
	 * @param	string		Optional additional where clauses. Like "AND title like '%blabla%'" for instance.
	 * @return	array		Array with key/value pairs; keys are page-uid numbers. values are the corresponding page records (with overlayed localized fields, if any)
	 * @see tslib_fe::getPageShortcut(), tslib_menu::makeMenu(), tx_wizardcrpages_webfunc_2, tx_wizardsortpages_webfunc_2
	 */
	function getMenu($uid,$fields='*',$sortField='sorting',$addWhere='')	{
		//Only published pages are selected
		$addWhere .= ' AND pages.tx_smileworkflow_state=4';
		
		$output = Array();
		$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery($fields, 'pages', 'pid='.intval($uid).$this->where_hid_del.' '.$addWhere, '', $sortField);
		while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))	{
#??			$this->versionOL('pages',$row);

				// Keep mount point:
			$origUid = $row['uid'];
			$mount_info = $this->getMountPointInfo($origUid, $row);	// $row MUST have "uid", "pid", "doktype", "mount_pid", "mount_pid_ol" fields in it
			if (is_array($mount_info) && $mount_info['overlay'])	{	// There is a valid mount point.
				$mp_row = $this->getPage($mount_info['mount_pid']);		// Using "getPage" is OK since we need the check for enableFields AND for type 2 of mount pids we DO require a doktype < 200!
				if (count($mp_row))	{
					$row = $mp_row;
					$row['_MP_PARAM'] = $mount_info['MPvar'];
				} else unset($row);	// If the mount point could not be fetched with respect to enableFields, unset the row so it does not become a part of the menu!
			}

				// Add to output array after overlaying language:
			if (is_array($row))	{
				$output[$origUid] = $this->getPageOverlay($row);
			}
		}
		return $output;
	}
}
?>