<?php
class ux_mediumDoc extends mediumDoc {
	/**
	 * Creates the version selector for the page id inputted.
	 * Requires the core version management extension, "version" to be loaded.
	 *
	 * @param	integer		Page id to create selector for.
	 * @param	boolean		If set, there will be no button for swapping page.
	 * @return	void
	 */
	function getVersionSelector($id,$noAction=FALSE)	{
		if ($id>0 && t3lib_extMgm::isLoaded('version'))	{
			
				//Get labels for all the versions
			$labels = array();
			$sql = 'SELECT uid,name FROM tx_smileworkflow_state ORDER by uid';
			$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
			while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx)){
				$labels[$row['uid']] = $row['name'];
			}

				// Get Current page record:
			$curPage = t3lib_BEfunc::getRecord('pages',$id);
			
				// If the selected page is not online, find the right ID
			if ($curPage['pid']==-1 ){
				$onlineId = $curPage['t3ver_oid'];
				$tmpOnlineId = $curPage['t3ver_oid'];
			}
			else {
				if ($curPage['tx_smileworkflow_state'] == 4){
					$onlineId = $curPage['uid'];
					$tmpOnlineId = $curPage['uid'];
				}
				//Pas de version en ligne
				else {
					$onlineId = 0;
					$tmpOnlineId = $curPage['uid'];
				}
			}
				// Select all versions of online version:
			$versions = t3lib_BEfunc::selectVersionsOfRecord('pages', $tmpOnlineId, 'uid,pid,t3ver_label,t3ver_oid,t3ver_id,tx_smileworkflow_state');

				// Create selector box entries:
			$opt = array();
			foreach($versions as $vRow)	{
				if ($vRow['uid']==$onlineId){
					$label = ' =>'.$GLOBALS['LANG']->sL('LLL:EXT:lang/locallang_core.php:ver.online').'<=';
				}
				else {
					$label = ' ('.$labels[$vRow['tx_smileworkflow_state']].')';
				}
				$opt[] = '<option value="'.htmlspecialchars(t3lib_div::linkThisScript(array('id'=>$vRow['uid']))).'"'.($id==$vRow['uid']?' selected="selected"':'').'>'.
						htmlspecialchars($vRow['t3ver_label'].' [v#'.$vRow['t3ver_id'].']'.$label).
						'</option>';
			}

				// Add management link:
			$opt[] = '<option value="'.htmlspecialchars(t3lib_div::linkThisScript(array('id'=>$id))).'">---</option>';
			$opt[] = '<option value="'.htmlspecialchars($this->backPath.t3lib_extMgm::extRelPath('version').'cm1/index.php?table=pages&uid='.$tmpOnlineId).'">'.$GLOBALS['LANG']->sL('LLL:EXT:lang/locallang_core.php:ver.mgm',1).'</option>';

				// Create onchange handler:
			$onChange = "document.location=this.options[this.selectedIndex].value;";

				// Controls:
			if ($id==$onlineId)	{
				$controls = '<img'.t3lib_iconWorks::skinImg($this->backPath,'gfx/blinkarrow_left.gif','width="5" height="9"').' class="absmiddle" alt="" /> <b>'.$GLOBALS['LANG']->sL('LLL:EXT:lang/locallang_core.php:ver.online',1).'</b>';
			}
				// Write out HTML code:
			return '

				<!--
					Version selector:
				-->
				<table border="0" cellpadding="0" cellspacing="0" id="typo3-versionSelector">
					<tr>
						<td>'.$GLOBALS['LANG']->sL('LLL:EXT:lang/locallang_core.php:ver.selVer',1).'</td>
						<td>
							<select onchange="'.htmlspecialchars($onChange).'">
								'.implode('',$opt).'
							</select></td>
						<td>'.$controls.'</td>
					</tr>
				</table>
			';
		}
	}
}
?>