<?php
require_once (PATH_t3lib."class.t3lib_tcemain.php");
require_once (PATH_tslib."class.tslib_fe.php");

define(PATH_workflow_common, PATH_site.'typo3conf/ext/smile_workflow/common/');
require_once(PATH_workflow_common.'send_mail.class.php');

class ux_t3lib_tsfeBeUserAuth extends t3lib_tsfeBeUserAuth {

	/**
	 * Creates and returns the HTML code for the Admin Panel in the TSFE frontend.
	 * Called from index_ts.php - in the end of the script
	 *
	 * @return	string		HTML for the Admin Panel
	 * @see index_ts.php
	 */
	function extPrintFeAdminDialog()	{
		if ($this->uc['TSFE_adminConfig']['display_top'])	{
			if ($this->extAdmModuleEnabled('workflow'))	$out.= $this->extGetCategory_workflow();
			if ($this->extAdmModuleEnabled('preview'))	$out.= $this->extGetCategory_preview();
			if ($this->extAdmModuleEnabled('cache'))	$out.= $this->extGetCategory_cache();
			if ($this->extAdmModuleEnabled('publish'))	$out.= $this->extGetCategory_publish();
			if ($this->extAdmModuleEnabled('edit'))	$out.= $this->extGetCategory_edit();
			if ($this->extAdmModuleEnabled('tsdebug'))	$out.= $this->extGetCategory_tsdebug();
			if ($this->extAdmModuleEnabled('info'))	$out.= $this->extGetCategory_info();
		}

		$header.='
			<tr class="typo3-adminPanel-hRow" bgcolor="#9BA1A8">
				<td colspan="2" nowrap="nowrap">'.
					$this->extItemLink('top','<img src="t3lib/gfx/ol/'.($this->uc['TSFE_adminConfig']['display_top']?'minus':'plus').'bullet.gif" width="18" height="16" align="absmiddle" border="0" alt="" /><strong>'.$this->extFw($this->extGetLL('adminOptions')).'</strong>').
					$this->extFw(': '.$this->user['username']).
					'</td>
				<td><img src="clear.gif" width="10" height="1" alt="" /></td>
				<td><input type="hidden" name="TSFE_ADMIN_PANEL[display_top]" value="'.$this->uc['TSFE_adminConfig']['display_top'].'" />'.($this->extNeedUpdate?'<input type="submit" value="'.$this->extGetLL('update').'" />':'').'</td>
			</tr>';

		$out='
<!--
	ADMIN PANEL
-->
<a name="TSFE_ADMIN"></a>
<form name="TSFE_ADMIN_PANEL_FORM" action="'.htmlspecialchars(t3lib_div::getIndpEnv('REQUEST_URI')).'#TSFE_ADMIN" method="post" style="margin: 0 0 0 0;">
	<table border="0" cellpadding="0" cellspacing="0" class="typo3-adminPanel" bgcolor="#F6F2E6" style="border: 1px solid black; z-index:0; position:absolute;">'.
		$header.$out.'
	</table>
</form>';

		if ($this->uc['TSFE_adminConfig']['display_top'])	{
			$out.='<script type="text/javascript" src="t3lib/jsfunc.evalfield.js"></script>';
			$out.='
			<script type="text/javascript">
					/*<![CDATA[*/
				var evalFunc = new evalFunc();
					// TSFEtypo3FormFieldSet()
				function TSFEtypo3FormFieldSet(theField, evallist, is_in, checkbox, checkboxValue)	{	//
					var theFObj = new evalFunc_dummy (evallist,is_in, checkbox, checkboxValue);
					var theValue = document.TSFE_ADMIN_PANEL_FORM[theField].value;
					if (checkbox && theValue==checkboxValue)	{
						document.TSFE_ADMIN_PANEL_FORM[theField+"_hr"].value="";
						document.TSFE_ADMIN_PANEL_FORM[theField+"_cb"].checked = "";
					} else {
						document.TSFE_ADMIN_PANEL_FORM[theField+"_hr"].value = evalFunc.outputObjValue(theFObj, theValue);
						document.TSFE_ADMIN_PANEL_FORM[theField+"_cb"].checked = "on";
					}
				}
					// TSFEtypo3FormFieldGet()
				function TSFEtypo3FormFieldGet(theField, evallist, is_in, checkbox, checkboxValue, checkbox_off)	{	//
					var theFObj = new evalFunc_dummy (evallist,is_in, checkbox, checkboxValue);
					if (checkbox_off)	{
						document.TSFE_ADMIN_PANEL_FORM[theField].value=checkboxValue;
					}else{
						document.TSFE_ADMIN_PANEL_FORM[theField].value = evalFunc.evalObjValue(theFObj, document.TSFE_ADMIN_PANEL_FORM[theField+"_hr"].value);
					}
					TSFEtypo3FormFieldSet(theField, evallist, is_in, checkbox, checkboxValue);
				}
					/*]]>*/
			</script>
			<script language="javascript" type="text/javascript">'.$this->extJSCODE.'</script>';
		}
		return "\n\n\n\n".$out.'<br />';
	}
	
	

	/**
	 * Workflow section for the admin panel
	 *
	 * @param	string		Optional start-value; The generated content is added to this variable.
	 * @return	string		HTML content for the section. Consists of a string with table-rows with four columns.
	 * @see extPrintFeAdminDialog()
	 */
	function extGetCategory_workflow($out='')	{
		$out.=$this->extGetHead('workflow');
		if ($this->uc['TSFE_adminConfig']['display_workflow'])	{
			//Looks for the roles of the user (contributor, validator, publisher...)
		    $roles = '';
		    $groupList = $GLOBALS['BE_USER']->groupList;
		    //Non admin user
			if ($groupList){
		    	$sql = 'SELECT distinct tx_smileworkflow_wrole FROM be_groups
		    			WHERE uid IN ('.$groupList.') AND tx_smileworkflow_wrole!=0';
		    	$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
		    	while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx)){
		    		$roles .= ','.$row['tx_smileworkflow_wrole'];
		    	}
		    	$roles = substr($roles,1);
			}
			else {
				$roles = '1,2,3';
			}
			
			//Finds the state of the page
			$sql = 'SELECT tx_smileworkflow_state,pid FROM pages WHERE uid='.$GLOBALS['TSFE']->id;
			$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
			$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx);

			if (t3lib_div::inList($roles,$row['tx_smileworkflow_state']) && $row['tx_smileworkflow_state'] != 3){			
				$out .= '<tr class="typo3-admin-panel-itemRow">
		    			<td><img src="clear.gif" alt="" height="1" width="10"></td>
		    			<td valign="top">'.$this->extGetLL('workflow_action').'</td>
		    			<td><img src="clear.gif" alt="" height="1" width="10"></td>
		    			<td><table border="0" cellpadding="3" cellspacing="0">
						    	<tr>
		    						<td><input type="radio" name="TSFE_ADMIN_PANEL[action][valid][change]" value="accept" checked></td>
		    						<td>'.$this->extGetLL('workflow_accept').'</td>
		    					</tr>';
		    	//If not a single contributor
		    	if (strcmp($roles,'1')){
		    		$out .= '<tr>
		    						<td><input type="radio" name="TSFE_ADMIN_PANEL[action][valid][change]" value="refuse"></td>
						    		<td>'.$this->extGetLL('workflow_refuse').'</td>
						    	</tr>';
		    	}
		    	$out .= '</table>
		    			</td>
		    		</tr>
		    		<tr class="typo3-admin-panel-itemRow">
		    			<td><img src="clear.gif" alt="" height="10" width="20"></td>
		    			<td valign="top">'.$this->extGetLL('workflow_comment').'</td>
		    			<td><img src="clear.gif" alt="" height="1" width="10"></td>
		    			<td><textarea name="TSFE_ADMIN_PANEL[action][valid][comment]" cols="30" rows="5"></textarea>&nbsp;</td>
		    		</tr>
		    		<tr class="typo3-admin-panel-itemRow">
						<td colspan="4"><div align="center">
		    				<input name="TSFE_ADMIN_PANEL[action][workflow][valid]" type="submit" value="'.$this->extGetLL('workflow_submit').'">
		    				</div>
		    			</td>
		    		</tr>';
			}
			//If the user has a role of a publisher and the page can be published and this is not the online version
			elseif (t3lib_div::inList($roles,3) && (($row['tx_smileworkflow_state'] == 4 && $row['pid'] == -1) || ($row['tx_smileworkflow_state'] == 3))){
				$out .= '<tr class="typo3-admin-panel-itemRow">
						<td colspan="4"><img src="clear.gif" alt="" height="15" width="10"></td>
		    		</tr>
		    		<tr class="typo3-admin-panel-itemRow">
						<td colspan="4">&nbsp;
		    				<a href="'.t3lib_div::getIndpEnv('TYPO3_SITE_URL').t3lib_extMgm::siteRelPath('smile_workflow').'cm1/index.php?id='.$GLOBALS['TSFE']->id.'">'
							.$this->extGetLL('workflow_publish').'</a>&nbsp;
							<br><img src="clear.gif" alt="" height="10" width="20">
		    			</td>
		    		</tr>';
		    }	
			else {
				$out .= '<tr class="typo3-admin-panel-itemRow">
		    			<td valign="top" colspan="4">
							<img src="clear.gif" alt="" height="15" width="10">
							'.$this->extGetLL('nothing').'&nbsp;
						</td>
		    		</tr>';
			}
		}
		return $out;
	}


	
	/**
 	* Saves any change in settings made in the Admin Panel.
 	* Called from index_ts.php right after access check for the Admin Panel
 	*
 	* @return	void
 	*/
	function extSaveFeAdminConfig()	{
		$input = t3lib_div::_POST('TSFE_ADMIN_PANEL');
		if (is_array($input))	{
				// Setting
			$this->uc['TSFE_adminConfig'] = array_merge(!is_array($this->uc['TSFE_adminConfig'])?array():$this->uc['TSFE_adminConfig'], $input);			// Candidate for t3lib_div::array_merge() if integer-keys will some day make trouble...
			unset($this->uc['TSFE_adminConfig']['action']);

				// Actions:
			if ($input['action']['clearCache'] && $this->extAdmModuleEnabled('cache'))	{
				$this->extPageInTreeInfo=array();
				$theStartId = intval($input['cache_clearCacheId']);
				$GLOBALS['TSFE']->clearPageCacheContent_pidList($this->extGetTreeList($theStartId, $this->extGetFeAdminValue('cache','clearCacheLevels'),0,$this->getPagePermsClause(1)).$theStartId);
			}
			if ($input['action']['publish'] && $this->extAdmModuleEnabled('publish'))	{
				$theStartId = intval($input['publish_id']);
				$this->extPublishList = $this->extGetTreeList($theStartId, $this->extGetFeAdminValue('publish','levels'),0,$this->getPagePermsClause(1)).$theStartId;
			}
			if ($input['action']['workflow'] && $this->extAdmModuleEnabled('workflow'))	{
				$this->processWorkflowAction($input['action']);
			}

				// Saving
			$this->writeUC();
		}
		$GLOBALS['TT']->LR = $this->extGetFeAdminValue('tsdebug','LR');
		if ($this->extGetFeAdminValue('cache','noCache'))	{$GLOBALS['TSFE']->set_no_cache();}
	}
	
	

	/**
	 * Droulement des actions lies au workflow
	 *
	 * @param	array		$params: action et commentaire
	 * @return	void		
	 */
	function processWorkflowAction($params){
		$validParams = $params['valid'];
    	
		//Id of the page
		if ($GLOBALS['TSFE']->id){
			$id = $GLOBALS['TSFE']->id;
		}
		else {
			$id = 1;
		}
		
		$sql = 'SELECT t3ver_oid, tx_smileworkflow_state FROM pages WHERE uid='.$GLOBALS['TSFE']->id;
		$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
		$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx);

		if (is_array($validParams)){
			//Workflow id
    		$wid = $this->getWorkflowTSconfig($id);
    		
    		//If we get a workflow id, we can go on
    		if ($wid) {
				//List of groups the user belongs to
				$groupList = $GLOBALS['BE_USER']->groupList;
				//Highest state for the user
				$stateMax = 1;
	
				//Not empty list => non admin user
				if ($groupList){
					$stateMax = $this->findStateMax($groupList,$wid,$row['tx_smileworkflow_state']);
				}
				//Empty list => admin
				else {
					$stateMax = 4;
				}
	
				//Validation : the state is increased to the highest authorized state
				if ($validParams['change'] == 'accept'){
					$finalState = $stateMax;
					$sql = 'UPDATE pages SET tx_smileworkflow_state='.$finalState.' WHERE uid='.$GLOBALS['TSFE']->id;
					//Updates DB
					$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
					
					//If the new state is 4 (published), it may be needed to switch versions with the online version
					if ($finalState == 4 && $row['pid'] == -1){
						$cmd['pages'][$row['t3ver_oid']]['version']['action'] = 'swap';
						$cmd['pages'][$row['t3ver_oid']]['version']['swapWith'] = $GLOBALS['TSFE']->id;
						$cmd['pages'][$row['t3ver_oid']]['version']['swapContent'] = 1;
						
						$tce = t3lib_div::makeInstance('t3lib_TCEmain');
						$tce->stripslashes_values = 0;
		
						//Executes the swap
						$tce->start(array(),$cmd);
						$tce->process_cmdmap();
					}
					//Recipient list for emails
					$emailList = $this->buildRecipientList($wid,$stateMax);
				}
				//Refusal : the state is decreased to the latest state, according to tstamp (table smileworkflow_action)
				else {
					$query = 'SELECT state FROM tx_smileworkflow_action
								WHERE wid='.$wid.' AND page='.$GLOBALS['TSFE']->id.' ORDER BY tstamp DESC LIMIT 1';
					$conx = $GLOBALS['TYPO3_DB']->sql_query($query);
					$result = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx);
					$finalState = $result['state'] - 1;
					
					$emailList = $this->findPredecessor($wid,$result['state'],$GLOBALS['TSFE']->id);
					
					$sql = 'UPDATE pages SET tx_smileworkflow_state='.$finalState.' WHERE uid='.$GLOBALS['TSFE']->id;
					//Updates DB
					$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
				}
				
				//Sends emails
				$mail = t3lib_div::makeInstance('SEND_MAIL');
				$mail->initMail(PATH_workflow_common.'template/mail.tmpl', PATH_workflow_common.'template/styles.css');
				$mail->sendMail($emailList,$validParams['change'],$id,$validParams['comment']);
				
				//Inserts action in table smileworkflow_action
				$sql = 'INSERT INTO tx_smileworkflow_action (pid,tstamp,crdate,cruser_id,page,wid,state,comment)
						VALUES (0,'.time().','.time().','.$GLOBALS['BE_USER']->user['uid'].','.$GLOBALS['TSFE']->id.','.$wid.','.$finalState.',"'.addslashes($validParams['comment']).'")';
				$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
			}
    	}
	}
	
	
	
	/**
     * Finds the highest authorized state for the user
     *
     * @param       string          $groupList: list of the groups of the user
     * @param       int             $wid: id of workflow
     * @return      int             highest state
     */
    function findStateMax($groupList,$wid,$currentState){
        $stateList = '';

        //Selects the destgroups for each state
        $sql = 'SELECT state,destgroups FROM tx_smileworkflow_step
                                WHERE wid='.$wid.t3lib_BEfunc::deleteClause('tx_smileworkflow_step').
                                ' ORDER BY state DESC';

        $conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
        while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx)){
                $exploded = explode(',',$row['destgroups']);
                //Finds the highest state authorized
                foreach ($exploded as $value){
                        if (t3lib_div::inList($groupList,$value) && ($row['state']+1 > $currentState)){
                                $stateList .= ','.$row['state'];
                        }
                }
        }
        //Removing the first comma
        $stateList = substr($stateList,1);
        $stateArray = explode(',',$stateList);
        //Getting a sorted array
        sort($stateArray);
        $length = count($stateArray);

        $i = 0;
        //If states allowed follow each other, we can take the highest one.
        //But if the user is a contributor/publisher, we cant bypass the state 'proposed to validation'
        while ($i<$length-1 && ($stateArray[$i+1] == ($stateArray[$i]+1))){
                $i++;
        }
        return $stateArray[$i]+1;
    }

    
    
    
    /**
	 * Finds the predecessor in the workflow
	 *
	 * @param	int		$wid: id of workflow
	 * @param	int		$state: state in the workflow
	 * @param	int		$uid: id of page
	 * @return	int		highest state
	 */
    function findPredecessor($wid,$state,$uid){
    	$sql = 'SELECT email FROM tx_smileworkflow_action, be_users
    			WHERE tx_smileworkflow_action.wid='.$wid.' AND tx_smileworkflow_action.state='.$state.' AND tx_smileworkflow_action.page='.$uid.'
    					AND tx_smileworkflow_action.cruser_id = be_users.uid
    			ORDER BY tx_smileworkflow_action.tstamp DESC';
    	$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
    	$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx);
    	return $row['email'];
    }
    
    
    
    /**
	 * Builds recipient list
	 *
	 * @param	int		$wid: id of workflow
	 * @param	int		$stateMax: highest state authorized for the user
	 * @return	string		recipient list
	 */
    function buildRecipientList($wid,$stateMax){
    	//Recipient list
    	$emailList = '';
    	
    	//Finds the destination groups
    	$sql = 'SELECT destgroups FROM tx_smileworkflow_step
						WHERE wid='.$wid.' AND state='.$stateMax.' AND deleted=0 AND hidden=0';
				$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
				$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx);
		
		//On regarde tous les utilisateurs non admins...pas terrible, mais comment faire mieux ?
		$query = 'SELECT email,usergroup FROM be_users WHERE admin=0';
		$conx = $GLOBALS['TYPO3_DB']->sql_query($query);
		if ($conx){
			while ($rowQuery = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx)){
				$explode = explode(',',$rowQuery['usergroup']);
				if (is_array($explode)){
					foreach ($explode as $value){
						//Si l'utilisateur fait partie d'un des groupes destinataires et
						//que son email est rempli, on l'ajoute  la liste
						if (t3lib_div::inList($row['destgroups'],$value) && $rowQuery['email']){
							$emailList .= ','.$rowQuery['email'];
					}
				}
			}
		}
		}
		//All duplicates are removed
		$emailList = substr($emailList,1);
		$emailList = t3lib_div::uniqueList($emailList);
		return $emailList;
    }



	/**
	 * Gets workflow id of a page
	 *
	 * @param	int		$uid: page id
	 * @return	int		workflow id
	 */
	function getWorkflowTSconfig($uid){
    	//Get TSConfig
		$row = $this->getPagesTSconfig($uid);
		
		$TSvalues = t3lib_BEfunc::implodeTSParams($row);
    	//Get workflow id
		return $TSvalues['user.workflow'];
    }
    
    
    
    /**
	 * Returns the Page TSconfig for page with id, $id
	 * Requires class "t3lib_TSparser"
	 * Usage: 26 (spec. in ext info_pagetsconfig)
	 *
	 * @param	integer		Page uid for which to create Page TSconfig
	 * @param	array		If $rootLine is an array, that is used as rootline, otherwise rootline is just calculated
	 * @param	boolean		If $returnPartArray is set, then the array with accumulated Page TSconfig is returned non-parsed. Otherwise the output will be parsed by the TypoScript parser.
	 * @return	array		Page TSconfig
	 * @see t3lib_TSparser
	 */
	function getPagesTSconfig($id,$rootLine='',$returnPartArray=0)	{
		$id=intval($id);
		if (!is_array($rootLine))	{
			//We don't user BEgetRootline from t3lib_BEfunc (not working correctly heres)
			$rootLine = $this->BEgetRootLine($id,'');
		}
		ksort($rootLine);	// Order correctly, changed 030102
		reset($rootLine);
		$TSdataArray = array();
		$TSdataArray['defaultPageTSconfig']=$GLOBALS['TYPO3_CONF_VARS']['BE']['defaultPageTSconfig'];	// Setting default configuration:
		while(list($k,$v)=each($rootLine))	{
			$TSdataArray['uid_'.$v['uid']]=$v['TSconfig'];
		}
		$TSdataArray = t3lib_TSparser::checkIncludeLines_array($TSdataArray);
		if ($returnPartArray)	{
			return $TSdataArray;
		}

			// Parsing the user TS (or getting from cache)
		$userTS = implode($TSdataArray,chr(10).'[GLOBAL]'.chr(10));
		$hash = md5('pageTS:'.$userTS);
		$cachedContent = t3lib_BEfunc::getHash($hash,0);
		$TSconfig = array();
		if (isset($cachedContent))	{
			$TSconfig = unserialize($cachedContent);
		} else {
			$parseObj = t3lib_div::makeInstance('t3lib_TSparser');
			$parseObj->parse($userTS);
			$TSconfig = $parseObj->setup;
			t3lib_BEfunc::storeHash($hash,serialize($TSconfig),'PAGES_TSconfig');
		}
		return $TSconfig;
	}
    
    
	
	/**
	 * Checks if the page id, $id, is found within the webmounts set up for the user.
	 * This should ALWAYS be checked for any page id a user works with, whether it's about reading, writing or whatever.
	 * The point is that this will add the security that a user can NEVER touch parts outside his mounted pages in the page tree. This is otherwise possible if the raw page permissions allows for it. So this security check just makes it easier to make safe user configurations.
	 * If the user is admin OR if this feature is disabled (fx. by setting TYPO3_CONF_VARS['BE']['lockBeUserToDBmounts']=0) then it returns "1" right away
	 * Otherwise the function will return the uid of the webmount which was first found in the rootline of the input page $id
	 *
	 * @param	integer		Page ID to check
	 * @param	string		Content of "->getPagePermsClause(1)" (read-permissions). If not set, they will be internally calculated (but if you have the correct value right away you can save that database lookup!)
	 * @param	boolean		If set, then the function will exit with an error message.
	 * @return	integer		The page UID of a page in the rootline that matched a mount point
	 */
	function isInWebMount($id,$readPerms='',$exitOnError=0)	{
		if (!$GLOBALS['TYPO3_CONF_VARS']['BE']['lockBeUserToDBmounts'] || $this->isAdmin())	return 1;
		$id = intval($id);
		if (!$readPerms)	$readPerms = $this->getPagePermsClause(1);
		if ($id>0)	{
			$wM = $this->returnWebmounts();
			//On appelle la fonction BEgetrootline de cette classe et plus celle de t3lib_BEfunc (pb avec fixVersioningPid())
			$rL = $this->BEgetRootLine($id,' AND '.$readPerms);

			foreach($rL as $v)	{
				if ($v['uid'] && in_array($v['uid'],$wM))	{
					return $v['uid'];
				}
			}
		}
		if ($exitOnError)	{
			t3lib_BEfunc::typo3PrintError ('Access Error','This page is not within your DB-mounts',0);
			exit;
		}
	}
	
	
	
	/**
	 * Returns what is called the 'RootLine'. That is an array with information about the page records from a page id ($uid) and back to the root.
	 * By default deleted pages are filtered.
	 * This RootLine will follow the tree all the way to the root. This is opposite to another kind of root line known from the frontend where the rootline stops when a root-template is found.
	 * Usage: 1
	 *
	 * @param	integer		Page id for which to create the root line.
	 * @param	string		$clause can be used to select other criteria. It would typically be where-clauses that stops the proces if we meet a page, the user has no reading access to.
	 * @return	array		Root line array, all the way to the page tree root (or as far as $clause allows!)
	 */
	function BEgetRootLine($uid,$clause='')	{
		$loopCheck = 100;
		$theRowArray = Array();
		$output=Array();
		while ($uid!=0 && $loopCheck>0)	{
			$loopCheck--;
			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
							'pid,uid,title,TSconfig,is_siteroot,storage_pid',
							'pages',
							'uid='.intval($uid).' '.
								t3lib_BEfunc::deleteClause('pages').' '.
								$clause		// whereClauseMightContainGroupOrderBy
						);
			if ($GLOBALS['TYPO3_DB']->sql_error())	{
				debug($GLOBALS['TYPO3_DB']->sql_error(),1);
			}
			if ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))	{
				//We use the function fixVersioningPid() of this class, the original one (t3lib_BEfunc) seems not to work correctly
				//and cannot be extended (t3lib_BEfunc not instantiated !!)
				$this->fixVersioningPid('pages',$row);
				$uid = $row['pid'];
				$theRowArray[]=$row;
			} else {
				break;
			}
		}
		if ($uid==0) {$theRowArray[]=Array('uid'=>0,'title'=>'');}
		if (is_array($theRowArray))	{
			reset($theRowArray);
			$c=count($theRowArray);
			while(list($key,$val)=each($theRowArray))	{
				$c--;
				$output[$c]['uid'] = $val['uid'];
				$output[$c]['pid'] = $val['pid'];
				if (isset($val['_ORIG_pid'])) $output[$c]['_ORIG_pid'] = $val['_ORIG_pid'];
				$output[$c]['title'] = $val['title'];
				$output[$c]['TSconfig'] = $val['TSconfig'];
				$output[$c]['is_siteroot'] = $val['is_siteroot'];
				$output[$c]['storage_pid'] = $val['storage_pid'];
			}
		}
		return $output;
	}
	
	
	
	/**
	 * Find page-tree PID for versionized record
	 * Will look if the "pid" value of the input record is -1 and if the table supports versioning - if so, it will translate the -1 PID into the PID of the original record
	 *
	 * @param	string		Table name
	 * @param	array		Record array passed by reference. As minimum, "pid" and "uid" fields must exist! "t3ver_oid" is nice and will save you a DB query.
	 * @return	void		(Passed by ref).
	 * @see t3lib_page::fixVersioningPid()
	 */
	function fixVersioningPid($table,&$rr)	{
		global $TCA;
		
		if (($rr['pid']==-1 && $TCA[$table]['ctrl']['versioning']) || ($rr['pid']==-1 && $table == 'pages'))	{
			if ($rr['t3ver_oid']>0)	{	// If "t3ver_oid" is already a field, just set this:
				$oid = $rr['t3ver_oid'];
			} else {	// Otherwise we have to expect "uid" to be in the record and look up based on this:
				/*$newPidRec = t3lib_BEfunc::getRecord($table,$rr['uid'],'t3ver_oid');
				if (is_array($newPidRec))	{
					$oid = $newPidRec['t3ver_oid'];
				}*/
				$sql = 'SELECT t3ver_oid FROM '.$table.' WHERE uid='.$rr['uid'];
				$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
				$newPidRec = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx);
				$oid = $newPidRec['t3ver_oid'];
			
			}

				// If ID of current online version is found, look up the PID value of that:
			if ($oid)	{
				//$oidRec = t3lib_BEfunc::getRecord($table,$oid,'pid');
				$sql = 'SELECT pid FROM '.$table.' WHERE uid='.$oid;
				$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
				$oidRec = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx);
				if (is_array($oidRec))	{
					$rr['_ORIG_pid'] = $rr['pid'];
					$rr['pid'] = $oidRec['pid'];
				}
			}
		}
	}
}
?>