<?php

require_once(t3lib_extMgm::extPath('smile_workflow').'class.t3lib_page.php');

class ux_tslib_fe extends tslib_fe {

	/**
	 * 
	 * ingmar_accessctrl extension
	 * 
	 **/

	/** 
	 * Checks page record for enableFields
	 * Returns true if enableFields does not disable the page record.
	 * This code is taken from: http://typo3.org/doc.0.html?&tx_extrepmgm_pi1[extUid]=490&tx_extrepmgm_pi1[tocEl]=1308&cHash=e1c9eed2bb
	 */
	function checkEnableFields($row)	{
		if ((!$row["hidden"] || $this->showHiddenPage)
			&& $row["starttime"]<=$GLOBALS["SIM_EXEC_TIME"] 
			&& ($row["endtime"]==0 || $row["endtime"]>$GLOBALS["SIM_EXEC_TIME"])
			&& $this->commonGroups($this->gr_list,$row["fe_group"])
		) {
			return 1;
		}
	}
	
	
	/*
	 * This code is taken from: http://typo3.org/doc.0.html?&tx_extrepmgm_pi1[extUid]=490&tx_extrepmgm_pi1[tocEl]=1308&cHash=e1c9eed2bb
	 */
	function commonGroups($l1, $l2) {
		return count(array_intersect(explode(',', $l1), explode(',', $l2))) > 0;
	}

	/**
	 * Get The Page ID
	 * This gets the id of the page, checks if the page is in the domain and if the page is accessible
	 * Sets variables such as $this->sys_page, $this->loginUser, $this->gr_list, $this->id, $this->type, $this->domainStartPage, $this->idParts
	 *
	 * @return	void
	 * @access private
	 */
	function fetch_the_id()	{
	
		if ($GLOBALS['extension'] == 'ingmar_accessctrl')
		{
		    
			$GLOBALS["TT"]->push("fetch_the_id initialize/","");

			// Initialize the page-select functions. 
		$this->sys_page = t3lib_div::makeInstance("t3lib_pageSelect");
		$this->sys_page->init($this->showHiddenPage);

			// Sets ->loginUser and ->gr_list based on front-end user status.
		$this->fe_user->showHiddenRecords = $this->showHiddenRecords;		// This affects the hidden-flag selecting the fe_groups for the user!
		if (is_array($this->fe_user->user) && $this->fe_user->fetchGroupData())	{
			$this->loginUser=1;	// global flag!
			$this->gr_list = "0,-2";	// group -2 is not an existing group, but denotes a "default" group when a user IS logged in. This is used to let elements be shown for all logged in users!
			$gr_array = $this->fe_user->groupData["uid"];
		} else {
			$this->loginUser=0;
			$this->gr_list = "0,-1";	// group -1 is not an existing group, but denotes a "default" group when not logged in. This is used to let elements be hidden, when a user is logged in!
			$gr_array=array();
		}

			// ADD group-numbers if the IPmask matches.
		if (is_array($GLOBALS["TYPO3_CONF_VARS"]["FE"]["IPmaskMountGroups"]))	{
			reset($GLOBALS["TYPO3_CONF_VARS"]["FE"]["IPmaskMountGroups"]);
			while(list(,$IPel)=each($GLOBALS["TYPO3_CONF_VARS"]["FE"]["IPmaskMountGroups"]))	{
				if (t3lib_div::getIndpEnv("REMOTE_ADDR") && $IPel[0] && t3lib_div::cmpIP(t3lib_div::getIndpEnv("REMOTE_ADDR"),$IPel[0]))	{$gr_array[]=intval($IPel[1]);}
			}
		}

			// Clean up.
		$gr_array = array_unique($gr_array);	// Make unique...
		sort($gr_array);	// sort
		if (count($gr_array))	{
			$this->gr_list.=",".implode(",",$gr_array);
		}
#debug($this->gr_list);

		// Sets sys_page where-clause (hga_div is a helper class, since I need
   	    // the newWherePart() also in class.ux_t3lib_pageSelect.php
		$this->sys_page->where_hid_del .= " AND doktype<200 ".ux_t3lib_pageSelect::getMultipleGroupsWhereClause('pages.fe_group');
			
			// Splitting $this->id by a period (.). First part is 'id' and second part - if exists - will overrule the &type param if given 
		$pParts = explode(".",$this->id);
		$this->id = $pParts[0];	// Set it.
		if (isset($pParts[1]))	{$this->type=$pParts[1];}
		
			// Splitting $this->id by a comma (,). First part is 'id' and other parts are just stored for use in scripts. 
		$this->idParts = explode(",",$this->id);

			// Splitting by a "+" sign - used for base64/md5 methods of parameter encryption for simulate static documents.
		list($pgID,$SSD_p)=explode("+",$this->idParts[0],2);
		if ($SSD_p)	{	$this->idPartsAnalyze($SSD_p);	}
		$this->id = $pgID;	// Set id
		
			// If $this->id is a string, it's an alias
		$this->checkAndSetAlias();
		
			// The id and type is set to the integer-value - just to be sure...
		$this->id = intval($this->id);
		$this->type = intval($this->type);
		$GLOBALS["TT"]->pull();

			// We find the first page belonging to the current domain
		$GLOBALS["TT"]->push("fetch_the_id domain/","");
		$this->domainStartPage = $this->findDomainRecord($GLOBALS["TYPO3_CONF_VARS"]["SYS"]["recursiveDomainSearch"]);	// the page_id of the current domain 
		if (!$this->id)	{
			if ($this->domainStartPage)	{
				$this->id = $this->domainStartPage;	// If the id was not previously set, set it to the id of the domain.
			} else {
				$theFirstPage = $this->sys_page->getFirstWebPage($this->id);	// Find the first "visible" page in that domain
				if ($theFirstPage)	{
					$this->id = $theFirstPage[uid];
				} else {
					$this->printError("No pages are found on the rootlevel!");
					exit;
				}
			}
		}
		$GLOBALS["TT"]->pull();

		$GLOBALS["TT"]->push("fetch_the_id rootLine/","");
		$requestedId = $this->id;		// We store the originally requested id
		$this->getPageAndRootlineWithDomain($this->domainStartPage);
		$GLOBALS["TT"]->pull();

		if ($this->pageNotFound && $this->TYPO3_CONF_VARS["FE"]["pageNotFound_handling"])	{
			$this->pageNotFoundHandler($this->TYPO3_CONF_VARS["FE"]["pageNotFound_handling"],$this->TYPO3_CONF_VARS["FE"]["pageNotFound_handling_statheader"]);
		}

			// set no_cache if set
		if ($this->page["no_cache"])	{
			$this->set_no_cache();
		}
			// Init SYS_LASTCHANGED
		$this->register["SYS_LASTCHANGED"] = intval($this->page["tstamp"]);

			
		}
		else
		{
	
		/**
		 * 
		 * smile_workflow extension
		 * 
		 **/
	
	
		$GLOBALS['TT']->push('fetch_the_id initialize/','');

			// Initialize the page-select functions.
		$this->sys_page = t3lib_div::makeInstance('t3lib_pageSelect');
		$this->sys_page->init($this->showHiddenPage);
		$this->sys_page->versioningPreview = $this->fePreview ? TRUE : FALSE;
		if ($this->sys_page->versioningPreview)	{
			$this->sys_page->versionPreviewMap = $this->versionPreviewMap;
#debug($this->sys_page->versionPreviewMap);
		}

			// Set the valid usergroups for FE
		$this->initUserGroups();

			// Sets sys_page where-clause
		$this->setSysPageWhereClause();
		
		//If not logged in the BE, we don't want to show the page which are not published
		if (!$this->beUserLogin)	{
			$this->sys_page->where_hid_del .= ' AND tx_smileworkflow_state = 4' ;
		}


			// Splitting $this->id by a period (.). First part is 'id' and second part - if exists - will overrule the &type param if given
		$pParts = explode('.',$this->id);
		$this->id = $pParts[0];	// Set it.
		if (isset($pParts[1]))	{$this->type=$pParts[1];}

			// Splitting $this->id by a comma (,). First part is 'id' and other parts are just stored for use in scripts.
		$this->idParts = explode(',',$this->id);

			// Splitting by a '+' sign - used for base64/md5 methods of parameter encryption for simulate static documents.
		list($pgID,$SSD_p)=explode('+',$this->idParts[0],2);
		if ($SSD_p)	{	$this->idPartsAnalyze($SSD_p);	}
		$this->id = $pgID;	// Set id

			// If $this->id is a string, it's an alias
		$this->checkAndSetAlias();

			// The id and type is set to the integer-value - just to be sure...
		$this->id = intval($this->id);
		$this->type = intval($this->type);
		$GLOBALS['TT']->pull();

			// We find the first page belonging to the current domain
		$GLOBALS['TT']->push('fetch_the_id domain/','');
		$this->domainStartPage = $this->findDomainRecord($this->TYPO3_CONF_VARS['SYS']['recursiveDomainSearch']);	// the page_id of the current domain
		if (!$this->id)	{
			if ($this->domainStartPage)	{
				$this->id = $this->domainStartPage;	// If the id was not previously set, set it to the id of the domain.
			} else {
				$theFirstPage = $this->sys_page->getFirstWebPage($this->id);	// Find the first 'visible' page in that domain
				if ($theFirstPage)	{
					$this->id = $theFirstPage['uid'];
				} else {
					$this->printError('No pages are found on the rootlevel!');
					exit;
				}
			}
		}
		
		//We look at the state to know if it is a preview or not
		$sql = 'SELECT tx_smileworkflow_state FROM pages where uid='.$this->id;
		$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
		$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx);

		if ($this->beUserLogin && $row['tx_smileworkflow_state'] != 4){
			$this->fePreview = 1;
		}

		$GLOBALS['TT']->pull();

		$GLOBALS['TT']->push('fetch_the_id rootLine/','');
		$requestedId = $this->id;		// We store the originally requested id
		$this->getPageAndRootlineWithDomain($this->domainStartPage);
		$GLOBALS['TT']->pull();

		if ($this->pageNotFound && $this->TYPO3_CONF_VARS['FE']['pageNotFound_handling'])	{
			$pNotFoundMsg = array(
				1 => 'ID was not an accessible page',
				2 => 'Subsection was found and not accessible',
				3 => 'ID was outside the domain',
			);
			$this->pageNotFoundAndExit($pNotFoundMsg[$this->pageNotFound]);
		}

			// set no_cache if set
		if ($this->page['no_cache'])	{
			$this->set_no_cache();
		}
			// Init SYS_LASTCHANGED
		$this->register['SYS_LASTCHANGED'] = intval($this->page['tstamp']);
		
		}
	}
}
?>