<?php
class ux_t3lib_TStemplate extends t3lib_TStemplate {
	
	/**
	 * Traverses the rootLine from the root and out. For each page it checks if there is a template record. If there is a template record, $this->processTemplate() is called.
	 * Resets and affects internal variables like $this->constants, $this->config, $this->editorcfg and $this->rowSum
	 * Also creates $this->rootLine which is a root line stopping at the root template (contrary to $GLOBALS['TSFE']->rootLine which goes all the way to the root of the tree
	 *
	 * @param	array		The rootline of the current page (going ALL the way to tree root)
	 * @param	integer		Set specific template record UID to select; this is only for debugging/development/analysis use in backend modules like "Web > Template". For parsing TypoScript templates in the frontend it should be 0 (zero)
	 * @return	void
	 * @see start()
	 */
	function runThroughTemplates($theRootLine,$start_template_uid=0)	{
		$this->constants = Array();
		$this->config = Array();
		$this->editorcfg = Array();
		$this->rowSum = Array();
		$this->hierarchyInfoToRoot = Array();
		$this->absoluteRootLine=$theRootLine;	// Is the TOTAL rootline

		reset ($this->absoluteRootLine);
		$c=count($this->absoluteRootLine);
		for ($a=0;$a<$c;$a++)	{
			if ($this->nextLevel)	{	// If some template loaded before has set a template-id for the next level, then load this template first!
				$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*', 'sys_template', 'uid='.intval($this->nextLevel).' '.$this->whereClause);
				$this->nextLevel = 0;
				if ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))	{
					$this->processTemplate($row,'sys_'.$row['uid'],$this->absoluteRootLine[$a]['uid'],'sys_'.$row['uid']);
					$this->outermostRootlineIndexWithTemplate=$a;
				}
				$GLOBALS['TYPO3_DB']->sql_free_result($res);
			}
			$addC='';
			if ($a==($c-1) && $start_template_uid)	{	// If first loop AND there is set an alternative template uid, use that
				$addC=' AND uid='.intval($start_template_uid);
			}
			//Si on est dans le cas d'une version non en ligne, on se dbrouille pour retrouver le TS de la version en ligne
			if ($this->absoluteRootLine[$a]['_ORIG_pid'] == -1){
				$pid = $this->absoluteRootLine[$a]['t3ver_oid'];
			}
			else {
				$pid = $this->absoluteRootLine[$a]['uid'];
			}
			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*', 'sys_template', 'pid='.intval($pid).$addC.' '.$this->whereClause,'','sorting',1);
			
			if ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))	{
				$this->processTemplate($row,'sys_'.$row['uid'],$this->absoluteRootLine[$a]['uid'],'sys_'.$row['uid']);
				$this->outermostRootlineIndexWithTemplate=$a;
			}
			$GLOBALS['TYPO3_DB']->sql_free_result($res);
			$this->rootLine[] = $this->absoluteRootLine[$a];
		}
	}
}
?>
