<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2004  ()
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * smileworkflow module cm1
 *
 * @author     <>
 */



    // DEFAULT initialization of a module [BEGIN]
unset($MCONF);
require ("conf.php");
require ($BACK_PATH."init.php");
require ($BACK_PATH."template.php");
$LANG->includeLLFile("EXT:smile_workflow/cm1/locallang.php");
#include ("locallang.php");
require_once (PATH_t3lib."class.t3lib_scbase.php");
require_once (PATH_t3lib."class.t3lib_tcemain.php");
    // ....(But no access check here...)
    // DEFAULT initialization of a module [END]

define(PATH_workflow_common, PATH_site.'typo3conf/ext/smile_workflow/common/');
require_once(PATH_workflow_common.'send_mail.class.php');


class tx_smileworkflow_cm1 extends t3lib_SCbase {
    /**
 * Main function of the module. Write the content to $this->content
 *
 * @return	string		HTML
 */
    function main()    {
        global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;
            // Draw the header.
        $this->doc = t3lib_div::makeInstance("mediumDoc");
        $this->doc->backPath = $BACK_PATH;
        $this->doc->form='<form action="" method="POST">';

            // JavaScript
        $this->doc->JScode = '
            <script language="javascript" type="text/javascript">
                script_ended = 0;
                function jumpToUrl(URL)    {
                    document.location = URL;
                }
            </script>
        ';

        $this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
        $access = is_array($this->pageinfo) ? 1 : 0;
        if (($this->id && $access) || ($BE_USER->user["admin"] && !$this->id))    {
            if ($BE_USER->user["admin"] && !$this->id)    {
                $this->pageinfo=array("title" => "[root-level]","uid"=>0,"pid"=>0);
            }

            $headerSection = $this->doc->getHeader("pages",$this->pageinfo,$this->pageinfo["_thePath"])."<br>".$LANG->sL("LLL:EXT:lang/locallang_core.php:labels.path").": ".t3lib_div::fixed_lgd_pre($this->pageinfo["_thePath"],50);

            $this->content.=$this->doc->startPage($LANG->getLL("title"));
            $this->content.=$this->doc->header($LANG->getLL("title"));
            $this->content.=$this->doc->spacer(5);
            $this->content.=$this->doc->section("",$this->doc->funcMenu($headerSection,t3lib_BEfunc::getFuncMenu($this->id,"SET[function]",$this->MOD_SETTINGS["function"],$this->MOD_MENU["function"])));
            $this->content.=$this->doc->divider(5);


            // Render content:
            $this->moduleContent();


            // ShortCut
            if ($BE_USER->mayMakeShortcut())    {
                $this->content.=$this->doc->spacer(20).$this->doc->section("",$this->doc->makeShortcutIcon("id",implode(",",array_keys($this->MOD_MENU)),$this->MCONF["name"]));
            }
        }
        $this->content.=$this->doc->spacer(10);
    }

    
	/**
	 * Ecrit le HTML
	 *
	 * @return	sring		HTML
	 */
    function printContent()    {

        $this->content.=$this->doc->endPage();
        echo $this->content;
    }

    
	/**
	 * Shows form or makes actions
	 *
	 * @return	string		HMTL
	 */
    function moduleContent()    {
    	$validParams = t3lib_div::_POST('valid');
    	$publishParams = t3lib_div::_POST('publish');
    	    	
    	//Get online page id
		$id = t3lib_div::_GET('id');
    	
    	//Validation/refusal
    	if (is_array($validParams)){
    		//Get the real page id
			$row = t3lib_BEfunc::getRecord('pages',$validParams['version'],'*');
			$uid = $row['uid'];
    		
    		//Workflow id
    		$wid = $this->getWorkflowTSconfig($id);
    		
    		//If a wid is found, we can go on
    		if ($wid){
				//Rcupration de la liste des groupes auxquels appartient le user
				$groupList = $GLOBALS['BE_USER']->groupList;
				//Finds out the highest state for the user
				//Not empty list => non admin user
				if ($groupList){
					$stateMax = $this->findStateMax($groupList,$wid,$row['tx_smileworkflow_state']);
				}
				//Empty list => admin
				else {
					$stateMax = 4;
				}
	
				//Validation : the state is increased to the highest authorized state
				if ($validParams['change'] == 'accept'){
					$finalState = $stateMax;
					$sql = 'UPDATE pages SET tx_smileworkflow_state='.$finalState.' WHERE uid='.$uid;
					//Updates DB
					$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
					
					//If the new state is 4 (published), it may be needed to switch versions with the online version
					if ($finalState == 4 && $row['pid'] == -1){
						$cmd['pages'][$row['t3ver_oid']]['version']['action'] = 'swap';
						$cmd['pages'][$row['t3ver_oid']]['version']['swapWith'] = $uid;
						$cmd['pages'][$row['t3ver_oid']]['version']['swapContent'] = 1;
						
						$tce = t3lib_div::makeInstance('t3lib_TCEmain');
						$tce->stripslashes_values = 0;
		
						//Executes the swap
						$tce->start(array(),$cmd);
						$tce->process_cmdmap();
					}
					//Recipient list for emails
					$emailList = $this->buildRecipientList($wid,$stateMax);
					
					//Outputs content
					$content .= '<img src="'.$GLOBALS['BACK_PATH'].'gfx/icon_ok2.gif" width="15" height="14">
							<b><font color="#00A000">'.$GLOBALS['LANG']->getLL('accept_done').'</font></b>';
				}
				//Refusal : the state is decreased to the latest state, according to tstamp (table smileworkflow_action)
				else {
					$query = 'SELECT state FROM tx_smileworkflow_action
								WHERE wid='.$wid.' AND page='.$uid.' ORDER BY tstamp DESC LIMIT 1';
					$conx = $GLOBALS['TYPO3_DB']->sql_query($query);
					$result = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx);
					
					$finalState = $result['state'] - 1;
					if ($result['state'] == 1){
						$finalState = $result['state'];
					}
					
					$emailList = $this->findPredecessor($wid,$result['state'],$uid);
					
					$sql = 'UPDATE pages SET tx_smileworkflow_state='.$finalState.' WHERE uid='.$uid;
					//Updates DB
					$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
					
					//Outputs content
					$content .= '<img src="'.$GLOBALS['BACK_PATH'].'gfx/icon_warning2.gif" width="18" height="16">
							<b><font color="#f86a47">'.$GLOBALS['LANG']->getLL('refuse_done').'</font></b>';
				}
				
				//Sends emails
				$mail = t3lib_div::makeInstance('SEND_MAIL');
				$mail->initMail(PATH_workflow_common.'template/mail.tmpl', PATH_workflow_common.'template/styles.css');
				$mail->sendMail($emailList,$validParams['change'],$uid,$validParams['comment']);
				
				//Inserts action in table smileworkflow_action
				$sql = 'INSERT INTO tx_smileworkflow_action (pid,tstamp,crdate,cruser_id,page,wid,state,comment)
						VALUES (0,'.time().','.time().','.$GLOBALS['BE_USER']->user['uid'].','.$uid.','.$wid.','.$finalState.',"'.addslashes($validParams['comment']).'")';
				$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
    		}
    		else {
    			$content .= '<b><font color="#FF0000">'.$GLOBALS['LANG']->getLL('no_wid').'</font></b>';
    		}
    	}
    	
    	//Swapping published versions
    	if (is_array($publishParams)){
    		//Get the real page id
			$row = t3lib_BEfunc::getRecord('pages',$publishParams['version'],'*');
			$uid = $row['uid'];
			
    		$cmd['pages'][$row['t3ver_oid']]['version']['action'] = 'swap';
			$cmd['pages'][$row['t3ver_oid']]['version']['swapWith'] = $uid;
			$cmd['pages'][$row['t3ver_oid']]['version']['swapContent'] = 1;

			$tce = t3lib_div::makeInstance('t3lib_TCEmain');
			$tce->stripslashes_values = 0;

			//Executes the swap
			$tce->start(array(),$cmd);
			$tce->process_cmdmap();
			
			$content .= '<img src="'.$GLOBALS['BACK_PATH'].'gfx/icon_ok2.gif" width="15" height="14">
						<b><font color="#00A000">'.$GLOBALS['LANG']->getLL('change_publish').'</font></b>';
    	}
    	
    	//Otherwise outputs the form
    	if (!is_array($validParams) && !is_array($publishParams) && ($id)) {
    		$content .= $this->makeForm();
    	}
    	elseif (!is_array($validParams) && !is_array($publishParams) && (!$id)) {
//		else {
    		$content .= $GLOBALS['LANG']->getLL('no_version');
    	}

        $this->content.=$this->doc->section($GLOBALS['LANG']->getLL('workflow'),$content,0,1);
    	
    }
    

    
	/**
	 * Makes validation/refusal form
	 *
	 * @return	string		HTML
	 */
    function makeForm(){
    	//Id of the page
    	$id = t3lib_div::_GET('id');
    	
    	//Looks for the roles of the user (contributor, validator, publisher...)
    	$roles = '';
    	$groupList = $GLOBALS['BE_USER']->groupList;
    	//Non admin user
    	if ($groupList){
	    	$sql = 'SELECT distinct tx_smileworkflow_wrole FROM be_groups
	    			WHERE uid IN ('.$groupList.') AND tx_smileworkflow_wrole!=0';
	    	$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
	    	while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx)){
	    		$roles .= ','.$row['tx_smileworkflow_wrole'];
	    	}
	    	$roles = substr($roles,1);
    	}
    	else {
    		$roles = '1,2,3';
    	}
    	
    	//We look for the versions on which the user can do actions
    	$optionsArray = array('classic' => $this->makeVersionsList($id,$roles),
    						'published' => $this->makeVersionsList($id,$roles,'true'));
    						
    						
    	//If the list of authorized versions is not empty, we make the form
    	if (strlen($optionsArray['classic'])){	
	    	$content = '<form name="validation" method="POST">
	    	<table border="0" cellpadding="5" cellspacing="0">
	    		<tr>
	    			<td>'.$GLOBALS['LANG']->getLL('version').'</td>
	    			<td><img src="clear.gif" width="5" height="1"></td>
	    			<td><select name="valid[version]">'.
	    			$optionsArray['classic'].'</select></td>
	    		</tr>
	    		<tr>
	    			<td valign="top">'.$GLOBALS['LANG']->getLL('action').'</td>
	    			<td><img src="clear.gif" width="5" height="1"></td>
	    			<td><table border="0" cellpadding="3" cellspacing="0">
					    	<tr>
	    						<td><input type="radio" name="valid[change]" value="accept" checked></td>
	    						<td>'.$GLOBALS['LANG']->getLL('accept').'</td>
	    					</tr>';
	    	//If we are not a contributor
	    	if (strcmp($roles,'1')){
	    		$content .= '<tr>
	    						<td><input type="radio" name="valid[change]" value="refuse"></td>
					    		<td>'.$GLOBALS['LANG']->getLL('refuse').'</td>
					    	</tr>';
	    	}
	    	$content .= '</table>
	    			</td>
	    		</tr>
	    		<tr>
	    			<td valign="top">'.$GLOBALS['LANG']->getLL('comment').'</td>
	    			<td><img src="clear.gif" width="5" height="1"></td>
	    			<td><textarea name="valid[comment]" cols="50" rows="5"></textarea></td>
	    		</tr>
	    		<tr>
	    			<td colspan="3" align="center"><input type="submit" value="'.$GLOBALS['LANG']->getLL('submit').'"></td>
	    		</tr>
	    	</table>
	    	</form>';
    	}
    	//If the user is a publisher
    	if (strlen($optionsArray['published'])) {
    		$content .= '<form name="publish" action="" method="POST">
				<table border="0" cellpadding="0" cellspacing="0">
					<tr>
						<td>'.$GLOBALS['LANG']->getLL('version_publish').'</td>
    					<td><img src="clear.gif" width="5" height="1"></td>
    					<td><select name="publish[version]">'.$optionsArray['published'].'</select></td>
					</tr>
    				<tr>
    					<td colspan="3"><img src="clear.gif" width="5" height="10"></td>
					</tr>
    				<tr>
    					<td colspan="3" align="center"><input type="submit" value="'.$GLOBALS['LANG']->getLL('publish').'"></td>
					</tr>
				</table>
    					</form>';
    	}
    	if (!strlen($optionsArray['classic']) && !strlen($optionsArray['published'])) {
    		$content = '<img src="'.$GLOBALS['BACK_PATH'].'gfx/icon_fatalerror.gif" width="18" height="16">
    			<b><font color="#FF0000">'.$GLOBALS['LANG']->getLL('no_action').'</font></b>';
    	}
    	return $content;
    }

    
    
    /**
     * Finds the highest authorized state for the user
     *
     * @param       string          $groupList: list of the groups of the user
     * @param       int             $wid: id of workflow
     * @return      int             highest state
     */
    function findStateMax($groupList,$wid,$currentState){
        $stateList = '';

        //Selects the destgroups for each state
        $sql = 'SELECT state,destgroups FROM tx_smileworkflow_step
                                WHERE wid='.$wid.t3lib_BEfunc::deleteClause('tx_smileworkflow_step').
                                ' ORDER BY state DESC';

        $conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
        while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx)){
                $exploded = explode(',',$row['destgroups']);
                //Finds the highest state authorized
                foreach ($exploded as $value){
                        if (t3lib_div::inList($groupList,$value) && ($row['state']+1 > $currentState)){
                                $stateList .= ','.$row['state'];
                        }
                }
        }
        //Removing the first comma
        $stateList = substr($stateList,1);
        $stateArray = explode(',',$stateList);
        //Getting a sorted array
        sort($stateArray);
        $length = count($stateArray);

        $i = 0;
        //If states allowed follow each other, we can take the highest one.
        //But if the user is a contributor/publisher, we cant bypass the state 'proposed to validation'
        while ($i<$length-1 && ($stateArray[$i+1] == ($stateArray[$i]+1))){
                $i++;
        }
        return $stateArray[$i]+1;
    }

    
    
    
    /**
	 * Finds the predecessor in the workflow
	 *
	 * @param	int		$wid: id of workflow
	 * @param	int		$state: state in the workflow
	 * @param	int		$uid: id of page
	 * @return	int		highest state
	 */
    function findPredecessor($wid,$state,$uid){
    	$sql = 'SELECT email FROM tx_smileworkflow_action, be_users
    			WHERE tx_smileworkflow_action.wid='.$wid.' AND tx_smileworkflow_action.state='.$state.' AND tx_smileworkflow_action.page='.$uid.'
    					AND tx_smileworkflow_action.cruser_id = be_users.uid
    			ORDER BY tx_smileworkflow_action.tstamp DESC';
    	$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
    	$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx);
    	return $row['email'];
    }
    
    
    
    /**
	 * Builds recipient list
	 *
	 * @param	int		$wid: id of workflow
	 * @param	int		$stateMax: highest state authorized for the user
	 * @return	string		recipient list
	 */
    function buildRecipientList($wid,$stateMax){
    	//Recipient list
    	$emailList = '';
		
    	//Finds the destination groups
    	$sql = 'SELECT destgroups FROM tx_smileworkflow_step
						WHERE wid='.$wid.' AND state='.$stateMax.' AND deleted=0 AND hidden=0';
				$conx = $GLOBALS['TYPO3_DB']->sql_query($sql);
				$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx);
		
		//On regarde tous les utilisateurs non admins...pas terrible, mais comment faire mieux ?
		$query = 'SELECT email,usergroup FROM be_users WHERE admin=0';
		$conx = $GLOBALS['TYPO3_DB']->sql_query($query);
		if ($conx){
			while ($rowQuery = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($conx)){
				$explode = explode(',',$rowQuery['usergroup']);
				if (is_array($explode)){
					foreach ($explode as $value){
						//Si l'utilisateur fait partie d'un des groupes destinataires et
						//que son email est rempli, on l'ajoute  la liste
						if (t3lib_div::inList($row['destgroups'],$value) && $rowQuery['email']){
							$emailList .= ','.$rowQuery['email'];
						}
					}
				}
			}
		}
		//All duplicates are removed
		$emailList = substr($emailList,1);
		$emailList = t3lib_div::uniqueList($emailList);
		return $emailList;
    }


	/**
	 * Builds a list of authorized versions for the user
	 *
	 * @param	int		$uid: id of page
	 * @param	string		$roles: comma-separated list of the roles of the user
	 * @param	string		$publishCmd: true to find only published versions
	 * @return	string		HTML
	 */
    function makeVersionsList($uid,$roles,$publishCmd='false'){
    	//All page versions are found
    	$versions = t3lib_BEfunc::selectVersionsOfRecord('pages',$uid,'uid');

    	//Get workflow id
    	$wid = $this->getWorkflowTSconfig($uid);

		//We build an array with the authorized versions
		$authorizedVersions = array();

		foreach ($versions as $value){
			$stateValue = t3lib_BEfunc::getRecord('pages',$value['uid'],'tx_smileworkflow_state,pid');
			switch ($publishCmd){
				case 'false':
					if (t3lib_div::inList($roles,$stateValue['tx_smileworkflow_state'])){
						array_push($authorizedVersions,$value['uid']);
					}
					break;
				case 'true':
					//Select only published versions, but not the online one
					if (t3lib_div::inList($roles,3) && $stateValue['tx_smileworkflow_state'] == 4 && $stateValue['pid'] == -1){
						array_push($authorizedVersions,$value['uid']);
					}
					break;
			}
		}
		$output = '';
		//Finally, a combo box with the authorized versions
		foreach ($authorizedVersions as $value){
			$row = t3lib_BEfunc::getRecord('pages',$value,'t3ver_label,t3ver_id');
			$output .= '<option value="'.$value.'">'.$row['t3ver_label'].' [v#'.$row['t3ver_id'].']</option>';
		}
		return $output;
    }
   	

    
	/**
	 * Retrouve l'id du workflow dans le TSconfig de la page
	 *
	 * @param	int		$uid: identifiant de page
	 * @return	int		identifiant de workflow
	 */
    function getWorkflowTSconfig($uid){
    	//Get TSconfig
		$row = t3lib_BEfunc::getPagesTSconfig($uid);
		$TSvalues = t3lib_BEfunc::implodeTSParams($row);
    	//Get workflow id
		return $TSvalues['user.workflow'];
    }
}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/smile_workflow/cm1/index.php"])    {
    include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/smile_workflow/cm1/index.php"]);
}




// Make instance:
$SOBE = t3lib_div::makeInstance("tx_smileworkflow_cm1");
$SOBE->init();


$SOBE->main();
$SOBE->printContent();

?>