<?php

	require_once 'db_database.class.php';
	require_once 'db_query_mysql.class.php';
	require_once 'db_table_mysql.class.php';
	
	class DB_DATABASE_MYSQL extends DB_DATABASE
	{
		/**
		 * constructor
		 * @access public
		 **/
	
		function DB_DATABASE_MYSQL()
		{
			DB_DATABASE::DB_DATABASE();
			
		}
		
		/**
		 * get autocommit
		 * @return boolean
		 * @access public
		 **/
		
		function get_autocommit()
		{
			/**
			 * TO DO
			 **/
		}
		
		/**
		 * set autocommit
		 * @param boolean $b_autocommit
		 * @access public
		 **/
		
		function set_autocommit($b_autocommit)
		{
			/**
			 * TO DO
			 **/
		}

		
		/**
		 * connect to database
		 * @param	boolean	$b_persistant
		 * @return	integer
		 * @access	public
		 **/

		function connect($b_persistent=false)
		{
			if (isset($this->m_i_connection))
			{
			    return $this->m_i_connection ;
			}
			else
			{
				$s_connect_function = ($b_persistent) ? "mysql_pconnect" : "mysql_connect";		

				if (isset($this->m_s_host))
				{
					if (isset($this->m_s_user))
					{
						if (isset($this->m_s_password))
						{
							$this->m_i_connection = @$s_connect_function($this->m_s_host, $this->m_s_user, $this->m_s_password);
						}
						else
							$this->m_i_connection = @$s_connect_function($this->m_s_host, $this->m_s_user);
					}
					else
						$this->m_i_connection = @$s_connect_function($this->m_s_host);
				}

				if ($this->m_i_connection)
				{
					if (!@mysql_select_db($this->m_s_database, $this->m_i_connection))
					{
						$this->m_i_connection = false ;
					}
					else
						$this->m_s_error = @mysql_error($this->m_i_connection);
				}
				else
					$this->m_s_error = @mysql_error($this->m_i_connection);
				
				return $this->m_i_connection ;
			}
		}
		
		/**
		 * disconnect from database
		 * @return	boolean
		 * @access	public
		 **/
		
		function disconnect()
		{
			if ($this->m_i_connection)
				return @mysql_close($this->m_i_connection);

			return false;
		}
		
		/**
		 * create database
		 * @access public
		 **/
		
		function create()
		{
			if (isset($this->m_s_database))
			{
				$o_query = new DB_QUERY_MYSQL();
			
				$o_query->add_sql('CREATE DATABASE ' . $this->m_s_database) ;
			
				return $o_query->execute();
			}
			else
			{
				return false ;
			}
		}
		
		/**
		 * drop database
		 * @access public
		 **/
		
		function drop()
		{
			if (isset($this->m_s_database))
			{
				$o_query = new DB_QUERY_MYSQL();
			
				$o_query->add_sql('DROP DATABASE ' . $this->m_s_database) ;
			
				return $o_query->execute();
			}
			else
			{
				return false ;
			}
		}
		
		/**
		 * get info
		 * @return array
		 * @access public
		 **/
		
		function get_info()
		{
			
			$o_query = $this->new_query() ;
			
			$o_query->add_sql('SELECT version() as version') ;
			
			if ($o_query->execute())
			{			
				$a_result = $o_query->fetch() ;
			
			    $a_info['server'] = 'MySQL '. $a_result['version'] ;
				
				$o_query->free() ;
			}
			
			$a_info['database'] = $this->m_s_databse ;
			$a_info['user'] = $this->m_s_user ;
			
			return $a_info ;
		}
		
		/**
		 * get last error
		 * @return string
		 * @access public
		 **/
		
		function get_error()
		{
			return @mysql_error($this->m_i_connection);
		}
		
		/**
		 * get last error code
		 * @return integer
		 * @access public
		 **/
		
		function get_error_code()
		{
			return @mysql_errno($this->m_i_connection) ;
		}
		
		/**
		 * begin transaction
		 * @return 	boolean
		 * @access	public
		 **/
		
		function begin()
		{
			$o_query = new DB_QUERY_MYSQL();
			
			$o_query->add_sql("BEGIN");
			
			return $o_query->execute();
		}
		
		/**
		 * rollback transaction
		 * @return 	boolean
		 * @access	public
		 **/
		
		function rollback()
		{
			$o_query = new DB_QUERY_MYSQL();
			
			$o_query->add_sql("ROLLBACK");
			
			return $o_query->execute();
		}
		
		/**
		 * commit transaction
		 * @return 	boolean
		 * @access	public
		 **/
		
		function commit()
		{
			$o_query = new DB_QUERY_MYSQL();
			
			$o_query->add_sql("COMMIT");
			
			return $o_query->execute();
		}
		
		/**
		 * new query
		 * @return 	DB_QUERY_MYSQL
		 * @access	public
		 **/
		
		function new_query()
		{
			$o_query = new DB_QUERY_MYSQL() ;
			
			$o_query->set_database($this);
			 
			return $o_query ;
		}
		
		/**
		 * new table
		 * @return 	DB_TABLE_MYSQL
		 * @access	public
		 **/
		
		function new_table()
		{
			$o_table = new DB_TABLE_MYSQL() ;
			
			$o_table->set_database($this);
			 
			return $o_table ;
		}
	}
?>
