<?php

	require_once 'object.class.php';
	
	/**
	 * DB_FIELD
	 * 
	 * @package DB
	 * @author Julian ROBLIN
	 * @copyright copyright (c) 2005
	 * @version 1.0
	 * @access public
	 **/
	
	class DB_FIELD extends OBJECT
	{
		/**
		 * name
		 * @var		string
		 * @access	protected
		 **/
		 
		var $m_s_name ;
		
		/**
		 * auto increment
		 * @var		boolean
		 * @access	protected
		 **/
		
		var $m_b_auto_increment ;
		
		/**
		 * type
		 * @var		string
		 * @access	protected
		 **/
		
		var $m_s_type ;
		
		/**
		 * value
		 * @var		undefined
		 * @access	protected
		 **/
		
		var $m_u_value ;
		
		/**
		 * default value
		 * @var		undefined
		 * @access	protected
		 **/
		
		var $m_u_default ;
		
		/**
		 * length
		 * @var		integer
		 * @access	protected
		 **/
		
		var $m_i_length ;
		
		/**
		 * precision
		 * @var		integer
		 * @access	protected
		 **/
		
		var $m_i_precision ;
		
		/**
		 * nullable
		 * @var		boolean
		 * @access	protected
		 **/
		
		var $m_b_nullable ;
		
		/**
		 * comment
		 * @var		string
		 * @access	protected
		 **/
		
		var $m_s_comment ;
		
		/**
		 * table
		 * @var		DB_TABLE
		 * @access	protected
		 **/
		
		var $m_o_table ;
	
		/**
		 * constructor
		 * @access public
		 **/
	
		function DB_FIELD()
		{
			OBJECT::OBJECT() ;
			
			$this->m_b_auto_increment = false ;
		}
		
		/**
		 * get accessor for variable m_s_name
		 * @return	string
		 * @access	public
		 **/
		
		function get_name()
		{
			return $this->m_s_name ;
		}
		
		/**
		 * get accessor for variable m_b_auto_increment
		 * @return	boolean
		 * @access	public
		 **/
		
		function get_auto_increment()
		{
			return $this->m_b_auto_increment ;
		}
		
		/**
		 * get accessor for variable m_s_type
		 * @return	string
		 * @access	public
		 **/
		
		function get_type()
		{
			return $this->m_s_type ;
		}
		
		/**
		 * get accessor for variable m_u_value
		 * @return	undefined
		 * @access	public
		 **/
		
		function get_value()
		{
			return $this->m_u_value ;
		}
		
		/**
		 * get accessor for variable m_u_default
		 * @return	undefined
		 * @access	public
		 **/
		
		function get_default()
		{
			return $this->m_u_default ;
		}
		
		/**
		 * get accessor for variable m_i_length
		 * @return	integer
		 * @access	public
		 **/
		
		function get_length()
		{
			return $this->m_i_length ;
		}
		
		/**
		 * get accessor for variable m_i_precision
		 * @return	integer
		 * @access	public
		 **/
		
		function get_precision()
		{
			return $this->m_i_precision ;
		}
		
		/**
		 * get accessor for variable m_b_nullable
		 * @return	boolean
		 * @access	public
		 **/
		
		function get_nullable()
		{
			return $this->m_b_nullable ;
		}
		
		/**
		 * get accessor for variable m_s_comment
		 * @return	string
		 * @access	public
		 **/
		
		function get_comment()
		{
			return $this->m_s_comment ;
		}
		
		/**
		 * set accessor for variable m_s_name
		 * @param	string $s_name
		 * @access	public
		 **/
		
		function set_name($s_name)
		{
			if (is_string($s_name))
			{
			    $this->m_s_name = $s_name ;
			}			
		}
		
		/**
		 * set accessor for variable m_b_auto_increment
		 * @param	boolean	$b_auto_increment
		 * @access 	public
		 **/
		
		function set_auto_increment($b_auto_increment)
		{		
			if (is_bool($b_auto_increment))
			{			
			    $this->m_b_auto_increment = $b_auto_increment ;
			}
		}
		
		/**
		 * set accessor for variable m_s_type
		 * @param	string $s_type
		 * @access	public
		 **/
		
		function set_type($s_type)
		{
			if (is_string($s_type))
			{						
				$this->m_s_type = $s_type ;
			}
		}
		
		/**
		 * set accessor for variable m_u_value
		 * @param	undefined $u_value
		 * @access	public
		 **/
		
		function set_value($u_value)
		{
			$this->m_u_value = $u_value ;
		}
		
		/**
		 * set accessor for variable m_u_default
		 * @param	undefined $u_default
		 * @access	public
		 **/
		
		function set_default($u_default)
		{
			$this->m_u_default = $u_default ;
		}
		
		/**
		 * set accessor for variable m_i_length
		 * @param	integer $i_length
		 * @access	public
		 **/
		
		function set_length($i_length)
		{
			if (is_numeric($i_length))
			{
			    $this->m_i_length = $i_length ;
			}
		}
		
		/**
		 * set accessor for variable m_i_precision
		 * @param	integer $i_precision
		 * @access	public
		 **/
		
		function set_precision($i_precision)
		{
			if (is_numeric($i_length))
			{
			    $this->m_i_precision = $i_precision ;
			}
		}
		
		/**
		 * set accessor for variable m_b_nullable
		 * @param	boolean $b_nullable
		 * @access	public
		 **/
		
		function set_nullable($b_nullable)
		{
			if (is_bool($b_nullable))
			{			
			    $this->m_b_nullable = $b_nullable ;
			}	
		}
		
		/**
		 * set accessor for variable m_s_comment
		 * @param	string $s_comment
		 * @access	public
		 **/
		
		function set_comment($s_comment)
		{
			if (is_string($s_comment))
			{
			    $this->m_s_comment = $s_comment ;
			}
		}
		
		/**
		 * get accessor for variable m_o_table
		 * @return DB_TABLE
		 * @access public
		 **/

		function get_table()
		{
			return $this->m_o_table ;
		}

		/**
		 * set accessor for variable m_o_table
		 * @param DB_TABLE $o_table
		 * @access public
		 **/

		function set_table($o_table)
		{		
			$this->m_o_table = $o_table ;
		}
		
		/**
		 * get sql value
		 * @return	undefined
		 * @access	public
		 **/
		
		function get_sql_value()
		{		
			if(eregi('char', $this->m_s_type) || eregi('date', $this->m_s_type) || eregi('string', $this->m_s_type) || eregi("text", $this->m_s_type) || eregi("blob", $this->m_s_type))
			{
			
			
				$s_sql = '\'' . addslashes(str_replace('\n', '<br>', $this->m_u_value)) . '\'';			    
			}
			else
			{
				if ((strlen($this->m_u_value) == 0) || strtoupper($this->m_u_value) == 'NULL')
					$s_sql = 'NULL' ;
				else
					$s_sql = $this->m_u_value ;
			}
							
			return $s_sql ;
		}
		
		/**
		 * get sql
		 * @return	string
		 * @access	public
		 **/
		 
		function get_sql()
		{
			$s_sql = $this->m_s_name . ' ' . $this->m_s_type ;
			
			if (isset($this->m_i_length))
			{
				$s_sql .= '(' ;
				
				$s_sql .= $this->m_i_length ;
				
				if (isset($this->m_i_precision))
				{
					$s_sql .= ', ' . $this->m_i_precision ;
				}
				
				$s_sql .= ')' ;
			}
						
			if ($this->m_b_nullable === false)
			{
				$s_sql .= ($this->m_b_nullable) ? '' : ' NOT NULL' ;
			}
						
			if ($this->m_b_auto_increment === false)
			{
				if ($this->m_b_nullable === false)
				{
				    if(eregi('char', $this->m_s_type) || eregi('date', $this->m_s_type) || eregi('string', $this->m_s_type) || eregi("text", $this->m_s_type) || eregi("blob", $this->m_s_type))
					{								
						$s_sql .= ' DEFAULT \'' . $this->m_u_default . '\'' ;
					}
					else
					{
						if (eregi('int', $this->m_s_type))
						{
						 	if (empty($this->m_u_default))
							{
								$s_sql .= ' DEFAULT 0';
						 	}
							else
							{
								$s_sql .= ' DEFAULT ' . $this->m_u_default ;
							}	
						}
					}
				}
			}
			
			return $s_sql ;
		}	
	}
?>