<?php

	require_once 'db_object.class.php';
	
	/**
	 * DB_QUERY
	 * 
	 * @package DB
	 * @author Julian ROBLIN
	 * @copyright copyright (c) 2005
	 * @version 1.0
	 * @abstract
	 * @access public
	 **/

	class DB_QUERY extends DB_OBJECT
	{
		/**
		 * query stmt
		 * @var integer
		 * @access protected
		 **/
	
		var $m_i_stmt ;
		
		/**
		 * sql array
		 * @var array
		 * @access protected
		 **/
		
		var $m_a_sql ;
		
		/**
		 * start
		 * @var integer
		 * @access protected
		 **/
		
		var $m_i_start ;
		
		/**
		 * limit
		 * @var integer
		 * @access protected
		 **/
		
		var $m_i_limit ;
		
		/**
		 * row count
		 * @var integer
		 * @access protected
		 **/
		
		var $m_i_row_count ;
	
		/**
		 * constructor
		 * @access public
		 **/
		
		function DB_QUERY()
		{
			DB_OBJECT::DB_OBJECT();

			$this->set_sql(array()) ;
		}

		/**
		 * get acessor for variable a_sql
		 * @return array
		 * @access public
		 **/

		function get_sql() { return $this->m_a_sql; }

		/**
		 * set acessor for variable a_sql
		 * @param array
		 * @access public
		 **/

		function set_sql($a_sql) { $this->m_a_sql = $a_sql ; }

		/**
		 * get acessor for variable i_start
		 * @return integer
		 * @access public
		 **/

		function get_start() { return $this->m_i_start ; }

		/**
		 * set acessor for variable i_start
		 * @param integer
		 * @access public
		 **/

		function set_start($i_start) { $this->m_i_start = $i_start; }

		/**
		 * get acessor for variable i_limit
		 * @return integer
		 * @access public
		 **/

		function get_limit() { return $this->m_i_limit ; }

		/**
		 * set acessor for variable i_limit
		 * @param integer
		 * @access public
		 **/

		function set_limit($i_limit) { $this->m_i_limit = $i_limit; }

		/**
		 * get acessor for variable i_row_count
		 * @return array
		 * @access public
		 **/

		function get_row_count() { return $this->m_i_row_count ; }

		/**
		 * set acessor for variable i_row_count
		 * @param integer
		 * @access public
		 **/

		function set_row_count($i_row_count) { $this->m_i_row_count = $i_row_count ; }

		/**
		 * add sql to query
		 * @param string or array $s_sql
		 * @access public
		 **/

		function add_sql($s_sql)
		{
			$s_type = gettype($s_sql);

			switch($s_type)
			{
				case 'string':
				{
					array_push($this->m_a_sql, $s_sql);

					break;
				}
				case 'array':
				{
					$this->m_a_sql = array_merge($this->m_a_sql, $s_sql);

					break;
				}
			}
		}

		/**
		 * clear sql
		 * @access public
		 **/

		function clear_sql()
		{
			$this->m_a_sql = array() ;
		}

		/**
		 * return sql
		 * @param string $s_separator
		 * @access public
		 **/

		function get_merged_sql($s_separator=' ')
		{
			$s_sql = '';

			foreach($this->m_a_sql as $s_line)
				$s_sql .= $s_line . $s_separator;

			return $s_sql;
		}
		
		/**
		 * return highlighted sql
		 * @param string $s_separator
		 * @access public
		 **/
		
		function get_highlighted_sql($s_separator=' ')
		{
			return $this->m_o_database->get_highlighted_sql($this->get_merged_sql($s_separator)) ;
		}	
	}
?>
