<?php	
	require_once 'db_query.class.php';

	class DB_QUERY_MYSQL extends DB_QUERY
	{
		/**
		 * constructor
		 * @access public
		 **/
	
		function DB_QUERY_MYSQL()
		{
			DB_QUERY::DB_QUERY() ;
		}

		/**
		 * return last insert id
		 * @return integer
		 * @access public
		 **/
		
		function get_insert_id()
		{
			return $GLOBALS['TYPO3_DB']->sql_insert_id() ;
		
			//return @mysql_insert_id($this->m_o_database->get_connection());
		}
		
		/**
		 * return affected rows
		 * @return integer
		 * @access public
		 **/
		
		function get_affected_rows()
		{
			return $GLOBALS['TYPO3_DB']->sql_affected_rows() ;
		
			//return @mysql_affected_rows($this->m_o_database->get_connection()) ;
		}

		/**
		 * return field count
		 * @return integer
		 * @access public
		 **/
		
		function get_field_count()
		{
			return @mysql_num_fields($this->m_i_stmt);
		}
		
		/**
		 * return field type
		 * @param position integer
		 * @return string
		 * @access public
		 **/
		
		function get_field_type($i_position)
		{
			return @mysql_field_type($this->m_i_stmt, $i_position);
		}
		
		/**
		 * return field name
		 * @param position integer
		 * @return string
		 * @access public
		 **/
		
		function get_field_name($i_position)
		{
			return strtolower(@mysql_field_name($this->m_i_stmt, $i_position));
		}
		
		/**
		 * return field length
		 * @param position integer
		 * @return string
		 * @access public
		 **/
		
		function get_field_length($i_position)
		{
			return @mysql_field_len($this->m_i_stmt, $i_position);
		}
		
		/**
		 * execute query
		 * @return boolean
		 * @access public
		 **/
		
		function execute()
		{
			if (isset($this->m_i_limit))
			{
				$this->add_sql(' LIMIT ' . $this->m_i_start . ', ' . $this->m_i_limit);
			}
			
			$s_sql = $this->get_merged_sql();
			
			//if ($this->m_i_stmt = @mysql_query($s_sql, $this->m_o_database->get_connection()))
			if ($this->m_i_stmt = $GLOBALS['TYPO3_DB']->sql_query($s_sql))
			{
				if (preg_match('^SELECT', $s_sql))
				{
					$this->m_i_row_count = $GLOBALS['TYPO3_DB']->sql_num_rows($this->m_i_stmt) ;
				}

				return true;
			}
			else
			{				
				return false ;
			}
		}
		
		/**
		 * fetch result into an associate array
		 * @return array
		 * @access public
		 **/

		function fetch()
		{
			$a_result = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($this->m_i_stmt);
		
			//$a_result = @mysql_fetch_array($this->m_i_stmt, MYSQL_ASSOC) ;
			
			if (is_array($a_result))
			{
				$a_result = array_change_key_case($a_result, CASE_LOWER);    
			}
			
			return $a_result ;
		}
		
		/**
		 * free
		 * @access public
		 **/

		function free()
		{
			$GLOBALS['TYPO3_DB']->sql_free_result($this->m_i_stmt) ;
		
			//@mysql_free_result($this->m_i_stmt);
		}
	}
?>
