<?php
	require_once 'db_table.class.php';
	require_once 'db_field_mysql.class.php';
	require_once 'db_query_mysql.class.php';

	class DB_TABLE_MYSQL extends DB_TABLE
	{
		/**
		 * constructor
		 * @access public
		 **/
	
		function DB_TABLE_MYSQL()
		{
			DB_TABLE::DB_TABLE();
		}

		/**
		 * create table
		 * @return boolean
		 * @access public
		 **/
		
		function create()
		{
			if (parent::create())
			{
			    if (is_array($this->m_a_field))
				{
			    	foreach($this->m_a_field as $o_field)
					{
						if (strtolower(get_parent_class($o_field)) == 'db_field')
						{
					    	if ($o_field->get_auto_increment())
							{
						    	$o_query = $this->m_o_database->new_query() ;
						
								$o_query->add_sql('ALTER TABLE ' . strtoupper($this->m_s_name)) ;
								$o_query->add_sql('CHANGE ' . $o_field->get_name() . ' ' . $o_field->get_sql() . ' AUTO_INCREMENT') ;
							
								if (!$o_query->execute())
								{
									return false ;
								}			
							}
						}			
					}
					
					return true ;
				}
			} 
		
			return false ;
		}
		
		/**
		 * new field
		 * @return	DB_FIELD_MYSQL
		 * @access	public
		 **/
		
		function new_field()
		{
			$o_field = new DB_FIELD_MYSQL() ;
			
			$o_field->set_table($this) ;
		
			return $o_field ;
		}
		
		/**
		 * new constraint
		 * @return	DB_CONSTRAINT_MYSQL
		 * @access	public
		 **/
		
		function new_constraint()
		{
			$o_constraint = new DB_CONSTRAINT_MYSQL() ;
			
			$o_constraint->set_table($this) ;
		
			return $o_constraint ;
		}
		
		/**
		 * optimize table
		 * @access public
		 **/
				
		function optimize()
		{
			$o_query = $this->m_o_database->new_query() ;
		
			$o_query->add_sql('OPTIMIZE TABLE ' . strtoupper($this->m_s_name)) ;
			
			return $o_query->execute() ;
		}
	}
?>
