<?php
	require_once 'html_object.class.php' ;

	class HTML_CELL extends HTML_OBJECT
	{
		/**
		 * object
		 * @var HTML_OBJECT
		 * @access protected
		 **/
	
		var $m_o_object ;
	
		/**
		 * cell text
		 * @var string
		 * @access protected
		 **/
	
		var $m_s_text ;
	
		function HTML_CELL()
		{
			HTML_OBJECT::HTML_OBJECT() ;
		
			$this->set_text('&nbsp;');
		}
		
		/**
		 * get accessor for variable m_i_width
		 * @return integer
		 * @access public
		 **/
		
		function get_width()
		{		
			return $this->m_a_attribute['width'] ;
		}
		
		function set_width($i_width)
		{
			if (is_numeric($i_width))
			{
				$this->m_a_attribute['width'] = $i_width ;
			}
		}
		
		/**
		 * get accessor for variable m_i_height
		 * @return integer
		 * @access public
		 **/
		
		function get_height()
		{
			return $this->m_a_attribute['height'] ;
		}
		
		function set_height($i_height)
		{
			if (is_numeric($i_height))
			{
				$this->m_a_attribute['height'] = $i_height ;
			}
		}
		
		function get_text()
		{
			return $this->m_s_text ;
		}
		
		function get_object()
		{
			return $this->m_o_object ;
		}
		
		function get_colspan()
		{
			return $this->m_a_attribute['colspan'] ;
		}
		
		function set_text($s_text)
		{
			$this->m_s_text = $s_text ;
		}
		
		function set_object($o_object)
		{		
			$this->m_o_object = $o_object ;
		}
		
		function set_colspan($i_colspan)
		{
			$this->m_a_attribute['colspan'] = $i_colspan ;
		}
		
		function generate()
		{		
			$s_html = '<td ' . $this->generate_attribute() . '>';
			
			if (isset($this->m_o_object))
			{
				if (method_exists($this->m_o_object, 'generate'))
				{
				    $s_html .= $this->m_o_object->generate() ;
				}
			}
			else
				if (empty($this->m_s_text))
				{
					$s_html .= '&nbsp;';
				}
				else
				{
					$s_html .= '' . $this->m_s_text ;
				}
			
			$s_html .= '</td>';
			
			return $s_html ;
		}
	}