<?php
	// +----------------------------------------------------------------------+
	// | PHP OBJECT MANAGER FRAMEWORK                                         |
	// | @copyright	(c) 2004-2005                                             |
	// | @license http://phpobjectmanager.online.fr                           |
	// +----------------------------------------------------------------------+
	// | @author Julian ROBLIN, Christophe LEFORT                             |
	// | @version 1.0                                                         |
	// +----------------------------------------------------------------------+

	require_once 'html_object.class.php';
	require_once 'html_select.class.php';
	require_once 'date_time.class.php';
	
	class HTML_DATE extends HTML_OBJECT
	{
		/**
		 * select day
		 * @var		HTML_CELL
		 * @access	protected
		 **/
		
		protected $m_o_select_day ;
		
		/**
		 * select month
		 * @var		HTML_CELL
		 * @access	protected
		 **/
		
		protected $m_o_select_month ;
	
		/**
		 * select year
		 * @var		HTML_CELL
		 * @access	protected
		 **/
		
		protected $m_o_select_year ;
	
		/**
		 * start year
		 * @var integer
		 * @access protected
		 **/
		 
		protected $m_i_start_year ;
		 
		/**
		 * end year
		 * @var integer
		 * @access protected
		 **/
		 
		protected $m_i_end_year ;
		 
		/**
		 * step year
		 * @var integer
		 * @access protected
		 **/
		 
		protected $m_i_step_year ;
		
		/**
		 * start month
		 * @var integer
		 * @access protected
		 **/
		 
		protected $m_i_start_month ;
		 
		/**
		 * end month
		 * @var integer
		 * @access protected
		 **/
		 
		protected $m_i_end_month ;
		 
		/**
		 * step month
		 * @var integer
		 * @access protected
		 **/
		 
		protected $m_i_step_month ;
	
		/**
		 * start day
		 * @var integer
		 * @access protected
		 **/
		 
		protected $m_i_start_day ;
		 
		/**
		 * end day
		 * @var integer
		 * @access protected
		 **/
		 
		protected $m_i_end_day ;
		 
		/**
		 * step day
		 * @var integer
		 * @access protected
		 **/
		 
		protected $m_i_step_day ;
	
		/**
		 * constructor
		 * @access	public
		 **/
	
		function __construct()
		{
			parent::__construct() ;
			
			$this->set_select_day(new HTML_SELECT());
			$this->set_select_month(new HTML_SELECT());
			$this->set_select_year(new HTML_SELECT());
			
			$this->set_date(new DATE_TIME());
			
			$this->set_start_day(1) ;
			$this->set_end_day(31);
			$this->set_start_month(1);
			$this->set_end_month(12);
			$this->set_start_year($a_date["year"]-20) ;
			$this->set_end_year($a_date["year"]+20) ;
			
			$this->get_select_day()->set_selected_value($this->m_o_date->get_day());
			$this->get_select_month()->set_selected_value($this->m_o_date->get_month() ;
			$this->get_select_year()->set_selected_value($this->m_o_date->get_year()) ;
		}
		
		/**
		 * destructor
		 * @access	public
		 **/
		
		function __destruct()
		{
			parent::__destruct() ;
		}
		
		function get_select_day()
		{
			return $this->m_o_select_day ;
		}
		
		function set_select_day($o_select_day)
		{
			if ($o_select_day instanceof HTML_SELECT)
			{
				$this->m_o_select_day = $o_select_day ;
			}
		}
		
		function get_select_month()
		{
			return $this->m_o_select_month ;
		}
		
		function set_select_month($o_select_month)
		{
			if ($o_select_month instanceof HTML_SELECT)
			{
				$this->m_o_select_month = $o_select_month ;
			}
		}
		
		function get_select_year()
		{
			return $this->m_o_select_year ;
		}
		
		function set_select_year($o_select_year)
		{
			if ($o_select_year instanceof HTML_SELECT)
			{
				$this->m_o_select_year = $o_select_year ;
			}
		}
		
		function get_date() { return $this->m_o_date ; }
		
		/**
		 * set accessor for variable m_o_date
		 * @param	$o_date	DATE_TIME	
		 * @access 	public
		 **/
		
		function set_date($o_date)
		{
			if ($o_date instanceof DATE_TIME)
			{
			    $this->m_o_date = $o_date ;
			}	
		}
		
		/**
		 * get accessor for variable m_i_start_day
		 * @return integer
		 * @access public
		 **/

		public function get_start_day()
		{
			return $this->m_i_start_day ;
		}

		/**
		 * set accessor for variable m_i_start_day
		 * @param integer $i_start_day
		 * @access public
		 **/

		public function set_start_day($i_start_day)
		{
			if (is_numeric($i_start_day) && ($i_start_day >= 1))
				$this->m_i_start_day = $i_start_day ;
		}

		/**
		 * get accessor for variable m_i_end_day
		 * @return integer
		 * @access public
		 **/

		public function get_end_day()
		{
			return $this->m_i_end_day ;
		}

		/**
		 * set accessor for variable m_i_end_day
		 * @param integer $i_end_day
		 * @access public
		 **/

		public function set_end_day($i_end_day)
		{
			if (is_numeric($i_end_day) && ($i_end_day <= 31))
				$this->m_i_end_day = $i_end_day ;
		}

		/**
		 * get accessor for variable m_i_start_month
		 * @return integer
		 * @access public
		 **/

		public function get_start_month()
		{
			return $this->m_i_start_month ;
		}

		/**
		 * set accessor for variable m_i_start_month
		 * @param integer $i_start_month
		 * @access public
		 **/

		public function set_start_month($i_start_month)
		{
			if (is_numeric($i_start_month))
				$this->m_i_start_month = $i_start_month ;
		}

		/**
		 * get accessor for variable m_i_end_month
		 * @return integer
		 * @access public
		 **/

		public function get_end_month()
		{
			return $this->m_i_end_month ;
		}

		/**
		 * set accessor for variable m_i_end_month
		 * @param integer $i_end_month
		 * @access public
		 **/

		public function set_end_month($i_end_month)
		{
			if (is_numeric($i_end_month))
				$this->m_i_end_month = $i_end_month ;
		}

		/**
		 * get accessor for variable m_i_start_year
		 * @return integer
		 * @access public
		 **/

		public function get_start_year()
		{
			return $this->m_i_start_year ;
		}

		/**
		 * set accessor for variable m_i_start_year
		 * @param integer $i_start_year
		 * @access public
		 **/

		public function set_start_year($i_start_year)
		{
			if (is_numeric($i_start_year))
				$this->m_i_start_year = $i_start_year ;
		}

		/**
		 * get accessor for variable m_i_end_year
		 * @return integer
		 * @access public
		 **/

		public function get_end_year()
		{
			return $this->m_i_end_year ;
		}

		/**
		 * set accessor for variable m_i_end_year
		 * @param integer $i_end_year
		 * @access public
		 **/

		public function set_end_year($i_end_year)
		{
			if (is_numeric($i_end_year))
				$this->m_i_end_year = $i_end_year ;
		}
		
		public function get_day_name()
		{
			return $this->get_select_day()->get_name() ;
		}
		
		public function set_day_name($s_day_name)
		{
			$this->get_select_day()->set_name($s_day_name);
		}
		
		public function get_day_value()
		{
			return $this->get_select_day()->get_selected_value() ;
		}
		
		public function set_day_value($s_day_value)
		{
			$this->get_select_day()->set_value($s_day_value);
		}
		
		public function get_month_name()
		{
			return $this->get_select_month()->get_name() ;
		}
		
		public function set_month_name($s_month_name)
		{
			$this->get_select_month()->set_name($s_month_name);
		}
		
		public function get_month_value()
		{
			return $this->get_select_month()->get_selected_value() ;
		}
		
		public function set_month_value($s_month_value)
		{
			$this->get_select_month()->set_value($s_month_value);
		}
		
		public function get_year_name()
		{
			return $this->get_select_year()->get_name() ;
		}
		
		public function set_year_name($s_year_name)
		{
			$this->get_select_year()->set_name($s_year_name);
		}
		
		public function get_year_value()
		{
			return $this->get_select_year()->get_selected_value() ;
		}
		
		public function set_year_value($s_year_value)
		{
			$this->get_select_year()->set_value($s_year_value);
		}
		
		/**
		 * add attribute
		 * @param string $s_name
		 * @param string $s_value
		 * @access public
		 **/
		
		public function add_attribute($s_name, $s_value)
		{
			$this->get_select_day()->add_attribute($s_name,$s_value);
			$this->get_select_month()->add_attribute($s_name,$s_value);
			$this->get_select_year()->add_attribute($s_name,$s_value);		
		}
		
		public function set_value($u_value)
		{
		
		}
		
		public function process()
		{
			return true ;
		}
		
		function generate()
		{
			for ($i_day = $this->get_start_day() ; $i_day < $this->get_end_day() ; $i_day++)
			{
				$i_select_day = sprintf("%02d", $i_day) ;
			
				$a_day[$i_select_day] = $i_select_day ;
			}
			
			for ($i_month = $this->get_start_month() ; $i_month < $this->get_end_month() ; $i_month++)
			{
				$i_select_month = sprintf("%02d", $i_month) ;
			
				$a_month[$i_select_month] = $i_select_month ;	
			}
			
			for ($i_year = $this->get_start_year() ; $i_year < $this->get_end_year() ; $i_year++)
			{
				$i_select_year = sprintf("%02d", $i_year) ;
				
				$a_year[$i_select_year] = $i_select_year ;	
			}
			
			$this->get_select_day()->set_value($a_day) ;
			$this->get_select_month()->set_value($a_month) ;
			$this->get_select_year()->set_value($a_year) ;
		
			$s_html	=	$this->get_select_day()->generate()
					.	'&nbsp;'
					.	$this->get_select_month()->generate()
					.	'&nbsp;'
					.	$this->get_select_year()->generate() ;
			
			return $s_html ;
		}
	}
?>
