<?php

	require_once 'html_object.class.php' ;
	require_once 'html_cell.class.php' ;
	
	/**
	 * HTML_FIELD
	 * 
	 * @package HTML
	 * @author Julian ROBLIN
	 * @copyright copyright (c) 2005
	 * @version 1.0
	 * @access public
	 **/

	class HTML_FIELD extends HTML_OBJECT
	{
		/**
		 * html form
		 * @var HTML_FORM
		 * @access protected
		 **/

		var $m_o_form ;
		
		/**
		 * text cell
		 * @var HTML_CELL
		 * @access protected
		 **/

		var $m_o_text_cell ;
		
		/**
		 * html_object cell
		 * @var HTML_CELL
		 * @access protected
		 **/

		var $m_o_html_object_cell ;
	
		/**
		 * text position
		 * @var integer
		 * @access protected
		 **/

		var $m_i_position ;
		
		/**
		 * text help
		 * @var string
		 * @access protected
		 **/
		 
		 var $m_s_help ;
		 
		 /**
		  * rule array
		  * @var array
		  * @access protected
		  **/
		 
		 var $m_a_rule ;

		/**
		 * constructor
		 * @access public
		 **/

		function HTML_FIELD()
		{
			HTML_OBJECT::HTML_OBJECT() ;
			
			$this->set_text_cell(new HTML_CELL());
			$this->set_html_object_cell(new HTML_CELL());
			$this->set_rule(array());
		}
		
		/**
		 * get acessor for variable m_o_form
		 * @return HTML_FORM
		 * @access public
		 **/

		function get_form()
		{
			return $this->m_o_form ;
		}

		/**
		 * set acessor for variable m_o_form
		 * @param HTML_FORM $o_form
		 * @access public
		 **/

		function set_form($o_form)
		{
				$this->m_o_form = $o_form ;
			
		}
		
		/**
		 * get acessor for variable m_o_text_cell
		 * @return HTML_CELL
		 * @access public
		 **/

		function get_text_cell()
		{
			return $this->m_o_text_cell ;
		}

		/**
		 * set acessor for variable m_o_text_cell
		 * @param HTML_CELL $o_text_cell
		 * @access public
		 **/

		function set_text_cell($o_text_cell)
		{
				$this->m_o_text_cell = $o_text_cell ;
		}
		
		/**
		 * get acessor for variable m_o_html_object
		 * @return HTML_CELL
		 * @access public
		 **/

		function get_html_object_cell()
		{
			return $this->m_o_html_object_cell ;
		}

		/**
		 * set acessor for variable m_o_html_object_cell
		 * @param HTML_CELL $o_html_object_cell
		 * @access public
		 **/

		function set_html_object_cell($o_html_object_cell)
		{		

				$this->m_o_html_object_cell = $o_html_object_cell ;
		}
		
		/**
		 * get acessor for variable m_o_html_object
		 * @return HTML_OBJECT
		 * @access public
		 **/

		function get_html_object()
		{
			return $this->m_o_html_object_cell->get_object() ;
		}

		/**
		 * set acessor for variable m_o_html_object
		 * @param integer $o_html_object
		 * @access public
		 **/

		function set_html_object($o_html_object)
		{		
			$this->m_o_html_object_cell->set_object($o_html_object) ;
		}

		/**
		 * get acessor for variable m_i_position
		 * @return integer
		 * @access public
		 **/

		function get_position()
		{
			return $this->m_i_position ;
		}

		/**
		 * set acessor for variable m_i_position
		 * @param integer $i_position
		 * @access public
		 **/

		function set_position($i_position)
		{
			if (is_numeric($i_position))
				$this->m_i_position = $i_position ;
		}
		
		/**
		 * get acessor for variable m_s_help
		 * @return string
		 * @access public
		 **/

		function get_help()
		{
			return $this->m_s_help ;
		}

		/**
		 * set acessor for variable m_s_help
		 * @param string $s_help
		 * @access public
		 **/

		function set_help($s_help)
		{
			if (is_string($s_help))
			{
				$this->m_s_help = $s_help ;
				
				$o_html_object = $this->get_html_object() ;
				
				if (isset($o_html_object))
				{
					$s_help = $this->get_help() ;
				
					if (isset($s_help))
					{
						$o_form = $this->get_form() ;
					
						$o_html_object->add_attribute('onFocus', 'javascript:show(\'' . $o_form->get_name() . '_help\', \'' . htmlentities($s_help) . '\');');
					}
				}
			}
		}
		
		/**
		 * get acessor for variable m_a_rule
		 * @return array
		 * @access public
		 **/

		function get_rule()
		{
			return $this->m_a_rule ;
		}

		/**
		 * set acessor for variable m_a_rule
		 * @param array $a_rule
		 * @access public
		 **/

		function set_rule($a_rule)
		{
			if (is_array($a_rule))
				$this->m_a_rule = $a_rule ;
		}
		
		/**
		 * add input
		 * @param	string	$s_field_name
		 * @param	string	$s_input_name
		 * @param	string	$s_input_type
		 * @param	string	$s_input_value
		 * @access public
		 **/
		
		function add_input($s_input_name, $s_input_type, $s_input_value=NULL)
		{
			require_once 'html_input.class.php';
		
			$o_input = new HTML_INPUT() ;
			
			$o_input->set_name($s_input_name);			
			$o_input->set_type($s_input_type);
			$o_input->set_value($s_input_value);
			
			$this->set_html_object($o_input);
			
			return $o_input ;
		}
		
		/**
		 * add textarea
		 * @param string $s_field_name
		 * @param string $s_text_area_name
		 * @param string $s_text_area_value
		 * @access public
		 **/
		
		function add_text_area($s_text_area_name, $b_rich_text=false, $s_text_area_value=NULL)
		{
			require_once 'html_text_area.class.php';
			
			$o_text_area = new HTML_TEXT_AREA();
			
			$o_text_area->set_name($s_text_area_name);
			$o_text_area->set_value($s_text_area_value);
			$o_text_area->set_rich_text($b_rich_text) ;
			
			$this->set_html_object($o_text_area);
			
			return $o_text_area ;
		}
		
		/**
		 * add select
		 * @param	string	$s_field_name
		 * @param	string	$s_select_name
		 * @param	array	$a__value
		 * @param	string	$s_selected_value
		 * @access	public
		 **/
		
		function add_select($s_select_name, $a_value=null, $s_selected_value=null)
		{
			require_once 'html_select.class.php';
			
			$o_select = new HTML_SELECT() ;
			
			$o_select->set_name($s_select_name) ;
			$o_select->set_value($a_value) ;
			$o_select->set_selected_value($s_selected_value) ;
			
			return $o_select ;
		}
		
		/**
		 * add checkbox
		 * @param	string	$s_field_name
		 * @param	string	$s_check_box_name
		 * @param	string	$s_text
		 * @param	boolean	$s_check_box_value
		 * @access	public
		 **/
		
		function add_check_box($s_check_box_name, $s_text, $s_check_box_value=false)
		{
			require_once 'html_check_box.class.php';
			
			$o_check_box = new HTML_CHECK_BOX() ;
			
			$o_check_box->set_name($s_check_box_name) ;
			$o_check_box->set_value($s_check_box_value) ;
			$o_check_box->set_text($s_text) ;

			return $o_check_box ;
		}
		
		/**
		 * add date
		 * @param	string	$s_field_name
		 * @param	string	$s_day_name
		 * @param	string	$s_month_name
		 * @param	string	$s_year_name
		 * @param	string	$s_day_value
		 * @param	string	$s_month_value
		 * @param	string	$s_year_value
		 * @access	public
		 **/
		
		function add_date($s_day_name, $s_month_name, $s_year_name, $s_day_value=null, $s_month_value=null, $s_year_value=null)
		{
			require_once 'html_date.class.php';
		
			$i_position = $this->add_field($s_field_name) ;
			
			$this->m_a_field[$i_position]->set_name($s_field_name) ;
			
			$o_html_date = new HTML_DATE() ;
			
			$o_html_date->set_day_name($s_day_name) ;
			$o_html_date->set_month_name($s_month_name) ;
			$o_html_date->set_year_name($s_year_name) ;
			$o_html_date->set_day_value($s_day_value) ;
			$o_html_date->set_month_value($s_month_value) ;
			$o_html_date->set_year_value($s_year_value) ;

			return $o_html_date ;
		}
		
		/**
		 * add time
		 * @param	string	$s_field_name
		 * @param	string	$s_hour_name
		 * @param	string	$s_minute_name
		 * @param	string	$s_second_name
		 * @param	string	$s_hour_value
		 * @param	string	$s_minute_value
		 * @param	string	$s_second_value
		 * @access	public
		 **/
		
		function add_time($s_hour_name=null, $s_minute_name=null, $s_second_name=null, $s_hour_value=null, $s_minute_value=null, $s_second_value=null)
		{
			require_once 'html_time.class.php';
			
			$o_html_time = new HTML_TIME() ;
			
			$o_html_time->set_hour_name($s_hour_name) ;
			$o_html_time->set_minute_name($s_minute_name) ;
			$o_html_time->set_second_name($s_second_name) ;
			$o_html_time->set_hour_value($s_hour_value) ;
			$o_html_time->set_minute_value($s_minute_value) ;
			$o_html_time->set_second_value($s_second_value) ;

			return $o_html_time ;
		}
		
		/**
		 * add file
		 * @param	string	$s_field_name
		 * @param	string	$s_file_name
		 * @access	public
		 **/
		
		function add_file($o_field, $s_file_name, $s_file_destination_path=null, $s_file_destination_name=null)
		{
			require_once 'html_file.class.php';
		
			$o_html_file = new HTML_FILE() ;
			
			$o_html_file->set_name($s_file_name) ;
			$o_html_file->set_file_destination_path($s_file_destination_path) ;
			$o_html_file->set_file_destination_name($s_file_destination_name) ;
			
			if (get_class($this->m_o_form) == 'html_form')
			{
			    $this->m_o_form->set_enctype('multipart/form-data') ;
			}
			
			return $o_html_file ;
		}

		
		function add_rule($s_type, $s_message, $a_option=null)
		{
			require_once 'html_rule.class.php' ;
		
			$o_rule = new HTML_RULE() ;
			
			$o_rule->set_field($this) ;
			$o_rule->set_type($s_type) ;
			$o_rule->set_message($s_message) ;
			$o_rule->set_option($a_option) ;
			
			array_push($this->m_a_rule, $o_rule) ;
		}
		
		function validate()
		{		
			foreach($this->m_a_rule as $o_rule)
			{			
				if (!$o_rule->validate())
				{				
					$this->m_o_form->set_message($o_rule->get_message()) ;
					
					return false ;
				}
			}
			
			return true ;
		}
		
		/**
		 * default process
		 * @return boolean
		 * @access public
		 **/
		
		function process()
		{
			$o_html_object = $this->get_html_object() ;
		
			return $o_html_object->process() ;
		}
		
		/**
		 * generate
		 * @return string
		 * @access public
		 **/

		function generate()
		{				
			if (isset($this->m_o_text_cell))
			{			
			    $this->m_o_text_cell->set_text($this->get_name()) ;
				
				$s_html	=	'<tr>'
						.	$this->m_o_text_cell->generate()
						.	$this->m_o_html_object_cell->generate()
						.	'</tr>';
			}
			else
			{
				$this->m_o_html_object_cell->set_colspan(2) ;
			
				$s_html	=	'<tr>'
						.	$this->m_o_html_object_cell->generate()
						.	'</tr>' ;
			}
					
			return $s_html ;		
		}
	}
?>