<?php
	// +----------------------------------------------------------------------+
	// | @copyright                                                           |
	// | @license http://phpobjectmanager.online.fr                           |
	// +----------------------------------------------------------------------+
	// | @author Julian ROBLIN, Christophe LEFORT                             |
	// | @version 1.0                                                         |
	// +----------------------------------------------------------------------+

	require_once 'html_object.class.php' ;
	
	/**
	 * HTML_FILE
	 * 
	 * @package HTML
	 * @author Julian ROBLIN
	 * @copyright copyright (c) 2005
	 * @version 1.0
	 * @access public
	 **/

	class HTML_FILE extends HTML_OBJECT
	{
		/**
		 * input hidden
		 * @var HTML_INPUT
		 * @access protected
		 **/

		var $m_o_html_input_hidden ;
		
		/**
		 * input file
		 * @var HTML_INPUT
		 * @access protected
		 **/

		var $m_o_html_input_file ;
		
		/**
		 * file destination path
		 * @var string
		 * @access protected
		 **/		
		
		var $m_s_file_destination_path ;
		
		/**
		 * file name
		 * @var string
		 * @access protected
		 **/		
		
		var $m_s_file_destination_name ;
	
		/**
		 * constructor
		 * @access public
		 **/

		function HTML_FILE()
		{
			HTML_OBJECT::HTML_OBJECT() ;
			
			$this->m_o_html_input_hidden = new HTML_INPUT() ;
			
			$this->m_o_html_input_hidden->set_type('hidden');
			$this->m_o_html_input_hidden->set_name('MAX_FILE_SIZE');
			$this->m_o_html_input_hidden->set_value(10000000);
			
			$this->m_o_html_input_file = new HTML_INPUT() ;
			
			$this->m_o_html_input_file->set_type('file');
			
			$this->m_a_file_type = array() ;
		}

		/**
		 * destructor
		 * @access public
		 **/

		function __destruct()
		{
			parent::__destruct() ;
		}
		
		/**
		 * get accessor for variable m_o_html_input_hidden
		 * @return HTML_INPUT
		 * @access public
		 **/

		function get_html_input_hidden()
		{
			return $this->m_o_html_input_hidden ;
		}

		/**
		 * set accessor for variable m_o_html_input_hidden
		 * @param HTML_INPUT $o_html_input_hidden
		 * @access public
		 **/

		function set_html_input_hidden($o_html_input_hidden)
		{
			$this->m_o_html_input_hidden = $o_html_input_hidden ;
			
		}
		
		/**
		 * get accessor for variable m_o_html_input_file
		 * @return HTML_INPUT
		 * @access public
		 **/

		function get_html_input_file()
		{
			return $this->m_o_html_input_file ;
		}

		/**
		 * set accessor for variable m_o_html_input_file
		 * @param HTML_INPUT $o_html_input_file
		 * @access public
		 **/

		function set_html_input_file($o_html_input_file)
		{

				$this->m_o_html_input_file = $o_html_input_file ;
			
		}

		/**
		 * get accessor for variable m_i_max_file_size
		 * @return integer
		 * @access public
		 **/

		function get_max_file_size()
		{
			return $this->m_o_html_input_hidden->get_value() ;
		}
		
		/**
		 * get accessor for file name
		 * @return	string
		 * @access	public
		 **/
		
		function get_name()
		{
			return $this->m_o_html_input_file->get_name() ;
		}
		
		function set_name($s_name)
		{	
			$this->m_o_html_input_file->set_name($s_name) ;
		}
		
		function get_class()
		{
			return $this->m_o_html_input_file->get_class() ;
		}
		
		function set_class($s_class)
		{
			$this->m_o_html_input_file->set_class($s_class) ;
		}
		
		function get_style()
		{
			return $this->m_o_html_input_file->get_class() ;
		}
		
		function set_style($s_style)
		{
			$this->m_o_html_input_file->set_style($s_style) ;
		}
		
		function get_help()
		{
			return $this->m_o_html_input_file->get_class() ;
		}
		
		function add_attribute($s_name, $s_value)
		{		
			$this->m_o_html_input_file->add_attribute($s_name, $s_value) ;
		}

		/**
		 * set accessor for variable m_i_max_file_size
		 * @param integer $i_max_file_size
		 * @access public
		 **/

		function set_max_file_size($i_max_file_size)
		{
			echo gettype($this->m_o_html_input_hidden) ;
		
		/*
			if (is_numeric($i_max_file_size))
				$this->get_html_input_hidden()->set_value($i_max_file_size) ;
			*/
		}
		
		function get_value()
		{
			return $this->m_o_html_input_file->get_value() ;
		}
		
		function set_value($u_value)
		{
			echo $u_value ;
		
			$this->m_o_html_input_file->set_value($u_value) ;
		}
		
		/**
		 * get acessor for variable m_s_file_destination_path
		 * @return	string
		 * @access	public
		 **/
		
		function get_file_destination_path()
		{
			return $this->m_s_file_destination_path ;
		}
		
		/**
		 * set acessor for variable m_s_file_destination_path
		 * @param string $s_file_destination_path
		 * @access public
		 **/
		
		function set_file_destination_path($s_file_destination_path)
		{
			if (is_string($s_file_destination_path))
			{
				$this->m_s_file_destination_path = $s_file_destination_path ;
			}
		}
		
		/**
		 * get acessor for variable m_s_file_destination_name
		 * @return	string
		 * @access	public
		 **/
		
		function get_file_destination_name()
		{
			return $this->m_s_file_destination_name ;
		}
		
		/**
		 * set acessor for variable m_s_file_destination_name
		 * @param string $s_file_destination_name
		 * @access public
		 **/
		
		function set_file_destination_name($s_file_destination_name)
		{
			if (is_string($s_file_destination_name))
			{
				$this->m_s_file_destination_name = $s_file_destination_name ;
			}
		}
		
		/**
		 * process upload
		 * @access public
		 **/
		
		function process()
		{
			$b_process = false ;
		
			if ($u_error = $_FILES[$this->get_name()]['error'])
			{
				switch($u_error)
				{
					case UPLOAD_ERR_INI_SIZE:
					{
						echo 'fichier trop gros PHP' ;
					
						break;
					}
					case UPLOAD_ERR_FORM_SIZE:
					{
						echo 'fichier trop gros FORM' ;
					
						break;
					}
					case UPLOAD_ERR_PARTIAL:
					{
						echo 'fichier charg partiellement' ;
					
						break ;
					}
					case UPLOAD_ERR_NO_FILE:
					{
						$b_process = true ;
						
						break ;
					}
					default:
					{
						break;
					}
				}
			}
			else
			{
				$o_file = new FILE() ;
					
				if (isset($this->m_s_file_destination_name))
				{
				    $o_file->set_name($this->m_s_file_destination_name);
				}
				else
				{
					$o_file->set_name($_FILES[$this->get_name()]['name']);
				}
					
				$o_file->set_path($this->m_s_file_destination_path);
					
				$b_process = $o_file->upload($_FILES[$this->get_name()]['tmp_name']) ;
			}
			
			return $b_process ;
		}
		
		/**
		 * generate html
		 * @return string
		 * @access public
		 **/

		function generate()
		{	
			$s_html = $this->m_o_html_input_hidden->generate() . $this->m_o_html_input_file->generate() ;
			
			return $s_html ;
		}
	}
?>