<?php

	require_once 'html_object.class.php';
	require_once 'html_field.class.php';
	require_once 'html_cell.class.php';
	
	/**
	 * HTML_FORM
	 * 
	 * @package HTML
	 * @author Julian ROBLIN
	 * @copyright copyright (c) 2005
	 * @version 1.0
	 * @access public
	 **/
	
	class HTML_FORM extends HTML_OBJECT
	{
		/**
		 * field
		 * @var array
		 * @access protected
		 **/
		 
		var $m_a_field ;
	
		/**
		 * form cell
		 * @var HTML_CELL
		 * @access protected
		 **/
	
		var $m_o_form_cell ;
	
		/**
		 * help cell
		 * @var HTML_CELL
		 * @access protected
		 **/
		
		var $m_o_help_cell ;
		
		/**
		 * header cell
		 * @var HTML_CELL
		 * @access protected
		 **/
		
		var $m_o_header_cell ;
		
		/**
		 * button array
		 * @var array
		 * @access protected
		 **/
		
		var $m_a_button ;
		
		/**
		 * message
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_message ;
		
		/**
		 * process message
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_process_message ;
		
		/**
		 * text width
		 * @var integer
		 * @access protected
		 **/
		 
		var $m_i_text_width ;
		
		/**
		 * text even class
		 * @var string
		 * @access protected
		 **/
		 
		var $m_s_text_even_class ;
		
		/**
		 * text uneven class
		 * @var string
		 * @access protected
		 **/
		 
		var $m_s_text_uneven_class ;
		
		/**
		 * text even style
		 * @var string
		 * @access protected
		 **/
		 
		var $m_s_text_even_style ;
		
		/**
		 * text uneven style
		 * @var string
		 * @access protected
		 **/
		 
		var $m_s_text_uneven_style ;
		
		/**
		 * field width
		 * @var integer
		 * @access protected
		 **/
		 
		var $m_i_field_width ;
		
		/**
		 * field even class
		 * @var string
		 * @access protected
		 **/
		 
		var $m_s_field_even_class ;
		
		/**
		 * field uneven class
		 * @var string
		 * @access protected
		 **/
		 
		var $m_s_field_uneven_class ;
		
		/**
		 * field even style
		 * @var string
		 * @access protected
		 **/
		 
		var $m_s_field_even_style ;
		
		/**
		 * field uneven style
		 * @var string
		 * @access protected
		 **/
		 
		var $m_s_field_uneven_style ;
		
		/**
		 * row height
		 * @var integer
		 * @access protected
		 **/
		 
		var $m_i_row_height ;
		
		/**
		 * row even class
		 * @var string
		 * @access protected
		 **/
		 
		var $m_s_row_even_class ;
		
		/**
		 * row uneven class
		 * @var string
		 * @access protected
		 **/
		 
		var $m_s_row_uneven_class ;
		
		/**
		 * row even style
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_row_even_style ;
		
		/**
		 * row even style
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_row_uneven_style ;
		
		/*
		 * javascript code
		 * @var array
		 * @access protected
		 **/
		 
		 var $m_a_javascript ;
		 
		 /*
		 * store value on success
		 * @var array
		 * @access protected
		 **/
		 
		 var $m_b_store_value ;
	
		/**
		 * constructor
		 * @access	public
		 **/
		
		function HTML_FORM()
		{
			$this->set_method('post') ;
			$this->set_field(array());
			$this->set_button(array());
			$this->set_form_cell(new HTML_CELL);
			$this->set_store_value(true);
		}
		
		/**
		 * get acessor for variable m_a_attribute['action']
		 * @return	string
		 * @access	public
		 **/
		
		function get_action()
		{
			return $this->m_a_attribute['action'] ;
		}
		
		/**
		 * set acessor for variable m_a_attribute['action']
		 * @param	string	$s_action
		 * @access	public
		 **/
		
		function set_action($s_action)
		{
			if (is_string($s_action))
				$this->m_a_attribute['action'] = $s_action ;
		}
		
		/**
		 * get acessor for variable m_a_attribute['method']
		 * @return	string
		 * @access	public
		 **/
		
		function get_method()
		{
			return $this->m_a_attribute['method'] ;
		}
		
		/**
		 * set acessor for variable m_a_attribute['method']
		 * @param	string	$s_method
		 * @access	public
		 **/
				
		function set_method($s_method)
		{
			if (is_string($s_method))
			{
				$this->m_a_attribute['method'] = $s_method ;
			}
		}
		
		/**
		 * get acessor for variable m_s_message
		 * @return	string
		 * @access	public
		 **/
		
		function get_message()
		{
			return $this->m_s_message ;
		}
		
		/**
		 * set acessor for variable m_s_message
		 * @param	string	$s_message
		 * @access	public
		 **/
				
		function set_message($s_message)
		{		
			if (is_string($s_message))
			{
				$this->m_s_message = $s_message ;
			}
		}
		
		/**
		 * get acessor for variable m_s_process_message
		 * @return	string
		 * @access	public
		 **/
		
		function get_process_message()
		{
			return $this->m_s_process_message ;
		}
		
		/**
		 * set acessor for variable m_s_process_message
		 * @param	string	$s_process_message
		 * @access	public
		 **/
				
		function set_process_message($s_process_message)
		{		
			if (is_string($s_process_message))
			{
				$this->m_s_process_message = $s_process_message ;
			}
		}
		
		/**
		 * get acessor for variable m_a_attribute['enctype']
		 * @return	string
		 * @access	public
		 **/

		function get_enctype()
		{
			return $this->m_a_attribute['enctype'] ;
		}

		/**
		 * set accessor for variable m_a_attribute['enctype']
		 * @param string $s_enctype
		 * @access public
		 **/

		function set_enctype($s_enctype)
		{
			if (is_string($s_enctype))
				$this->m_a_attribute['enctype'] = $s_enctype ;
		}
		
		/**
		 * get acessor for variable m_o_form_cell
		 * @return	HTML_CELL
		 * @access	public
		 **/
		
		function get_form_cell()
		{
			return $this->m_o_form_cell ;
		}
		
		/**
		 * set acessor for variable m_o_form_cell
		 * @param	HTML_CELL	$o_form_cell
		 * @access	public
		 **/
				
		function set_form_cell($o_form_cell)
		{
			
			$this->m_o_form_cell = $o_form_cell ;
			
		}
		
		/**
		 * get acessor for variable m_o_help_cell
		 * @return	HTML_CELL
		 * @access	public
		 **/
		
		function get_help_cell()
		{
			return $this->m_o_help_cell ;
		}
		
		/**
		 * set acessor for variable m_o_help_cell
		 * @param	HTML_CELL	$o_help_cell
		 * @access	public
		 **/
				
		function set_help_cell($o_help_cell)
		{
			$this->m_o_help_cell = $o_help_cell ;
		}

		/**
		 * get acessor for variable m_s_help
		 * @return	boolean
		 * @access	public
		 **/

		function get_help()
		{
			if (isset($this->m_s_help))
			{
			    return $this->m_s_help ;
			}
			else
			{
				return null ;
			}
		}

		/**
		 * set acessor for variable m_s_help
		 * @param	boolean	$s_help
		 * @access	public
		 **/

		function set_help($s_help)
		{
			if (is_string($s_help))
			{
				if ($s_help)
				{
					$this->set_help_cell(new HTML_CELL());
				
					$this->m_o_help_cell->set_text('<div id="' . $this->get_name() . '_help">' . $s_help . '</div>') ;
					$this->m_o_help_cell->add_style('vertical-align:text-top;') ;
					
					$this->m_o_form_cell->add_style('vertical-align:text-top;') ;
				}
			
				$this->m_s_help = $s_help ;
			}
		}
		
		/**
		 * get acessor for variable m_i_field_width
		 * @return	integer
		 * @access	public
		 **/
		
		function get_field_width()
		{
			return $this->m_i_field_width ;
		}
		
		/**
		 * set acessor for variable m_i_field_width
		 * @param integer $i_field_width
		 * @access public
		 **/
		
		function set_field_width($i_field_width)
		{
			if (is_numeric($i_field_width))
			{
				$this->m_i_field_width = $i_field_width ;
			}
		}
		
		/**
		 * get acessor for variable m_i_text_width
		 * @return	integer
		 * @access	public
		 **/
		
		function get_text_width()
		{
			return $this->m_i_text_width ;
		}
		
		/**
		 * set acessor for variable m_i_text_width
		 * @param integer $i_text_width
		 * @access public
		 **/
		
		function set_text_width($i_text_width)
		{
			if (is_numeric($i_text_width))
			{
			    $this->m_i_text_width = $i_text_width ;
			}
		}
		
		/**
		 * get acessor for variable row_height
		 * @return	integer
		 * @access	public
		 **/
		
		function get_row_height()
		{
			return $this->m_i_row_height ;
		}
		
		/**
		 * set acessor for variable m_i_row_height
		 * @param integer $i_row_height
		 * @access public
		 **/
		
		function set_row_height($i_row_height)
		{
			if (is_numeric($i_row_height))
			{
				$this->m_i_row_height = $i_row_height ;
			}
		}
		
		/**
		 * get acessor for variable m_s_field_even_class
		 * @return	string
		 * @access	public
		 **/
		
		function get_field_even_class()
		{
			return $this->m_s_field_even_class ;
		}
		
		/**
		 * set acessor for variable m_s_field_even_class
		 * @param string $s_field_even_class
		 * @access public
		 **/
		
		function set_field_even_class($s_field_even_class)
		{
			if (is_string($s_field_even_class))
			{
				$this->m_s_field_even_class = $s_field_even_class ;
			}
		}
		
		/**
		 * get acessor for variable m_s_field_uneven_class
		 * @return	string
		 * @access	public
		 **/
		
		function get_field_uneven_class()
		{
			return $this->m_s_field_even_class ;
		}
		
		/**
		 * set acessor for variable m_s_field_uneven_class
		 * @param string $s_field_uneven_class
		 * @access public
		 **/
		
		function set_field_uneven_class($s_field_uneven_class)
		{
			if (is_string($s_field_uneven_class))
			{
				$this->m_s_field_uneven_class = $s_field_uneven_class ;
			}
		}
		
		/**
		 * get acessor for variable m_s_field_even_style
		 * @return	string
		 * @access	public
		 **/
		
		function get_field_even_style()
		{
			return $this->m_s_field_even_style ;
		}
		
		/**
		 * set acessor for variable m_s_field_even_style
		 * @param string $s_field_even_style
		 * @access public
		 **/
		
		function set_field_even_style($s_field_even_style)
		{
			if (is_string($s_field_even_style))
			{
				$this->m_s_field_even_style = $s_field_even_style ;
			}
		}
		
		/**
		 * get acessor for variable m_s_field_uneven_style
		 * @return	string
		 * @access	public
		 **/
		
		function get_field_uneven_style()
		{
			return $this->m_s_field_uneven_style ;
		}
		
		/**
		 * set acessor for variable m_s_field_uneven_style
		 * @param string $s_field_uneven_style
		 * @access public
		 **/
		
		function set_field_uneven_style($s_field_uneven_style)
		{
			if (is_string($s_field_uneven_style))
			{
				$this->m_s_field_uneven_style = $s_field_uneven_style ;
			}
		}
		
		
		/**
		 * get acessor for variable m_s_text_even_class
		 * @return	string
		 * @access	public
		 **/
		
		function get_text_even_class()
		{
			return $this->m_s_text_even_class ;
		}
		
		/**
		 * set acessor for variable m_s_text_even_class
		 * @param string $s_text_even_class
		 * @access public
		 **/
		
		function set_text_even_class($s_text_even_class)
		{
			if (is_string($s_text_even_class))
			{
				$this->m_s_text_even_class = $s_text_even_class ;
			}
		}
		
		/**
		 * get acessor for variable m_s_text_uneven_class
		 * @return	string
		 * @access	public
		 **/
		
		function get_text_uneven_class()
		{
			return $this->m_s_text_even_class ;
		}
		
		/**
		 * set acessor for variable m_s_text_uneven_class
		 * @param string $s_text_uneven_class
		 * @access public
		 **/
		
		function set_text_uneven_class($s_text_uneven_class)
		{
			if (is_string($s_text_uneven_class))
			{
				$this->m_s_text_uneven_class = $s_text_uneven_class ;
			}
		}
		
		/**
		 * get acessor for variable m_s_text_even_style
		 * @return	string
		 * @access	public
		 **/
		
		function get_text_even_style()
		{
			return $this->m_s_text_even_style ;
		}
		
		/**
		 * set acessor for variable m_s_text_even_style
		 * @param string $s_text_even_style
		 * @access public
		 **/
		
		function set_text_even_style($s_text_even_style)
		{
			if (is_string($s_text_even_style))
			{
				$this->m_s_text_even_style = $s_text_even_style ;
			}
		}
		
		/**
		 * get acessor for variable m_s_text_uneven_style
		 * @return	string
		 * @access	public
		 **/
		
		function get_text_uneven_style()
		{
			return $this->m_s_text_uneven_style ;
		}
		
		/**
		 * set acessor for variable m_s_text_uneven_style
		 * @param string $s_text_uneven_style
		 * @access public
		 **/
		
		function set_text_uneven_style($s_text_uneven_style)
		{
			if (is_string($s_text_uneven_style))
			{
				$this->m_s_text_uneven_style = $s_text_uneven_style ;
			}
		}
		
		/**
		 * get acessor for variable m_s_row_even_class
		 * @return	string
		 * @access	public
		 **/
		
		function get_row_even_class()
		{
			return $this->m_s_row_even_class ;
		}
		
		/**
		 * set acessor for variable m_s_text_even_class
		 * @param string $s_text_even_class
		 * @access public
		 **/
		
		function set_row_even_class($s_row_even_class)
		{
			if (is_string($s_row_even_class))
			{
				$this->m_s_row_even_class = $s_row_even_class ;
				
				$this->set_field_even_class($this->m_s_row_even_cmass);
				$this->set_text_even_class($this->m_s_row_even_class);
			}
		}
		
		/**
		 * get acessor for variable m_s_row_uneven_class
		 * @return	string
		 * @access	public
		 **/
		
		function get_row_uneven_class()
		{
			return $this->m_s_row_even_class ;
		}
		
		/**
		 * set acessor for variable m_s_row_uneven_class
		 * @param string $s_row_uneven_class
		 * @access public
		 **/
		
		function set_row_uneven_class($s_row_uneven_class)
		{
			if (is_string($s_row_uneven_class))
			{
				$this->m_s_row_uneven_class = $s_row_uneven_class ;
				
				$this->set_field_uneven_class($this->m_s_row_uneven_cmass);
				$this->set_text_uneven_class($this->m_s_row_uneven_class);
			}
		}
		
		/**
		 * get acessor for variable m_s_row_even_style
		 * @return	string
		 * @access	public
		 **/
		
		function get_row_even_style()
		{
			return $this->m_s_row_even_style ;
		}
		
		/**
		 * set acessor for variable m_s_row_even_style
		 * @param string $s_row_even_style
		 * @access public
		 **/
		
		function set_row_even_style($s_row_even_style)
		{
			if (is_string($s_row_even_style))
			{
				$this->m_s_row_even_style = $s_row_even_style ;
				
				$this->set_field_even_style($this->m_s_row_even_style);
				$this->set_text_even_style($this->m_s_row_even_style);
			}
		}
		
		/**
		 * get acessor for variable m_s_row_uneven_style
		 * @return	string
		 * @access	public
		 **/
		
		function get_row_uneven_style()
		{
			return $this->m_s_row_uneven_style ;
		}
		
		/**
		 * set acessor for variable m_s_row_uneven_style
		 * @param string $s_row_uneven_style
		 * @access public
		 **/
		
		function set_row_uneven_style($s_row_uneven_style)
		{
			if (is_string($s_row_uneven_style))
			{
				$this->m_s_row_uneven_style = $s_row_uneven_style ;
				
				$this->set_field_uneven_style($this->m_s_row_uneven_style);
				$this->set_text_uneven_style($this->m_s_row_uneven_style);
			}
		}
		
		/**
		 * get acessor for variable m_o_header_cell
		 * @return	string
		 * @access	public
		 **/
		
		function get_header_cell()
		{
			return $this->m_o_header_cell ;
		}
		
		function set_header_cell($o_header_cell)
		{
			$this->m_o_header_cell = $o_header_cell ;
		}
		
		/**
		 * get acessor for variable m_a_button
		 * @return	array
		 * @access	public
		 **/
		
		function get_button()
		{
			return $this->m_a_button ;
		}
		
		/**
		 * set acessor for variable m_a_button
		 * @param	array	$a_button
		 * @access	public
		 **/
		
		function set_button($a_button)
		{
			if (is_array($a_button))
			{
				$this->m_a_button = $a_button ;
			}
		}
		
		/**
		 * get acessor for variable m_a_field
		 * @return	array
		 * @access	public
		 **/
		
		function get_field($i_position=null)
		{
			if (is_numeric($i_position))
			{
			    return $this->m_a_field[$i_position] ;
			}
			else
			{
				return $this->m_a_field ;
			}
		}
		
		/**
		 * set acessor for variable m_a_field
		 * @param	array	$a_field
		 * @access	public
		 **/
		
		function set_field($a_field)
		{
			if (is_array($a_field))
			{
				$this->m_a_field = $a_field ;
			}
		}
		
		/**
		 * get acessor for variable m_a_javascript
		 * @return	array
		 * @access	public
		 **/
		
		function get_javascript()
		{
			return $this->m_a_javascript ;
		}
		
		/**
		 * set acessor for variable m_a_javascript
		 * @param	array	$a_javascript
		 * @access	public
		 **/
		
		function set_javascript($a_field)
		{
			if (is_array($a_field))
			{
				$this->m_a_field = $a_field ;
			}
		}
		
		/**
		 * add javascript code
		 * @param	string	$s_code
		 * @access	public
		 **/
		
		function add_javascript($s_code)
		{
			if (is_string($s_code))
			{
				array_push($this->m_a_javascript, $s_code) ;
			}
		}
		
		function get_store_value()
		{
			return $this->m_b_store_value ;
		}
		
		function set_store_value($b_store_value)
		{
			$this->m_b_store_value = $b_store_value ;
		}
		
		/**
		 * add button
		 * @param	string	$s_button_name
		 * @param	string	$s_button_value
		 * @param	string	$s_button_help
		 * @access	public
		 **/
		
		function add_button($s_button_name, $s_button_value, $s_button_help=null)
		{
			require_once 'html_input.class.php' ;
		
			$o_button = new HTML_INPUT();
			
			$o_button->set_type('submit') ;
			$o_button->set_name($s_button_name) ;
			$o_button->set_value($s_button_value) ;
			
			if (isset($s_button_help))
			{
			    $o_button->add_attribute('onMouseOver', 'javascript:show(\'' . $this->get_name() . '_help\', \'' . htmlentities($s_button_help) . '\');');
			}
			
			array_push($this->m_a_button, $o_button) ;
			
			return $o_button ;
		}
		
		function new_field($s_name)
		{
			$o_field = new HTML_FIELD();

			$o_field->set_form($this) ;
			$o_field->set_position(count($this->m_a_field)) ;
			$o_field->set_name($s_name) ;
			
			return $o_field ;
		}
		
		/**
		 * add field
		 * @param	string 	$s_name
		 * @access	public
		 **/
		
		function add_field($o_field)
		{
			$this->m_a_field[$o_field->get_position()] = $o_field ;
		}
						
		/**
		 * validate form
		 * @return	boolean
		 * @access	public
		 **/
		
		function validate()
		{
			foreach($this->m_a_field as $o_field)
			{
				if (!$o_field->validate())
				{				
				    return false ;
				}
			}

			return true ;
		}
		
		/**
		 * process form
		 * @return boolean
		 * @access public
		 **/
		
		function process()
		{
			require_once 'html_file.class.php';
		
			$b_submit = false ;
		
			foreach($this->m_a_field as $o_field)
			{
				if (get_class($o_field) ==  'html_field')
				{
					$o_html_object = $o_field->get_html_object() ;
			
					if (get_parent_class($o_html_object) == 'html_object')
					{
					    $s_name = $o_html_object->get_name() ;
				
						if (get_class($o_field) == 'html_file')
						{
						 	$u_value = $_FILES[$s_name]['name'] ;
						}
						else
						{
							if (isset($_POST[$s_name]) || isset($_GET[$s_name]))
							{
								$u_value = ($this->get_method() == 'post') ? $_POST[$s_name] : $_GET[$s_name] ;    
							}
						}
					
						if (isset($u_value))
						{
					    	$o_html_object->set_value($u_value);
						
							$b_submit = true ;
						}
					}
				}
			}
			
			if ($b_submit)
			{			
			    if($this->validate())
				{
					foreach($this->m_a_field as $o_field)
					{
						if (!$o_field->process())
						{						
							return false ;
						}
					}
					
					if (!$this->get_store_value())
					{
					    foreach($this->m_a_field as $o_field)
						{
							$o_html_object = $o_field->get_html_object() ;
							
							if (get_parent_class($o_html_object) == 'html_object')
							{
								$o_html_object->set_value('') ;
							}
					    }
					}
			
					return true ;
				}
			
				return false ;
			}
			
			return false ;	
		}
		
		/**
		 * generate html
		 * @return string
		 * @access public
		 **/
		
		function generate()
		{
			$i_field = 0 ;
		
			ksort($this->m_a_field, SORT_NUMERIC);
			
			$s_form =	'<form ' . $this->generate_attribute() . '>' ;
			
			$s_process_message = $this->get_process_message() ;
			
			if (isset($s_process_message))
			{
				foreach ($this->m_a_button as $o_button)
				{
					$o_button->add_attribute('onClick', 'javascript:display(\'' . $this->get_name() . '_process_message\', true)') ;
				}
			
				$s_form	.=	'<div id="' . $this->get_name() . '_process_message" style="visibility:hidden; z-index:3; position:absolute; background-color:#FFFFFF; text-align:center; margin-top:100px; margin-left:120px;">'
						.	'<table width="400" height="100" border="0" cellpadding="0" cellspacing="0">'
						.	'<tr>'
						.	'<td align="center" style="font-size:14px; font-weight:bold; border:solid #DEDEDE solid 1px;">'    
						.	$this->get_process_message()
						.	'<td>'
						.	'</tr>'
						.	'</table>'
						.	'</div>' ;
				
			}
			
			
			
			$s_form  .= '<table border="0" cellpadding="0" cellspacing="0">';
			
			foreach($this->m_a_field as $o_field)
			{					
				$s_field_class = ($i_field%2 == 0) ? $this->get_field_even_class() : $this->get_field_uneven_class() ;
				$s_text_class = ($i_field%2 == 0) ? $this->get_text_even_class() : $this->get_text_uneven_class() ;
				$s_field_style = ($i_field%2 == 0) ? $this->get_field_even_style() : $this->get_field_uneven_style() ;
				$s_text_style = ($i_field%2 == 0) ? $this->get_text_even_style() : $this->get_text_uneven_style() ;
				
				$o_html_object_cell = $o_field->get_html_object_cell() ;
				$o_html_object_cell->set_width($this->get_field_width()) ;
				$o_html_object_cell->set_height($this->get_row_height()) ;
				$o_html_object_cell->set_class($s_field_class) ;
				$o_html_object_cell->set_style($s_field_style) ;
				
				$o_text_cell = $o_field->get_text_cell() ;
				
				if (isset($o_text_cell))
				{
				    $o_text_cell->set_width($this->get_text_width()) ;
					$o_text_cell->set_height($this->get_row_height()) ;
					$o_text_cell->set_class($s_text_class) ;
					$o_text_cell->set_style($s_text_style) ;
				}
			
				$s_form .= $o_field->generate() ;
				
				$i_field++ ;
			}
			
			$b_separator = false ;
			
			$s_form  	.=	'<tr>'
						.	'<td colspan="2">' ;
			
			foreach($this->get_button() as $o_button)
			{
				if ($b_separator)
				{
					$s_form .= ' ' ;
				}
				else
					$b_separator = true ;
			
				$s_form .= $o_button->generate() ;
			}
			
			$s_form		.=	'</td>'
						.	'</tr>';
			
			$s_form  .= '</table>';
			
			$s_form .= '</form>' ;
			
			$this->m_o_form_cell->set_text($s_form) ;
		
			$s_help = $this->get_help() ;
		
			if (isset($s_help))
			{
				$s_html	=	'<script language="javascript" src="framework/javascript/html_form.js"></script>' ;
			}
			else
			{
				$s_html = '' ;
			}
			
			$s_html .=	'<table border="0" cellpadding="0" cellspacing="0">'
					.	'<tr>'
					.	$this->m_o_form_cell->generate() ;
			
			if (isset($s_help))
			{
				$s_html .= $this->m_o_help_cell->generate() ;
			}
			
			$s_html .= 	'</tr>'
					. 	'</table>' ;
			
			
			return $s_html ;
		}
	}
?>
