<?php
	// +----------------------------------------------------------------------+
	// | PHP OBJECT MANAGER FRAMEWORK                                         |
	// | @copyright	(c) 2004-2005                                             |
	// | @license http://phpobjectmanager.online.fr                           |
	// +----------------------------------------------------------------------+
	// | @author Julian ROBLIN, Christophe LEFORT                             |
	// | @version 1.0                                                         |
	// +----------------------------------------------------------------------+

	require_once 'html_object.class.php' ;

	class HTML_GROUP extends HTML_OBJECT
	{
		/**
		 * html object array
		 * @var array
		 * @access protected
		 **/
	
		protected $m_a_html_object ;
	
		/**
		 * constructor
		 * @access public
		 **/

		public function __construct()
		{
			parent::__construct() ;
			
			$this->set_html_object(array());
		}

		/**
		 * destructor
		 * @access public
		 **/

		public function __destruct()
		{
			parent::__destruct() ;
		}

		/**
		 * get accessor for variable m_a_property['html_object']
		 * @return array
		 * @access public
		 **/

		public function get_html_object()
		{
			return $this->m_a_html_object ;
		}

		/**
		 * set accessor for variable m_a_html_object
		 * @param array $a_html_object
		 * @access public
		 **/

		public function set_html_object($a_html_object)
		{
			if (is_array($a_html_object))
				$this->m_a_html_object = $a_html_object ;
		}

		/**
		 * add html object
		 * @access public
		 **/

		public function add_object($o_html_object)
		{
			if ($o_html_object instanceof HTML_OBJECT)
			{
				array_push($this->m_a_html_object, $o_html_object) ;
			}
		}
		
		public function add_attribute($s_name, $s_value)
		{
			foreach($this->get_html_object() as $o_html_object)
			{
				$o_html_object->add_attribute($s_name, $s_value) ;
			}
		}
		
		public function add_check_box($s_check_box_name, $s_text, $s_check_box_value=false)
		{
			$o_check_box = new HTML_CHECK_BOX() ;
			
			$o_check_box->set_name($s_check_box_name) ;
			$o_check_box->set_value($s_check_box_value) ;
			$o_check_box->set_text($s_text) ;
			
			$this->add_object($o_check_box);
		}
		
		public function add_radio_box($s_radio_box_name, $s_text, $s_radio_box_value=false)
		{
			$o_radio_box = new HTML_RADIO_BOX() ;
			
			$o_radio_box->set_name($s_radio_box_name) ;
			$o_radio_box->set_value($s_radio_box_value) ;
			$o_radio_box->set_text($s_text) ;
			
			$this->add_object($o_radio_box);
		}
		
		public function set_value($u_value)
		{
		
		}
		
		public function process()
		{
			return true ;
		}
		
		/**
		 * generate
		 * @return string
		 * @access public
		 **/
		 
		 public function generate()
		 {
		 	$s_html .= '' ;
		 
		 	foreach($this->get_html_object() as $o_html_object)
			{
				$s_html .= '<div>' . $o_html_object->generate() . '</div>' ;
			}
			
			return $s_html ;
		 }
	}
?>