<?php
	// +----------------------------------------------------------------------+
	// | @copyright                                                           |
	// | @license http://phpobjectmanager.online.fr                           |
	// +----------------------------------------------------------------------+
	// | @author Julian ROBLIN, Christophe LEFORT                             |
	// | @version 1.0                                                         |
	// +----------------------------------------------------------------------+

	require_once 'html_object.class.php' ;

	class HTML_INPUT extends HTML_OBJECT
	{
		function HTMl_INPUT()
		{
			HTML_OBJECT::HTML_OBJECT() ;
			
			$this->set_type('text');
		}

		/**
		 * get acessor for variable m_s_value
		 * @return string
		 * @access public
		 **/

		function get_value()
		{
			return $this->m_a_attribute['value'] ;
		}

		/**
		 * set acessor for variable attribute value
		 * @param string $u_value
		 * @access public
		 **/

		function set_value($u_value)
		{
				$this->m_a_attribute['value'] = $u_value ;
		}
		
		/**
		 * get acessor for variable m_s_type
		 * @return string
		 * @access public
		 **/

		function get_type()
		{
			return $this->m_a_attribute['type'] ;
		}

		/**
		 * set acessor for variable m_s_type
		 * @param string $s_type
		 * @access public
		 **/

		function set_type($s_type)
		{
			if (is_string($s_type))
				$this->m_a_attribute['type'] = $s_type ;
		}
		
		/**
		 * get acessor for variable m_i_max_length
		 * @return integer
		 * @access public
		 **/

		function get_max_length()
		{
			return $this->m_a_attribute['maxlength'] ;
		}

		/**
		 * set acessor for variable m_i_max_length
		 * @param integer $i_max_length
		 * @access public
		 **/

		function set_max_length($i_max_length)
		{
			if (is_numeric($i_max_length))
				$this->m_a_attribute['maxlength'] = $i_max_length ;
		}
		
		/**
		 * get acessor for variable m_b_disabled
		 * @return boolean
		 * @access public
		 **/

		function get_disabled()
		{
			return $this->m_a_attribute['disabled'] ;
		}

		/**
		 * set acessor for variable m_b_disabled
		 * @param boolean $b_disabled
		 * @access public
		 **/

		function set_disabled($b_disabled)
		{
			if (is_bool($b_disabled))
				$this->m_a_attribute['disabled'] = $b_disabled ;
		}
		
		/**
		 * get acessor for variable m_s_accesskey
		 * @return string
		 * @access public
		 **/

		function get_accesskey()
		{
			return $this->m_a_attribute['accesskey'] ;
		}

		/**
		 * set acessor for variable m_s_accesskey
		 * @param string $s_accesskey
		 * @access public
		 **/

		function set_accesskey($s_accesskey)
		{
			if (is_string($s_accesskey))
				$this->m_a_attribute['accesskey'] = $s_accesskey ;
		}
		
		function process()
		{
			return true ;
		}
		
		/**
		 * generate
		 * @return string
		 * @access public
		 **/

		function generate()
		{
			$s_html	=	'<input ' . $this->generate_attribute() . '>' ;
			
			return $s_html ;
		}
	}
?>