<?php
	require_once 'html_object.class.php' ;
	require_once 'html_row.class.php' ;
		
	class HTML_LIST extends HTML_OBJECT
	{
		var $m_i_connexion ;
	
		/**
		 * border
		 * @var integer
		 * @access protected
		 **/
	
		var $m_i_border ;
	
		/**
		 * cellpadding
		 * @var integer
		 * @access protected
		 **/
		
		var $m_i_cellpadding ;
		
		/**
		 * cellspacing
		 * @var integer
		 * @access protected
		 **/
		
		var $m_i_cellspacing ;
		
		/**
		 * header class
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_header_class ;
		
		/**
		 * header style
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_header_style ;
		
		/**
		 * row even class
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_row_even_class ;
		
		/**
		 * row even style
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_row_even_style ;
		
		/**
		 * row uneven class
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_row_uneven_class;
		
		/**
		 * row uneven style
		 * @var string
		 * @access protected
		 **/
		
		var $m_s_row_uneven_style ;
		
		/**
		 * header array
		 * @var array
		 * @access protected
		 **/
		
		var $m_a_header ;
		
		/**
		 * row array
		 * @var array
		 * @access protected
		 **/
		
		var $m_a_row ;
		
		/**
		 * row count
		 * @var integer
		 * @access protected
		 **/
		
		var $m_i_row_count ;
		
		/**
		 * current row
		 * @var HTML_ROW
		 * @access protected
		 **/
		
		var $m_o_current_row ;
		
		/**
		 * start
		 * @var integer
		 * @access protected
		 **/
		 
		var $m_i_start ;
		 
		/**
		 * end
		 * @var integer
		 * @access protected
		 **/
		 
		var $m_i_limit ;
	
		/**
		 * constructor
		 * @access public
		 **/
	
		function HTML_LIST()
		{
			HTML_OBJECT::HTML_OBJECT() ;
			
			$this->m_i_border = 0;
			$this->m_i_cellpadding = 0 ;
			$this->m_i_cellspacing = 0 ;
	
			$this->m_a_header = array();
			$this->m_a_row = array();
			
			$this->m_i_row_count = 0 ;
		}
		
		function get_border()
		{
			return $this->m_i_border ;
		}
		
		function get_cellpadding()
		{
			return $this->m_i_cellpadding ;
		}
		
		function get_cellspacing()
		{
			return $this->m_i_cellspacing ;
		}
		
		function set_border($i_border)
		{
			$this->m_i_border = $i_border ;
		}
		
		function set_cellpadding($i_cellpadding)
		{
			$this->m_i_cellpadding = $i_cellpadding ;
		}
		
		function set_cellspacing($i_cellspacing)
		{
			$this->m_i_cellspacing = $i_cellspacing ;
		}
		
		
		
		function set_header_class($s_header_class)
		{
			$this->m_s_header_class = $s_header_class ;
		}
		
		function set_row_even_class($s_row_even_class)
		{
			$this->m_s_row_even_class = $s_row_even_class ;
		}
		
		function set_row_uneven_class($s_row_uneven_class)
		{
			$this->m_s_row_uneven_class = $s_row_uneven_class ;
		}
		
		function set_row_even_style($s_row_even_style)
		{
			$this->m_s_row_even_style = $s_row_even_style ;
		}
		
		function set_row_uneven_style($s_row_uneven_style)
		{
			$this->m_s_row_uneven_style = $s_row_uneven_style ;
		}
		
		/**
		 * get acessor for variable i_start
		 * @return integer
		 * @access public
		 **/

		function get_start()
		{
			return $this->m_i_start ;
		}

		/**
		 * set acessor for variable i_start
		 * @param integer
		 * @access public
		 **/

		function set_start($i_start)
		{
			$this->m_i_start = $i_start;
		}

		/**
		 * get acessor for variable i_limit
		 * @return integer
		 * @access public
		 **/

		function get_limit() { return $this->m_i_limit ; }

		/**
		 * set acessor for variable i_limit
		 * @param integer
		 * @access public
		 **/

		function set_limit($i_limit) { $this->m_i_limit = $i_limit; }
		
		/**
		  * create row
		  * @access public
		  **/
		
		function create_row()
		{
			$s_row_class = (($this->m_i_row_count%2) == 0) ? $this->m_s_row_even_class : $this->m_s_row_uneven_class;
			$s_row_style = (($this->m_i_row_count%2) == 0) ? $this->m_s_row_even_style : $this->m_s_row_uneven_style;
			
			$this->m_o_current_row = new HTML_ROW();
			
			$this->m_o_current_row->set_row_class($s_row_class) ;
			$this->m_o_current_row->set_row_style($s_row_style) ;
		
			$this->m_i_row_count++ ;
		}
		
		/**
		  * add row
		  * @access public
		  **/
		
		function add_row()
		{
			array_push($this->m_a_row, $this->m_o_current_row);
		}
		
		/**
		  * add cell
		  * @access public
		  **/
		
		function add_cell($s_text='', $i_width='', $i_height='', $i_colspan='', $s_cell_class='', $s_cell_style='')
		{
			if (strtolower(get_class($this->m_o_current_row)) == 'html_row')
			{
			    $this->m_o_current_row->add_cell($s_text, $i_width, $i_height, $i_colspan, $s_cell_class, $s_cell_style);
			}
		}
		
		function generate()
		{		
			$cpt_row = 0 ;
		
			$s_html = '<table '
					. $this->generate_attribute()
					. '>';
			
			
			
			foreach($this->m_a_row as $o_row)
				$s_html .= $o_row->generate();
			
			
			 				
			$s_html .= '</table>';
			
			return $s_html ;
		}
	}
?>