<?php

	require_once 'db_object.class.php';
	
	class HTML_OBJECT extends DB_OBJECT
	{
		/**
		 * attribute array
		 * @var array
		 * @access protected
		 **/
	
		var $m_a_attribute ;
	
		/**
		 * constructor
		 * @access	public
		 **/
	
		function HTML_OBJECT()
		{
			DB_OBJECT::DB_OBJECT() ;
		
			$this->m_a_attribute = array() ;
		}
		
		function get_attribute()
		{
			return $this->m_a_attribute;
		}
		
		function set_attribute($a_attribute)
		{
			if (is_array($a_attribute))
			{
				$this->m_a_attribute = $a_attribute ;
			}
		}
		/**
		 * add attribute
		 * @param string $s_name
		 * @param string $s_value
		 * @access public
		 **/
		
		function add_attribute($s_name, $s_value)
		{
			if (isset($s_name))
			{
				$this->m_a_attribute[$s_name] = $s_value ;				
			}
		}
		
		/**
		 * get name
		 * @return string
		 * @access public
		 **/
		
		function get_name()
		{
			if (isset($this->m_a_attribute['name']))
			{
			 	return $this->m_a_attribute['name'] ; 
			}
			
			return null ;
		}
		
		function set_name($s_name)
		{
			if (is_string($s_name))
			{
				$this->m_a_attribute['name'] = $s_name ;
			}
		}
		
		function get_id()
		{
			return $this->m_a_attribute['id'] ;
		}
		
		function set_id($s_id)
		{
			if (is_numeric($s_id))
			{
				$this->m_a_attribute['id'] = $s_id ;
			}
		}
		
		function get_class()
		{
			return $this->m_a_attribute['class'] ;
		}
		
		/**
		 * get accessor for variable m_s_class
		 * @return string
		 * @access public
		 **/
		
		function set_class($s_class)
		{
			if (is_string($s_class))
			{
				$this->m_a_attribute['class'] = $s_class ;
			}
		}
		
		/**
		 * get accessor for variable m_s_style
		 * @return string
		 * @access public
		 **/
		
		function get_style()
		{
			return $this->m_a_attribute['style'] ;
		}
		
		function set_style($s_style)
		{
			if (is_string($s_style))
			{
				$this->m_a_attribute['style'] = $s_style ;
			}
		}
		
		function add_style($s_style)
		{
			if (is_string($s_style))
			{
				$s_current_style = $this->get_style() ;
			
				$s_space = ($s_current_style) ? ' ' : '' ;
				
				$this->set_style($this->get_style() . $s_space . $s_style);				
			}
		}
		
		/**
		 * get acessor for variable m_i_tab_index
		 * @return integer
		 * @access public
		 **/

		function get_tab_index()
		{
			return $this->m_a_attribute['tabindex'] ;
		}

		/**
		 * set acessor for variable m_i_tab_index
		 * @param integer $i_tab_index
		 * @access public
		 **/

		function set_tab_index($i_tab_index)
		{
			if (is_integer($i_tab_index))
				$this->m_a_attribute['tabindex'] = $i_tab_index ;
		}
		
		/**
		 * generate attribute
		 * @return string
		 * @access public
		 **/
		
		function generate_attribute()
		{
			$s_html = '' ;
			$b_space = false ;
			
			if (is_array($this->m_a_attribute))
			{
				foreach($this->m_a_attribute as $s_name => $s_value)
				{
					if ($b_space)
					{
					    $s_html .= ' ' ;
					}
					else
						$b_space = true ;
				
					$s_html .= $s_name . '="' . $s_value . '"' ;
				}
			}
			
			return $s_html ;
		}
	}
?>
