<?php

	require_once 'html_object.class.php' ;

	class HTML_RULE extends HTML_OBJECT
	{
		/**
		 * type rule
		 * @var string
		 * @access private
		 **/

		var $m_s_type ;

		/**
		 * message
		 * @var string
		 * @access protected
		 **/

		var $m_s_message ;
		
		/**
		 * option array
		 * @var array
		 * @access protected
		 **/

		var $m_a_option ;
		
		/**
		 * field
		 * @var field
		 * @access protected
		 **/

		var $m_o_field ;
		
		/**
		 * validate
		 * @var boolean
		 * @access protected
		 **/

		var $m_b_validate ;

		/**
		 * constructor
		 * @access public
		 **/

		function HTML_RULE()
		{
			HTML_OBJECT::HTML_OBJECT() ;
			
			$this->set_option(array()) ;
		}

		/**
		 * get accessor for variable m_s_type
		 * @return string
		 * @access public
		 **/

		function get_type()
		{
			return $this->m_s_type ;
		}

		/**
		 * set accessor for variable m_s_type
		 * @param string $s_type
		 * @access public
		 **/

		function set_type($s_type)
		{
			if (is_string($s_type))
				$this->m_s_type = $s_type ;
		}

		/**
		 * get accessor for variable m_s_message
		 * @return string
		 * @access public
		 **/

		function get_message()
		{
			return $this->m_s_message ;
		}

		/**
		 * set accessor for variable m_s_message
		 * @param string $s_message
		 * @access public
		 **/

		function set_message($s_message)
		{
			if (is_string($s_message))
				$this->m_s_message = $s_message ;
		}
		
		/**
		 * get accessor for variable m_o_field
		 * @return HTML_FIELD
		 * @access public
		 **/

		function get_field()
		{
			return $this->m_o_field ;
		}

		/**
		 * set accessor for variable m_o_field
		 * @param HTML_FIELD $o_field
		 * @access public
		 **/

		function set_field($o_field)
		{

				$this->m_o_field = $o_field ;
			
		}
		
		/**
		 * get accessor for variable m_a_option
		 * @return	array
		 * @access	public
		 **/

		function get_option()
		{
			return $this->m_a_option ;
		}

		/**
		 * set accessor for variable m_a_option
		 * @param	array	$a_option
		 * @access	public
		 **/

		function set_option($a_option)
		{
			if (is_array($a_option))
				$this->m_a_option = $a_option ;
		}
		
		/**
		 * get accessor for variable m_b_validate
		 * @return boolean
		 * @access public
		 **/

		function get_validate()
		{
			return $this->m_b_validate ;
		}
				
		function validate()
		{
			if (get_class($o_html_object) == 'html_input' 
				|| get_class($o_html_object) == 'html_select'
				|| get_class($o_html_object) == 'html_check_box'
				|| get_class($o_html_object) == 'html_radio_box'
				|| get_class($o_html_object) == 'html_text_area'
			)
			{
			   $o_html_object = $this->m_o_field->get_html_object() ; 
			   
			   $u_value = $o_html_object->get_value() ;
			}
			else
			{
				$u_value = '' ;
			}
		
			switch($this->m_s_type)
			{
				case 'is_required':
				{					
					if (empty($u_value))
					{
					    $this->m_b_validate = false ;
					}
					else
					{
						$this->m_b_validate = true ;
					}
					
					break;
				}
				case 'is_email':
				{
					$o_email = new HTML_EMAIL() ;
					
					$o_email->set_adress($u_value) ;
					
					$this->m_b_validate = $o_email->check() ;
					
					break;
				}
				case 'is_numeric':
				{
					$this->m_b_validate = is_numeric($u_value) ;
					
					break;
				}
				case 'is_string':
				{
					if (is_string($u_value))
					{
					
						$this->m_b_validate = true ;
					}
					else
					{
						$this->m_b_validate = false ;
					}
					
					break;
				}
				case 'is_range':
				{
					$this->m_b_validate = true ;
				
					$i_length = strlen($u_value) ;
					
					if (isset($this->m_a_option['min_length']))
					{
						if ($i_length < $this->m_a_option['min_length'])
						{
							$this->m_b_validate = false ;
						}    
					}
					
					if (isset($this->m_a_option['max_length']))
					{
						if ($i_length > $this->m_a_option['max_length'])
						{
							$this->m_b_validate = false ;
						}
					}				
					
					break;
				}
				case 'is_filter':
				{
					$this->m_b_validate = eregi($this->m_a_option['pattern'], $u_value) ;
					
					break;
				}
				case 'is_file_extension':
				{
					$this->m_b_validate = false ;
				
					$o_html_file = $this->m_o_field->get_html_object() ;
				
					if (get_class($o_html_file) == 'html_file')
					{
						$o_file = new FILE() ;
					
						$o_file->set_name($u_value) ;
					
					 	if (is_array($this->m_a_option))
						{
					 	    foreach ($this->m_a_option as $s_file_type)
							{
								if (strtolower($s_file_type) == $o_file->get_extension())
								{
						    		$this->m_b_validate = true ;
								}	
							}	
					 	}
					}
					
					break;
				}
				case 'is_file_max_size':
				{
					$this->m_b_validate = false ;
				
					$o_html_file = $this->m_o_field->get_html_object() ;
				
					if (get_class($o_html_file) == 'html_file')
					{
						echo $_FILES[$o_html_file->get_name()]['size'] ;
					}
				
					break;
				}
				default:
				{
					$this->m_b_validate = true ;
					
					break;
				}
			}
						
			return $this->m_b_validate ;
		}
		
		/**
		 * generate
		 * @return string
		 * @access public
		 **/

		function generate()
		{
			$s_html = $this->m_s_message ;
			
			return $s_html ;
		}
	}
?>