<?php

	require_once 'html_object.class.php' ;

	class HTML_SELECT extends HTML_OBJECT
	{
		/**
		 * value array
		 * @var array
		 * @access protected
		 **/ 
	
		var $m_a_value ;
		
		/**
		 * multiple
		 * @var boolean
		 * @access protected
		 **/ 
		
		var $m_b_multiple ;
		
		/**
		 * selected value
		 * @var undefined
		 * @access protected
		 **/
		
		var $m_u_selected_value ;
	
		/**
		 * constructor
		 * @access public
		 **/

		function HTML_SELECT()
		{
			HTML_OBJECT::HTML_OBJECT() ;

			$this->set_value(array());
		}

		/**
		 * get accessor for variable m_a_object
		 * @return array
		 * @access public
		 **/

		function get_value()
		{
			return $this->m_a_value ;
		}

		/**
		 * set accessor for variable m_a_value
		 * @param	undefined	$u_value
		 * @access public
		 **/

		function set_value($u_value)
		{
			if (is_array($u_value))
			{
				if (count($this->m_a_value) > 0)
				{
				    $this->m_a_value = array_merge($this->m_a_value, $u_value) ;
				}
				else
				{
					$this->m_a_value = $u_value ;
				}
			}
			else
			{
				$this->m_u_selected_value = $u_value ;
			}
		}
		
		function add_value($s_option_value, $s_text_value)
		{
		    $this->m_a_value[$s_option_value] = $s_text_value ;
		}

		/**
		 * get accessor for variable m_u_selected_value
		 * @return string
		 * @access public
		 **/

		function get_selected_value()
		{
			return $this->m_u_selected_value ;
		}

		/**
		 * set accessor for variable u_selected_value
		 * @param string $u_selected_value
		 * @access public
		 **/

		function set_selected_value($u_selected_value)
		{
			$this->m_u_selected_value = $u_selected_value ;
		}
		
		function get_multiple()
		{
			return $this->m_b_multiple ;
		}
		
		function set_multiple($b_multiple)
		{
			$this->m_b_multiple = $b_multiple ;
		}
		
		function process()
		{
			return true ;
		}
		
		/**
		 * load value
		 * @access public
		 **/

		function load_value($o_query)
		{		
			if (get_parent_class($o_query) == 'query' || get_class($o_query) == 'query')
			{			
			    if ($o_query->Execute())
				{				
			    	while($o_query->FetchInto(&$row))
					{					
			    		$this->add_value($row[0], $row[1]) ;
			    	}
				
					$o_query->Free() ;
				}
			}
		}

		/**
		 * generate html
		 * @return string
		 * @access public
		 **/

		function generate()
		{
			$s_html = '<select ' . $this->generate_attribute() ;
			
			if ($this->m_b_multiple)
			{
				$s_html .= ' multiple';
			}
			
			$s_html .= '>' ;
			
			foreach($this->m_a_value as $hidden_value=>$visible_value)
			{
				$s_html .= '<option value="' . $hidden_value . '"' ;
				$s_html .= ($this->get_selected_value() == $hidden_value) ? ' selected' : '' ;
				$s_html .= '>' ;
				$s_html .= $visible_value ;
				$s_html .= '</option>' ;
			}

			$s_html .= '</select>' ;

			return $s_html ;
		}	
	}
?>