<?php
	/**
	 *
	 * ======================================
	 * SMILE
	 * MOTORISTES INTERNET
	 * ======================================
	 * @author Julian ROBLIN
	 * @version 1.0
	 * --------------------------------------
	 * HTML_LISTE_PAGE class
	 * 
	 * page list
	 **/

	require_once PATH_t3lib.'class.t3lib_pagetree.php';
	 
	require_once PATH_typo3conf . 'ext/smile_workflow/common/html_form.class.php' ;
	require_once PATH_typo3conf . 'ext/smile_workflow/common/html_list.class.php' ;
	require_once PATH_typo3conf . 'ext/smile_workflow/common/html_navigation.class.php' ;
	require_once PATH_typo3conf . 'ext/smile_workflow/common/html_check_box.class.php' ;

	class HTML_LIST_PAGE extends HTML_LIST
	{
		var $m_o_page_list ;
		
		var $m_i_answer_count ;
		
		var $m_b_action ;
	
		function HTML_LIST_PAGE()
		{
			HTML_LIST::HTML_LIST() ;
			
			$this->m_o_page_list = array() ;
			
			$this->m_b_action = true ;
		}
		
		function get_action()
		{
			return $this->m_b_action ;
		}
		
		function set_action($b_action)
		{
			if (is_bool($b_action))
			{
			    $this->m_b_action = $b_action ;
			}
		}
		
		function init()		
		{
			// Initialize starting point of page tree:
			
			$treeStartingPoint = 1;
			$treeStartingRecord = t3lib_BEfunc::getRecord('pages', $treeStartingPoint);
			$depth = 3;

		    // Initialize tree object:
			$tree = t3lib_div::makeInstance('t3lib_pageTree');
			
			$tree->fieldArray = array('uid','title','doktype','php_tree_stop', 'tsconfig');
			
			$tree->init('AND '.$GLOBALS['BE_USER']->getPagePermsClause(1) . ' AND doktype < 200');

		    // Creating top icon; the current page
			$HTML = t3lib_iconWorks::getIconImage('pages', $treeStartingRecord, $GLOBALS['BACK_PATH'],'align="top"');
			
			$tree->tree[] = array(
			    'row' => $treeStartingRecord,
			    'HTML'=>$HTML
			);

		    // Create the tree from starting point:
			
			$tree->getTree($treeStartingPoint, $depth, '');
			
			// Put together the tree HTML:

			$a_result = array() ;
			
			foreach($tree->tree as $data)
			{
				$a_row['uid'] = $data['row']['uid'] ;
				$a_row['title'] = $data['HTML'] . htmlspecialchars($data['row']['title']) ;
				
				
				array_push($a_result, $a_row) ;
			}

			$this->m_i_count = count($a_result) ;
			
			return $a_result ; 
			
		}
		
		function load()
		{	
			if (isset($_GET['start']))
			{
			    $this->m_i_start = $_GET['start'] ;
			}
			else
				if (isset($_POST['start']))
				{
				    $this->m_i_start = $_POST['start'] ;
				}
				else
					$this->m_i_start = 0 ;    
		
			$a_result = $this->init() ;
			
			if (($this->m_i_start + $this->m_i_limit) <= $this->m_i_count)
			{
			    $this->m_i_answer_count = $this->m_i_limit ;
			}
			else
			{
				$this->m_i_answer_count = $this->m_i_count - $this->m_i_start ;
			}
			
			if (is_array($a_result))
			{
				$i_end = $this->m_i_start + $this->m_i_answer_count ;
				
				for ($i_cpt = $this->m_i_start ; $i_cpt < $i_end ; $i_cpt++)
				{
					$o_page = new PAGE() ;
				
					$o_page->set_uid($a_result[$i_cpt]['uid'])	 ;
					$o_page->set_title($a_result[$i_cpt]['title']);
					
					$o_page->set_database($this->m_o_database) ;
				
					
					array_push($this->m_o_page_list, $o_page) ;
				}
				
			}
		}
		
		function create()
		{
			global $LANG ;
		
			$s_button = '' ;
		
			if (is_array($this->m_o_page_list))
			{			
				$this->create_row() ;
				
				$this->add_cell('&nbsp;', 30, 20, 1,'bgColor5') ;
				$this->add_cell('Uid', 50, 20, 1,'bgColor5') ;
				$this->add_cell($LANG->getLL("name"), 220, 20, 1,'bgColor5') ;
				$this->add_cell('Workflow', 150, 20, 1,'bgColor5') ;
					
				$this->add_row() ;
			
			    foreach($this->m_o_page_list as $o_page)
				{
					$this->create_row() ;
				
					$o_check_box = new HTML_CHECK_BOX() ;
					
					$o_check_box->set_name('page_list[]');
					$o_check_box->set_value($o_page->get_uid()) ;
					
					if ($this->m_b_action)
					{
					    $this->add_cell($o_check_box->generate(), 30, 20, 1, 'bgColor4', 'text-align:center;') ;
					}
					else
					{
						$this->add_cell('&nbsp;', 30, 20, 1, 'bgColor4') ;
					}
				
					$this->add_cell($o_page->get_uid(), 50, 20, 1, 'bgColor4', 'padding-left:4px;');
					$this->add_cell($o_page->get_title(), 220, 20, 1, 'bgColor4', 'padding-left:4px;');
					$this->add_cell($o_page->get_workflow(), 150, 20, 1, 'bgColor4', 'padding-left:4px;');
					
					$this->add_row() ;
				}
				
				if (isset($this->m_i_limit))
				{				
					$o_html_navigation = new HTML_NAVIGATION() ;
			
					$o_html_navigation->set_width(450);
					$o_html_navigation->set_height(20);
					$o_html_navigation->set_previous_link($LANG->getLL("previous_link"));
					$o_html_navigation->set_next_link($LANG->getLL("next_link"));
					$o_html_navigation->set_start_link($LANG->getLL("start_link"));
					$o_html_navigation->set_end_link($LANG->getLL("end_link"));
			
					$o_html_navigation->set_start($this->m_i_start);
					$o_html_navigation->set_answer_count($this->m_i_answer_count);
					$o_html_navigation->set_max_answer_count($this->m_i_limit);
					$o_html_navigation->set_total_answer_count($this->m_i_count);
			
					$o_html_navigation->set_space('&nbsp;-&nbsp;');
					$o_html_navigation->set_page_count(10);
					
					$o_html_navigation->set_message_no_answer($LANG->getLL("no_page"));
				
					if ($this->m_b_action)
					{
						$o_html_navigation->set_url(t3lib_div::getIndpEnv('SCRIPT_NAME') . '?page=assign_page') ;    
					}
					else
					{
						$o_html_navigation->set_url(t3lib_div::getIndpEnv('SCRIPT_NAME') . '?page=view_page') ;    
					}
			
					$this->create_row() ;
			
					$this->add_cell($o_html_navigation->generate(), 440, 20, 4, 'bgColor5');
			
					$this->add_row() ;    
				}
				
				if (count($this->m_o_page_list) > 0)
				{				
					if ($this->m_b_action)
					{
						$o_button_assign = new HTML_INPUT() ;
					
						$o_button_assign->set_name('action_assign_page');
						$o_button_assign->set_value($LANG->getLL("action_assign_page"));
						$o_button_assign->set_type('submit') ;
					
						$o_button_remove = new HTML_INPUT() ;
					
						$o_button_remove->set_name('action_remove');
						$o_button_remove->set_value($LANG->getLL("action_remove"));
						$o_button_remove->set_type('submit') ;    
						
						$s_button .= $o_button_assign->generate() . '&nbsp;' . $o_button_remove->generate() ;
					}
				
					$o_button_finish = new HTML_INPUT() ;
					
					$o_button_finish->set_name('action_finish');
					$o_button_finish->set_value($LANG->getLL("action_finish"));
					$o_button_finish->set_type('submit') ;

					$o_start = new HTML_INPUT() ;
					
					$o_start->set_name('start');
					$o_start->set_value($this->m_i_start);
					$o_start->set_type('hidden') ;
				
					$s_button .= '&nbsp;' . $o_button_finish->generate() . $o_start->generate() ;
				
				    $this->create_row() ;
					
					$this->add_cell($s_button, 440, 30, 4) ;
					
					$this->add_row() ;
				}
			}
		}
		
		function generate()
		{
			$this->create() ;
			
			return HTML_LIST::generate() ;
		}
	}

?>