<?php

	/**
	 * 
	 * ======================================
	 * SMILE
	 * MOTORISTES INTERNET
	 * ======================================
	 * @author Julian ROBLIN
	 * @version 1.0
	 * --------------------------------------
	 * HTML_LIST_STEP class
	 * 
	 * workflow list step
	 * 
	 **/

	require_once PATH_typo3conf . 'ext/smile_workflow/common/html_form.class.php' ;
	require_once PATH_typo3conf . 'ext/smile_workflow/common/html_check_box.class.php' ;
	require_once PATH_typo3conf . 'ext/smile_workflow/common/html_list.class.php' ;
	require_once PATH_typo3conf . 'ext/smile_workflow/common/html_navigation.class.php' ;
	require_once PATH_typo3conf . 'ext/smile_workflow/common/html_check_box.class.php' ;

	require_once 'step.class.php' ;
	require_once 'state.class.php' ;
	
	class HTML_LIST_STEP extends HTML_LIST
	{
		var $m_o_step_list ;

		function HTML_LIST_STEP()
		{
			HTML_LIST::HTML_LIST() ;
			
			$this->m_o_step_list = array() ;
		}
		
		function add_step($o_step)
		{
			if (strtolower(get_class($o_step)) == 'step')
			{
			    array_push($this->m_o_step_list, $o_step) ;
			}
		}
		
		function set_workflow($o_workflow)
		{
			$this->m_o_step_list = $o_workflow->get_step() ;
		}
		
		function load()
		{
			if (empty($_GET['start']))
			{			
				$this->m_i_start = 0 ;    
			}
			else
			{
				$this->m_i_start = $_GET['start'] ;
			}
				
			$o_table = $this->m_o_database->new_table() ;
			
			$o_table->set_name('tx_smileworkflow_step'); 
		
			$o_table->add_field('uid')	;

			$a_option = array() ;
			
			if (strtolower(get_class($o_step)) == 'workflow')
			{
			    $a_option['where'] = 'wid = ' . $o_step->get_uid() ;
			}
			
			if (isset($this->m_i_limit))
			{
				$a_option['start'] = $this->m_i_start ;
				$a_option['limit'] = $this->m_i_limit ;
			}
		
			$a_result = $o_table->select($a_option) ;
			
			$this->m_i_count = $o_table->count() ;
			
			if (is_array($a_result))
			{
				foreach($a_result as $a_row)
				{
			    	$o_step = new STEP() ;
				
					$o_step->set_uid($a_row['uid'])	 ;
					$o_step->set_database($this->m_o_database);
					
					$o_step->load() ;
					
					array_push($this->m_o_step_list, $o_step) ;
				}
			}
		}

		function create($b_action=true)
		{
			global $LANG ;	
		
			$this->create_row() ;

			$this->add_cell('&nbsp;', 30, 20, 1, 'bgColor5');
			$this->add_cell('<b>'. $LANG->getLL("state") . '</b>', 200, 20, 1,'bgColor5') ;
			$this->add_cell('<b>'. $LANG->getLL("dest_groups")  . '</b>', 220, 20, 1,'bgColor5') ;
			
			/*
			
			$this->add_cell('<b>'. $LANG->getLL("except_groups") . '</b>', 170, 20, 1,'bgColor5') ;
			
			*/
					
			$this->add_row() ;	
		
			foreach($this->m_o_step_list as $o_step)
			{			
				if (strtolower(get_class($o_step)) == 'step')
				{						
				    $this->create_row() ;
				
					$o_check_box = new HTML_CHECK_BOX() ;
					
					$o_check_box->set_name('step_list[]');
					$o_check_box->set_value($o_step->get_count()) ;
					
					if ($b_action)
					{
					    $this->add_cell('&nbsp;' . $o_check_box->generate(), 30, 20, 1, 'bgColor4') ;
					}
					else
					{
						$this->add_cell('&nbsp;', 30, 20, 1, 'bgColor4') ;
					}
					
				
					$o_state = new STATE() ;
					
					$o_state->set_uid($o_step->get_state());
					$o_state->set_database($this->m_o_database);
					
					$o_state->load() ;
					
					$a_dest_group = $o_step->get_dest_group() ;
					$a_dest_group_name = array() ;
					
					if (is_array($a_dest_group))
					{
						$o_query = $this->m_o_database->new_query() ;
						
						$o_query->add_sql('SELECT title') ;
						$o_query->add_sql('FROM be_groups') ;
						$o_query->add_sql('WHERE uid IN ('. implode(', ', $a_dest_group) .')') ;
					
					    if ($o_query->execute())
						{
					        while($a_result = $o_query->fetch())
							{
					        	array_push($a_dest_group_name, $a_result['title']) ;
					        } 
							
							$o_query->free() ;
					    }
					}
					
					/*
					
					$a_except_group = $o_step->get_except_group() ;
					$a_except_group_name = array() ;
					
					if (is_array($a_except_group))
					{
						$o_query = $this->m_o_database->new_query() ;
						
						$o_query->add_sql('SELECT title') ;
						$o_query->add_sql('FROM be_groups') ;
						$o_query->add_sql('WHERE uid IN ('. implode(', ', $a_except_group) .')') ;
					
					    if ($o_query->execute())
						{
					        while($a_result = $o_query->fetch())
							{
					        	array_push($a_except_group_name, $a_result['title']) ;
					        } 
							
							$o_query->free() ;
					    }
					}
					
					*/
										
					$this->add_cell($o_state->get_name(), 200, 20, 1, 'bgColor4', 'padding:4px;') ;
					$this->add_cell(implode('<br>', $a_dest_group_name), 220, 20, 1, 'bgColor4', 'padding:4px;') ;
					
					/*
					
					$this->add_cell(implode('<br>', $a_except_group_name), 170, 20, 1, 'bgColor4') ;
					
					*/
					 
					$this->add_row() ;
				}		
			}
 
			if (count($this->m_o_step_list) > 0 && $b_action)
			{
			    $o_input = new HTML_INPUT() ;
			
				$o_input->set_name('action_drop_step');
				$o_input->set_value($LANG->getLL("action_drop_step"));
				$o_input->set_type('submit');
			
				$this->create_row() ;
			
				$this->add_cell($o_input->generate(), 440, 30, 4);
		
				$this->add_row() ;
			}
		}
	}
?>