<?php

	/**
	 * 
	 * ======================================
	 * SMILE
	 * MOTORISTES INTERNET
	 * ======================================
	 * @author Julian ROBLIN
	 * @version 1.0
	 * --------------------------------------
	 * HTML_LIST_WORKFLOW class
	 * 
	 * workflow list
	 **/

	require_once PATH_typo3conf . 'ext/smile_workflow/common/html_list.class.php' ;
	require_once PATH_typo3conf . 'ext/smile_workflow/common/html_navigation.class.php' ;
	require_once PATH_typo3conf . 'ext/smile_workflow/common/html_check_box.class.php' ;

	require_once 'workflow.class.php' ;
	
	class HTML_LIST_WORKFLOW extends HTML_LIST
	{
		var $m_o_workflow_list ;

		function HTML_LIST_WORKFLOW()
		{
			HTML_LIST::HTML_LIST() ;
			
			$this->m_o_workflow_list = array() ;
			
			$this->m_b_action = true ;
		}
		
		function load()
		{
			global $LANG ;
		
			if (isset($_GET['start']))
			{
			    $this->m_i_start = $_GET['start'] ;
			}
			else
				if (isset($_POST['start']))
				{
				    $this->m_i_start = $_POST['start'] ;
				}
				else
					$this->m_i_start = 0 ; 
				
			$o_table = $this->m_o_database->new_table() ;
			
			$o_table->set_name('tx_smileworkflow_name'); 
		
			$o_table->add_field('uid')	;

			$a_option['where'] = 'deleted = 0 AND hidden = 0' ;
			
			if (isset($this->m_i_limit))
			{
				$a_option['start'] = $this->m_i_start ;
				$a_option['limit'] = $this->m_i_limit ;
			}
		
			$a_result = $o_table->select($a_option) ;
			
			$this->m_i_count = $o_table->count() ;
			
			if (is_array($a_result))
			{
				foreach($a_result as $a_row)
				{
			    	$o_workflow = new WORKFLOW() ;
				
					$o_workflow->set_uid($a_row['uid'])	 ;
					$o_workflow->set_database($this->m_o_database);
					
					$o_workflow->load() ;
					
					array_push($this->m_o_workflow_list, $o_workflow) ;
				}
			}
			
			$this->create_row() ;
		
			$this->add_cell('&nbsp;', 30, 20, 1, 'bgColor5');
			$this->add_cell('Uid', 50, 20, 1, 'bgColor5');
			$this->add_cell($LANG->getLL("name"), 130, 20, 1, 'bgColor5');
			$this->add_cell('Action', 240, 20, 1, 'bgColor5');
		
			$this->add_row() ;
		
			foreach($this->m_o_workflow_list as $o_workflow)
			{			
				if (strtolower(get_class($o_workflow)) == 'workflow')
				{						
				    $this->create_row() ;
				
					$o_check_box = new HTML_CHECK_BOX() ;
					
					$o_check_box->set_name('workflow_list[]');
					$o_check_box->set_value($o_workflow->get_uid()) ;
						
					$this->add_cell($o_check_box->generate(), 30, 20, 1, 'bgColor4', 'text-align:center;') ;
				
					$this->add_cell($o_workflow->get_uid(), 50, 20, 1, 'bgColor4');
					$this->add_cell($o_workflow->get_name(), 130, 20, 1, 'bgColor4');
					
					$s_assign_link = '<a href="' . t3lib_div::getIndpEnv('SCRIPT_NAME') . '?action_assign_page=1&wid=' . $o_workflow->get_uid() . '">' . $LANG->getLL("action_assign_page") . '</a>' ;
					$s_update_link = '<a href="' . t3lib_div::getIndpEnv('SCRIPT_NAME') . '?action_update_workflow=1&wid=' . $o_workflow->get_uid() . '">' . $LANG->getLL("action_update_workflow") . '</a>' ;
					$s_remove_link = '<a href="' . t3lib_div::getIndpEnv('SCRIPT_NAME') . '?action_drop_workflow=1&wid=' . $o_workflow->get_uid() . '">' . $LANG->getLL("action_drop_workflow") . '</a>' ;
					$s_view_link = '<a href="' . t3lib_div::getIndpEnv('SCRIPT_NAME') . '?action_view_workflow=1&wid=' . $o_workflow->get_uid() . '">' . $LANG->getLL("action_view_workflow") . '</a>' ;
					
					$this->add_cell($s_assign_link . ' | ' . $s_update_link . ' | ' . $s_remove_link . ' | ' . $s_view_link, 240, 20, 1, 'bgColor4');
					
					$this->add_row() ;
					
				}	
			}
			
			if (isset($this->m_i_limit))
			{
				$o_html_navigation = new HTML_NAVIGATION() ;
			
				$o_html_navigation->set_width(450);
				$o_html_navigation->set_height(20);
				$o_html_navigation->set_previous_link($LANG->getLL("previous_link"));
				$o_html_navigation->set_next_link($LANG->getLL("next_link"));
				$o_html_navigation->set_start_link($LANG->getLL("start_link"));
				$o_html_navigation->set_end_link($LANG->getLL("end_link"));
			
				$o_html_navigation->set_start($this->m_i_start);
				$o_html_navigation->set_answer_count(count($this->m_o_workflow_list));
				$o_html_navigation->set_max_answer_count($this->m_i_limit);
				$o_html_navigation->set_total_answer_count($this->m_i_count);
			
				$o_html_navigation->set_space('&nbsp;-&nbsp;');
				$o_html_navigation->set_page_count(10);
			
				$o_html_navigation->set_message_no_answer($LANG->getLL("no_workflow"));
				
				$o_html_navigation->set_url(t3lib_div::getIndpEnv('SCRIPT_NAME') . '?page=list_workflow') ;
			
				$this->create_row() ;
			
				$this->add_cell($o_html_navigation->generate(), 440, 20, 4, 'bgColor5');
			
				$this->add_row() ;    
			}
			
			$o_input_new = new HTML_INPUT() ;
			
			$o_input_new->set_name('action_create_workflow');
			$o_input_new->set_value($LANG->getLL("action_create_workflow"));
			$o_input_new->set_type('submit');
			
			$o_input_drop = new HTML_INPUT() ;
			
			$o_input_drop->set_name('action_drop_workflow');
			$o_input_drop->set_value($LANG->getLL("action_drop_workflow"));
			$o_input_drop->set_type('submit');
			
			$o_input_view = new HTML_INPUT() ;
			
			$o_input_view->set_name('action_view_page');
			$o_input_view->set_value($LANG->getLL("action_view_page"));
			$o_input_view->set_type('submit');
			
			$this->create_row() ;
			
			$this->add_cell($o_input_new->generate() . '&nbsp;' . $o_input_drop->generate(). '&nbsp;' . $o_input_view->generate(), 440, 30, 4);
			
			$this->add_row() ;	
		}
	}


?>