<?php
	/**
	 * 
	 * ======================================
	 * SMILE
	 * MOTORISTES INTERNET
	 * ======================================
	 * @author Julian ROBLIN
	 * @version 1.0
	 * --------------------------------------
	 * STEP class
	 * 
	 * workflow step
	 **/
	 
	require_once PATH_typo3conf . 'ext/smile_workflow/common/db_object.class.php';
	
	class STEP extends DB_OBJECT
	{
		/**
		 * uid
		 * @var integer
		 **/
	
		var $m_i_uid ;
		
		/**
		 * wid
		 * @var integer
		 **/
	
		var $m_i_wid ;
		
		/**
		 * state
		 * @var integer
		 **/
	
		var $m_i_state ;

		/**
		 * dest group array
		 * @var array
		 **/

		var $m_a_dest_group ;

		/**
		 * except group array
		 * @var array
		 **/

		var $m_a_except_group ;
		
		/**
		 * step count
		 * @var integer
		 **/
		
		var $m_i_count ;
		
		function STEP()
		{
			DB_OBJECT::DB_OBJECT() ;
		}
		
		/**
		 * get accessor for variable m_i_uid
		 * @return integer
		 * @access public
		 **/

		function get_uid()
		{
			return $this->m_i_uid ;
		}

		/**
		 * set accessor for variable m_i_uid
		 * @param integer $i_uid
		 * @access public
		 **/

		function set_uid($i_uid)
		{
			if (is_numeric($i_uid))
				$this->m_i_uid = $i_uid ;
		}
		
		/**
		 * get accessor for variable m_i_wid
		 * @return integer
		 * @access public
		 **/

		function get_wid()
		{
			return $this->m_i_wid ;
		}

		/**
		 * set accessor for variable m_i_wid
		 * @param integer $i_wid
		 * @access public
		 **/

		function set_wid($i_wid)
		{
			if (is_numeric($i_wid))
				$this->m_i_wid = $i_wid ;
		}
		
		/**
		 * get accessor for variable m_i_state
		 * @return integer
		 * @access public
		 **/

		function get_state()
		{
			return $this->m_i_state ;
		}

		/**
		 * set accessor for variable m_i_state
		 * @param integer $i_state
		 * @access public
		 **/

		function set_state($i_state)
		{
			if (is_numeric($i_state))
				$this->m_i_state = $i_state ;
		}
		
		/**
		 * get accessor for variable m_a_dest_group
		 * @return array
		 * @access public
		 **/

		function get_dest_group()
		{
			return $this->m_a_dest_group ;
		}

		/**
		 * set accessor for variable m_a_dest_group
		 * @param array $a_dest_group
		 * @access public
		 **/

		function set_dest_group($a_dest_group)
		{
			if (is_array($a_dest_group))
				$this->m_a_dest_group = $a_dest_group ;
		}
		
		/**
		 * get accessor for variable m_a_except_group
		 * @return array
		 * @access public
		 **/

		function get_except_group()
		{
			return $this->m_a_except_group ;
		}

		/**
		 * set accessor for variable m_a_except_group
		 * @param array $a_except_group
		 * @access public
		 **/

		function set_except_group($a_except_group)
		{
			if (is_array($a_except_group))
				$this->m_a_except_group = $a_except_group ;
		}
		
		/**
		 * get accessor for variable m_i_count
		 * @return integer
		 * @access public
		 **/

		function get_count()
		{
			return $this->m_i_count ;
		}

		/**
		 * set accessor for variable m_i_count
		 * @param integer $i_count
		 * @access public
		 **/

		function set_count($i_count)
		{
			if (is_numeric($i_count))
				$this->m_i_count = $i_count ;
		}
		
		function load()
		{
			$o_table = new $this->m_o_database->new_table() ;
			
			$o_table->set_name('tx_smileworkflow_step') ;

			$a_result = $o_table->select(
				array(
					'where' => 'uid = ' . $this->m_i_uid
				)
			);
			
			if (is_array($a_result))
			{
			    foreach($a_result as $a_row)
				{
					$this->m_i_uid = $row[0]['uid'] ;
					$this->m_i_wid = $row[0]['wid'] ;
					$this->m_i_state = $row[0]['state'] ;
					$this->m_a_dest_group = explode(',', $row[0]['destgroups']) ;
					$this->m_a_explode_group = explode(',', $row[0]['exceptgroups']) ;
				}
			}
		}
		
		function create()
		{		
			$o_table = $this->m_o_database->new_table() ;
			
			$o_table->set_name('tx_smileworkflow_step') ;
		
			$o_table->add_field('uid', array('type' => 'INT', 'auto_increment' => true));
			$o_table->add_field('pid', array('type' => 'INT', 'value' => 0));
			$o_table->add_field('tstamp', array('type' => 'TIMESTAMP', 'value' => 'UNIX_TIMESTAMP()'));
			$o_table->add_field('crdate', array('type' => 'TIMESTAMP', 'value' => 'UNIX_TIMESTAMP()'));
			$o_table->add_field('cruser_id', array('type' => 'INT', 'value' => $GLOBALS['BE_USER']->user['uid']));
			$o_table->add_field('deleted', array('type' => 'INT', 'value' => 0));
			$o_table->add_field('hidden', array('type' => 'INT', 'value' => 0));
			$o_table->add_field('wid', array('type' => 'INT', 'value' => $this->m_i_wid));
			$o_table->add_field('state', array('type' => 'BLOB', 'value' => $this->m_i_state));
			$o_table->add_field('destgroups', array('type' => 'BLOB', 'value' => implode(',', $this->m_a_dest_group)));
			
			if (is_array($this->m_a_except_group))
			{
			    $o_table->add_field('exceptgroups', array('type' => 'BLOB', 'value' => implode(',', $this->m_a_except_group)));
			}
			else
			{
				$o_table->add_field('exceptgroups', array('type' => 'BLOB', 'value' => ''));
			}
			
			if ($this->m_i_uid = $o_table->insert())
			{
				return true ;
			}
			else
			{
				return false ;
			}
		}
		
		function update()
		{
			$o_table = new $this->m_o_database->new_table() ;
			
			$o_table->set_name('tx_smileworkflow_step') ;
		}
		
		function drop()
		{
			$o_table = new $this->m_o_database->new_table() ;
			
			$o_table->set_name('tx_smileworkflow_step') ;
			
			$o_table->add_field('uid', array('type' => 'INT', 'value' => $this->m_i_uid)) ;
			
			return $o_table->delete() ;
		}
		
	}
?>