<?php
	/**
	 * 
	 * ======================================
	 * SMILE
	 * MOTORISTES INTERNET
	 * ======================================
	 * @author Julian ROBLIN
	 * @version 1.0
	 * --------------------------------------
	 * update step
	 * 
	 **/

	require_once PATH_typo3conf . 'ext/smile_workflow/common/html_form.class.php' ;
	 
	require_once 'workflow.class.php' ;
	require_once 'html_list_step.class.php' ;
	
	$s_content = '<h3>' . $LANG->getLL("list_step") . '</h3>' ;
	
	$o_database = new DB_DATABASE_MYSQL() ;
	
	$o_database->set_connection($GLOBALS['TYPO3_DB']->link);
				
	if (!$o_database->connect())
		die() ;
	
	$o_workflow = unserialize($_SESSION['workflow']) ;
	
	$o_workflow->set_database($o_database) ;
	
	$o_html_list_step = new HTML_LIST_STEP() ;
	
	$o_html_list_step->set_database($o_database);
	$o_html_list_step->set_workflow($o_workflow) ;
	
	$o_html_list_step->create() ;
	
	$o_form = new HTML_FORM() ;
			
	$o_form->set_name('step_list_form') ;
	$o_form->set_method('post') ;
	$o_form->set_action($_SERVER['REQUEST_URI']) ;
			
	$o_field = $o_form->new_field('') ;
			
	$o_field->set_text_cell(null) ;
	$o_field->set_html_object($o_html_list_step);
			
	$o_form->add_field($o_field) ;
			
	$s_content .= $o_form->generate() ;

	$s_content .= '<h3>' . $LANG->getLL("create_step") . '</h3>' ;
	
	
	$o_table = $o_database->new_table() ;
	
	$o_table->set_name('tx_smileworkflow_state') ;
	
	$o_table->add_field('uid') ;
	$o_table->add_field('name') ;
	
	$a_result = $o_table->select(
		array(
			'where' => 'deleted = 0 AND hidden = 0',
			'where' => 'uid < 4'
		)
	) ;
	
	$a_select_value = array() ;
	
	if (is_array($a_result))
	{
		foreach($a_result as $a_row)
		{
			$a_select_value_state[$a_row['uid']]	= $a_row['name'] ;
		}    
	}

	$o_table = $o_database->new_table() ;
	
	$o_table->set_name('be_groups') ;
	
	$o_table->add_field('uid') ;
	$o_table->add_field('title') ;
	
	$a_result = $o_table->select(
		array(
			'order_by' => 'title'
		)
	) ;
	
	$a_select_value = array() ;
	
	if (is_array($a_result))
	{
		foreach($a_result as $a_row)
		{		
			$a_select_value_group[$a_row['uid']] = $a_row['title'] ;
		}    
	}
	
	$o_form = new HTML_FORM() ;
					
	$o_form->set_method('post');
	$o_form->set_action($_SERVER['REQUEST_URI']);
			
	$o_form->set_text_width(300);
	$o_form->set_field_width(200);
				
	$o_field = $o_form->new_field($LANG->getLL("choose_state"));
				
	$o_select = $o_field->add_select('state_select', $a_select_value_state) ;
				
	$o_field->set_html_object($o_select) ;
				
	$o_form->add_field($o_field);
	
	$o_field = $o_form->new_field($LANG->getLL("choose_dest_group"));
					
	$o_select = $o_field->add_select('dest_group_select[]', $a_select_value_group) ;
					
	$o_select->add_attribute('size', 10) ;
	$o_select->set_multiple(true);
				
	$o_field->set_html_object($o_select) ;
				
	$o_form->add_field($o_field);
	
	/*
	
	$o_field = $o_form->new_field($LANG->getLL("choose_except_group"));
					
	$o_select = $o_field->add_select('except_group_select[]') ;
	
	$o_select->set_value($a_select_value_group);
	$o_select->add_value('', '');
	$o_select->set_selected_value('');
	$o_select->add_attribute('size', 10) ;
	$o_select->set_multiple(true);
				
	$o_field->set_html_object($o_select) ;
				
	$o_form->add_field($o_field);
	
	*/
	
	$o_form->add_button('action.create_step', $LANG->getLL("action_create_step")) ;
	$o_form->add_button('action.next', $LANG->getLL("action_next")) ;
	
	if (isset($_POST['action_create_step']))
	{
		$o_workflow->add_step($_POST['state_select'], $_POST['dest_group_select'], $_POST['except_group_select']) ;
							
		$_SESSION['workflow'] = serialize($o_workflow);
							
		header('Location:' . $_SERVER['SCRIPT_NAME'] . '?page=update_step');
			
		exit() ;
	}
	
	if (isset($_POST['action_drop_step']))
	{
		if (isset($_POST['step_list']))
		{								
			$o_workflow->remove_step($_POST['step_list']) ;
									
			$_SESSION['workflow'] = serialize($o_workflow);
									
			header('Location:' . $_SERVER['SCRIPT_NAME'] . '?page=update_step');
						
			exit() ;
		}						
	}
	
	if (isset($_POST['action_next']))
	{
		if ($o_workflow->update_step())
		{
		    unset($_SESSION['workflow']);
			
			$_SESSION['workflow'] = serialize($o_workflow);
						
			header('Location:' . $_SERVER['SCRIPT_NAME'] . '?page=assign_page');
							
			exit() ;
		}
	}
	 
	$o_database->disconnect() ;
	
	$s_content .= $o_form->generate() ;

?>