<?php

	/**
	 * 
	 * ======================================
	 * SMILE
	 * MOTORISTES INTERNET
	 * ======================================
	 * @author Julian ROBLIN
	 * @version 1.0
	 * --------------------------------------
	 * workflow class
	 * 
	 * define a workflow
	 **/
	 
	require_once PATH_typo3conf . 'ext/smile_workflow/common/db_object.class.php';

	require_once 'step.class.php' ;
	require_once 'page.class.php' ;
	
	class WORKFLOW extends DB_OBJECT
	{	
		/**
		 * uid
		 * @var integer
		 **/
	
		var $m_i_uid ;
		
		/**
		 * name
		 * @var string
		 **/
		
		var $m_s_name ;
		
		/**
		 * date
		 * @var integer (timestamp)
		 **/
		
		var $m_i_date ;	
		
		/**
		 * user
		 * @var integer
		 **/
		
		var $m_i_user ;
		
		/**
		 * page array
		 * @var array
		 * @access private
		 **/

		var $m_a_page ;
		
		/**
		 * step array
		 * @var array
		 * @access protected
		 **/

		var $m_a_step ;
		
		var $m_i_step ;
		
		function WORKFLOW()
		{					
			DB_OBJECT::DB_OBJECT() ;
		
			$this->m_a_page = array() ;
			$this->m_a_step = array() ;
			
			$this->m_i_step = 0 ;
		}
		
		/**
		 * get accessor for variable m_i_user
		 * @return integer
		 * @access public
		 **/

		function get_user()
		{
			return $this->m_i_user ;
		}

		/**
		 * set accessor for variable m_i_user
		 * @param integer $i_user
		 * @access public
		 **/

		function set_user($i_user)
		{
			if (is_numeric($i_user))
				$this->m_i_user = $i_user ;
		}

		/**
		 * get accessor for variable m_s_name
		 * @return string
		 * @access public
		 **/

		function get_name()
		{
			return $this->m_s_name ;
		}

		/**
		 * set accessor for variable m_s_name
		 * @param string $s_name
		 * @access public
		 **/

		function set_name($s_name)
		{
			if (is_string($s_name))
				$this->m_s_name = $s_name ;
		}

		/**
		 * get accessor for variable m_i_uid
		 * @return integer
		 * @access public
		 **/

		function get_uid()
		{

			return $this->m_i_uid ;
		}

		/**
		 * set accessor for variable m_i_uid
		 * @param integer $i_uid
		 * @access public
		 **/

		function set_uid($i_uid)
		{
			if (is_numeric($i_uid))
				$this->m_i_uid = $i_uid ;
		}
		
		/**
		 * get accessor for variable m_i_date
		 * @return integer
		 * @access public
		 **/

		function get_date()
		{
			return $this->m_i_date ;
		}
		
		/**
		 * get accessor for variable m_a_page
		 * @return array
		 * @access public
		 **/

		function get_page()
		{
			return $this->m_a_page ;
		}

		/**
		 * set accessor for variable m_a_page
		 * @param array $a_page
		 * @access public
		 **/

		function set_page($a_page)
		{
			if (is_array($a_page))
				$this->m_a_page = $a_page ;
		}
		
		/**
		 * get accessor for variable m_a_step
		 * @return array
		 * @access public
		 **/

		function get_step()
		{
			return $this->m_a_step ;
		}

		/**
		 * set accessor for variable m_a_page
		 * @param array $a_page
		 * @access public
		 **/

		function set_step($a_step)
		{
			if (is_array($a_step))
				$this->m_a_step = $a_step ;
		}
		
		/**
		 * add step to workflow
		 * @param	integer		$i_state
		 * @param	array		$a_dest_group
		 * @param	array		$a_except_group
		 **/
		
		function add_step($i_state, $a_dest_group, $a_except_group)
		{		
			if (is_array($this->m_a_step))
			{
			    foreach($this->m_a_step as $o_step)
				{
					$o_step ;
				
					if ($o_step->get_state() == $i_state)
					{
						$a_dest_group_step = $o_step->get_dest_group() ;
						
						if (!is_array($a_dest_group))
						{
						    return false ;
						}
						
						if (is_array($a_except_group))
						{
						    foreach($a_dest_group as $i_group)
							{
								if (in_array($i_group, $a_except_group))
								{
						    		return false ;
								}
							}
						}
						
						$a_dest_group_step = array_merge($a_dest_group_step, $a_dest_group);
						
						$o_new_step = &$this->m_a_step[$o_step->get_count()] ;
						
						$o_new_step->set_dest_group($a_dest_group_step) ;
						
					    return true ;
					}
				}
			}
			
			
			if (!is_array($a_dest_group))
			{
			    return false ;
			}
		
			if (empty($a_dest_group))
			{
			    return false ;
			}
			
			if (is_array($a_except_group))
			{
				foreach($a_dest_group as $i_group)
				{
					if (in_array($i_group, $a_except_group))
					{
				    	return false ;
					}
				}
			}
		
			$o_step = new STEP() ;
			
			$o_step->set_uid($this->m_i_step) ;
			$o_step->set_wid($this->m_i_uid) ;
			$o_step->set_state($i_state) ;
			$o_step->set_dest_group($a_dest_group);
			$o_step->set_except_group($a_except_group);
			$o_step->set_database($this->m_o_database)	;
			$o_step->set_count($this->m_i_step) ;
				
			
			if (empty($this->m_a_step[$this->m_i_step]))
			{
			    $this->m_a_step[$this->m_i_step] = $o_step ;
			}
			
			$this->m_i_step++;
			
			ksort($this->m_a_step, SORT_NUMERIC);
			
			return true ;
		}
		
		function remove_state($a_state)
		{
			if (is_array($a_state))
			{
			    foreach($a_state as $i_state)
				{
					if (!empty($i_state))
					{
					    unset($this->m_a_state[$i_state]) ;
					}
				}
			}
		}
		
		function remove_step($a_step)
		{
			if (is_array($a_step))
			{
			    foreach($a_step as $i_step)
				{
				    unset($this->m_a_step[$i_step]) ;
				}
			}
		}

		/**
		 * load workflow
		 * @access public
		 **/
		
		function load()
		{
			$o_table = $this->m_o_database->new_table() ;
			
			$o_table->set_name('tx_smileworkflow_name') ;
			
			$o_table->add_field('uid') ;
			$o_table->add_field('name') ;
			$o_table->add_field('cruser_id') ;
			
			$a_result = $o_table->select(
				array(
					'where' => 'uid = ' . $this->m_i_uid
				)
			);
			
			if (is_array($a_result))
			{									
				$a_row = array_pop($a_result) ;
			
			    $this->m_i_uid = $a_row['uid'] ;
				$this->m_s_name = $a_row['name'] ;
				$this->m_i_user = $a_row['cruser_id'] ;
				
				return true ;
			}
			
			return false ;
		}
		
		/**
		 * load page
		 * @access public
		 **/
		
		function load_page($b_this_only=false)
		{
			$o_table = $this->m_o_database->new_table() ;
			
			$o_table->set_name('pages') ;
		
			$o_table->add_field('uid') ;
			$o_table->add_field('title') ;
			$o_table->add_field('tsconfig') ;
		
			$a_result = $o_table->select(
				array(
					'order_by' => 'title'
				)
			);
			
			if (is_array($a_result))
			{
			    foreach($a_result as $a_row)
				{					
					$o_page = new PAGE() ;
					
					$o_page->set_database($this->m_o_database);
					$o_page->set_uid($a_row['uid']);
					$o_page->set_title($a_row['title']);
					$o_page->set_ts_config($a_row['tsconfig']);
					
					if ($b_this_only)
					{
					    $a_tsconfig = t3lib_BEfunc::getPagesTSconfig($a_row['uid']) ;

						if (isset($a_tsconfig['user.']['workflow']))
						{
							if ($a_tsconfig['user.']['workflow'] == $this->m_i_uid)
							{
							    array_push($this->m_a_page, $o_page) ;
							}
						}
					}
					else
					{
						array_push($this->m_a_page, $o_page) ;
					}
					
				}
			}
		}

		/**
		 * load step
		 * @access public
		 **/
		
		function load_step()
		{
			$o_table = $this->m_o_database->new_table() ;
			
			$o_table->set_name('tx_smileworkflow_step') ;
			
			$a_result = $o_table->select(
				array(
					'where' => 'wid = ' . $this->m_i_uid,
					'order_by' => 'state'
				)
			);
		
			if (is_array($a_result))
			{
			    foreach($a_result as $a_row)
				{
					$o_step = new STEP() ;
					
					$o_step->set_uid($a_row['uid']);
					$o_step->set_wid($this->m_i_uid);
					$o_step->set_state($a_row['state']);
					$o_step->set_count($this->m_i_step) ;
					
					$a_dest_group = explode(',', $a_row['destgroups']) ;
					
					if (count($a_dest_group) <= 1)
					{
						$a_dest_group = array($a_dest_group[0]) ;
					}
					
					$o_step->set_dest_group($a_dest_group);
					
					$a_except_group = explode(',', $a_row['exceptgroups']) ;
					
					if (count($a_except_group) <= 1)
					{
					    $a_except_group = array($a_except_group[0]) ;
					}
					
					$o_step->set_except_group($a_except_group);
					
					$o_step->set_database($this->m_o_database)	;
					
					$this->m_a_step[$this->m_i_step] = $o_step ;
					
					$this->m_i_step++;
				}
			}
			
			ksort($this->m_a_step, SORT_NUMERIC);
		}
			
		/**
		 * create
		 * @access public
		 **/
		
		function create()
		{		
			$o_table = $this->m_o_database->new_table() ;
			
			$o_table->set_name('tx_smileworkflow_name') ;
		
			$o_table->add_field('uid', array('type' => 'INT', 'auto_increment' => true)) ;
			$o_table->add_field('name', array('type' => 'VARCHAR', 'value' => $this->m_s_name)) ;
			$o_table->add_field('pid', array('type' => 'INT', 'value' => 0)) ;
			$o_table->add_field('tstamp', array('type' => 'TIMESTAMP', 'value' => 'UNIX_TIMESTAMP()')) ;
			$o_table->add_field('crdate', array('type' => 'TIMESTAMP', 'value' => 'UNIX_TIMESTAMP()')) ;
			$o_table->add_field('cruser_id', array('type' => 'INT', 'value' => $GLOBALS['BE_USER']->user['uid'])) ;
			$o_table->add_field('hidden', array('type' => 'INT', 'value' => 0)) ;
			$o_table->add_field('deleted', array('type' => 'INT', 'value' => 0)) ;
			
			if ($this->m_i_uid = $o_table->insert())
			{			
				return true ;
			} 
			else
			{
				return false ;
			}
		}
		
		function create_state()
		{
			if (is_array($this->m_a_state))
			{
			    foreach($this->m_a_state as $o_state)
				{
					if (get_class($o_state) == 'state')
					{
					    if (!$o_state->create())
						{
					        return false ;
					    }
					}	
				}
			}	
			
			return true ;
		}
		
		/**
		 * create step
		 * @access public
		 **/
		
		function create_step()
		{		
			if (is_array($this->m_a_step))
			{
			    foreach($this->m_a_step as $o_step)
				{
					if (get_class($o_step) == 'step')
					{
						$o_step->set_database($this->m_o_database) ;
					
					    if (!$o_step->create())
						{
					        return false ;
					    }
					}	
				}
			}	
			
			return true ;
		}
		
		/**
		 * update step
		 * @access public
		 **/
		
		function update_step()
		{
			if ($this->drop_step())
			{
				return $this->create_step();
			}
			
			return false ;
		}
		
		/**
		 * drop step
		 * @access public
		 **/
		
		function drop_step()
		{
			$o_table = $this->m_o_database->new_table() ;
				
			$o_table->set_name('tx_smileworkflow_step') ;
			
			$o_table->add_field('wid', array('type' => 'INT', 'value' => $this->m_i_uid)) ;	
			
			return $o_table->delete() ;
		}
		
		/**
		 * assign page to this workflow
		 * @access public
		 **/
		
		function assign_to($a_page)
		{
			if (is_array($a_page))
			{
			    foreach($a_page as $i_page)
				{
				   $o_page = new PAGE() ;
				   
				   $o_page->set_uid($i_page);
				   
				   $o_page->set_database($this->m_o_database);
				   
				   $o_page->assign_to($this->m_i_uid);
				}
			}
		}
		
		/**
		 * remove page from this workflow
		 * @access public
		 **/
		
		function remove_from($a_page)
		{
			if (is_array($a_page))
			{
			    foreach($a_page as $i_page)
				{
				   $o_page = new PAGE() ;
				   
				   $o_page->set_uid($i_page);
				   
				   $o_page->set_database($this->m_o_database);
				   
				   $o_page->remove_from();
				}
			}
		}
		
		/**
		 * update
		 * @access public
		 **/
		
		function update()
		{		
			$o_table = $this->m_o_database->new_table() ;
				
			$o_table->set_name('tx_smileworkflow_name') ;
			
			$o_table->add_field('name', array('type' => 'VARCHAR', 'value' => $this->m_s_name));
			
			return $o_table->update('uid = ' . $this->m_i_uid);
		}
		/**
		 * drop
		 * @access public
		 **/
		
		function drop()
		{
			$this->load_page(true);
						
			if (count($this->m_a_page) == 0)
			{
				if ($this->drop_step())
				{
				    $o_table = $this->m_o_database->new_table() ;
				
					$o_table->set_name('tx_smileworkflow_name') ;
					
					$o_table->add_field('uid', array('type' => 'INT', 'value' => $this->m_i_uid)) ;
			
					return $o_table->delete() ;
				} 
				
			    return false ;
			}
			else
			{
				return false ;
			}	
		}
	}
?>