<?php
	
	/**
	 * 
	 * ======================================
	 * SMILE
	 * MOTORISTES INTERNET
	 * ======================================
	 * @author Julian ROBLIN
	 * @version 1.0
	 * --------------------------------------
	 * HTML_DASHBOARD class
	 * 
	 **/
	
	require_once PATH_typo3conf . 'ext/smile_workflow/common/html_list.class.php' ;
	
	class HTML_DASHBOARD extends HTML_LIST
	{
		var $m_o_page_list_writing ;
		
		var $m_o_page_list_standby ;
		
		var $m_o_page_list_todo ;
		
		var $m_o_page_list_standby_delete ;
		
		var $m_o_page_list_todo_delete ;
	
		function HTML_DASHBOARD()
		{
			HTML_LIST::HTML_LIST();
			
			$this->m_o_page_list_writing = array() ;
			$this->m_o_page_list_standby = array() ;
			$this->m_o_page_list_todo = array() ;
			$this->m_o_page_list_standby_delete = array() ;
			$this->m_o_page_list_todo_delete = array() ;
		}
	
		function load()
		{
			$a_group_list = $GLOBALS['BE_USER']->userGroups ;
		
			$i_role = 0 ;
			
			foreach($a_group_list as $a_group)
			{
				if ($a_group['tx_smileworkflow_wrole'] > $i_role)
				{
				    $i_role = $a_group['tx_smileworkflow_wrole'] ;
				}
			}
			
			/**
			 * writing elements list
			 **/
		
			if ($i_role == 1)
			{
			    $o_query = $this->m_o_database->new_query() ;
			
				$o_query->add_sql('SELECT pages.uid AS uid, pages.crdate AS crdate, title, name, t3ver_label');
				$o_query->add_sql('FROM pages, tx_smileworkflow_state');
				$o_query->add_sql('WHERE pages.tx_smileworkflow_state = tx_smileworkflow_state.uid');
				$o_query->add_sql('AND tx_smileworkflow_state.uid = 1');
				$o_query->add_sql('AND pages.cruser_id = ' . $GLOBALS['BE_USER']->user['uid']);
				$o_query->add_sql('AND pages.deleted = 0');
				$o_query->add_sql('AND pages.doktype < 200');
				$o_query->add_sql('ORDER BY crdate');
			

				/**
				 * uncomment for debugging
				 **/
				 
				//echo $o_query->get_merged_sql() ;
			 
				if ($o_query->execute())
				{
				    while($a_result = $o_query->fetch())
					{
						array_push($this->m_o_page_list_writing, $a_result);
				    }
				
					$o_query->free();
				}
			}
			
			/**
			 * standby elements list
			 **/
		
			if ($i_role != 3)
			{
				$o_query = $this->m_o_database->new_query() ;
				
				$o_query->add_sql('SELECT pages.uid AS uid, tx_smileworkflow_action.tstamp crdate, title,');
				$o_query->add_sql('name, be_users.username as user, t3ver_label');
				$o_query->add_sql('FROM pages, tx_smileworkflow_state, tx_smileworkflow_action,');
				$o_query->add_sql('tx_smileworkflow_action tx_smileworkflow_action_last, be_users');
				$o_query->add_sql('WHERE pages.tx_smileworkflow_state = tx_smileworkflow_state.uid');
				$o_query->add_sql('AND tx_smileworkflow_action.state = tx_smileworkflow_state.uid');
				$o_query->add_sql('AND pages.uid = tx_smileworkflow_action.page');
				$o_query->add_sql('AND pages.uid = tx_smileworkflow_action_last.page');
				$o_query->add_sql('AND tx_smileworkflow_action.cruser_id = be_users.uid');
				$o_query->add_sql('AND pages.tx_smileworkflow_state IN (2,3)');
				$o_query->add_sql('AND tx_smileworkflow_action.statedel = 0');
				$o_query->add_sql('AND pages.deleted = 0');
				$o_query->add_sql('AND pages.doktype < 200');
				$o_query->add_sql('AND (pages.cruser_id = ' . $GLOBALS['BE_USER']->user['uid']);
				$o_query->add_sql('OR tx_smileworkflow_action.cruser_id = ' . $GLOBALS['BE_USER']->user['uid'] . ')');
				$o_query->add_sql('GROUP BY pages.uid, crdate');
				$o_query->add_sql('HAVING crdate = MAX(tx_smileworkflow_action_last.tstamp)');
				$o_query->add_sql('ORDER BY crdate');
			
				/**
				 * uncomment for debugging
				 **/
				
				//echo $o_query->get_merged_sql() ;
			
				if ($o_query->execute())
				{
				    while($a_result = $o_query->fetch())
					{
						if ($GLOBALS['BE_USER']->isInWebMount($a_result['uid']))
						{
							array_push($this->m_o_page_list_standby, $a_result);
						}
			    	}
				
					$o_query->free();
				}
			}
			
			/**
			 * todo list (validate / refuse)
			 **/
			
			if (($i_role > 1) || ($i_role == 0))
			{
				$o_query = $this->m_o_database->new_query() ;
				
				$o_query->add_sql('SELECT pages.uid AS uid, tx_smileworkflow_action.tstamp crdate, title,');
				$o_query->add_sql('name, be_users.username as user, t3ver_label');
				$o_query->add_sql('FROM pages, tx_smileworkflow_state, tx_smileworkflow_action,');
				$o_query->add_sql('tx_smileworkflow_action tx_smileworkflow_action_last, be_users');
				$o_query->add_sql('WHERE pages.tx_smileworkflow_state = tx_smileworkflow_state.uid');
				$o_query->add_sql('AND tx_smileworkflow_action.state = tx_smileworkflow_state.uid');
				$o_query->add_sql('AND tx_smileworkflow_action.statedel = 0');
				$o_query->add_sql('AND pages.uid = tx_smileworkflow_action.page');
				$o_query->add_sql('AND pages.uid = tx_smileworkflow_action_last.page');
				$o_query->add_sql('AND tx_smileworkflow_action.cruser_id = be_users.uid');
				
			 
				if ($GLOBALS['BE_USER']->isAdmin())
				{
					$o_query->add_sql('AND tx_smileworkflow_action.state > 1');
				}
				else
				{
					$o_query->add_sql('AND tx_smileworkflow_action.state = ' . $i_role);
				}

				$o_query->add_sql('AND pages.deleted = 0');
				$o_query->add_sql('AND pages.doktype < 200');
				$o_query->add_sql('GROUP BY pages.uid, crdate');
				$o_query->add_sql('HAVING crdate = MAX(tx_smileworkflow_action_last.tstamp)');
				$o_query->add_sql('ORDER BY crdate');
			
				/**
				 * uncomment for debugging
				 **/
				
				//echo $o_query->get_merged_sql() ;
			
				if ($o_query->execute())
				{
				    while($a_result = $o_query->fetch())
					{
						if ($GLOBALS['BE_USER']->isInWebMount($a_result['uid']))
						{
						    array_push($this->m_o_page_list_todo, $a_result);
						}	
				    }
				
					$o_query->free();
				}
			}
			
			/**
			 * stantby elements to delete
			 **/
			
			$o_query = $this->m_o_database->new_query() ;
			
			$o_query->add_sql('SELECT pages.uid AS uid, tx_smileworkflow_action.tstamp crdate, title,');
			$o_query->add_sql('be_users.username as user, t3ver_label');
			$o_query->add_sql('FROM pages, tx_smileworkflow_action,');
			$o_query->add_sql('tx_smileworkflow_action tx_smileworkflow_action_last, be_users');
			$o_query->add_sql('WHERE (pages.cruser_id = ' . $GLOBALS['BE_USER']->user['uid']);
			$o_query->add_sql('OR tx_smileworkflow_action.cruser_id = ' . $GLOBALS['BE_USER']->user['uid'] . ')');
			$o_query->add_sql('AND pages.uid = tx_smileworkflow_action.page');
			$o_query->add_sql('AND pages.uid = tx_smileworkflow_action_last.page');
			$o_query->add_sql('AND tx_smileworkflow_action.statedel > 0');
			$o_query->add_sql('AND pages.deleted = 0');
			$o_query->add_sql('AND pages.doktype < 200');
			$o_query->add_sql('GROUP BY pages.uid, crdate');
			$o_query->add_sql('HAVING crdate = MAX(tx_smileworkflow_action_last.tstamp)');
			$o_query->add_sql('ORDER BY crdate');
			
			/**
			 * uncomment for debugging
			 **/
				
			//echo $o_query->get_merged_sql() ;
			
			if ($o_query->execute())
			{
			    while($a_result = $o_query->fetch())
				{
					array_push($this->m_o_page_list_standby_delete, $a_result);	
				}
			}
			
			/**
			 * to do list (delete)
			 **/
			 
			$o_query = $this->m_o_database->new_query() ;
				
			$o_query->add_sql('SELECT pages.uid AS uid, title, tx_smileworkflow_action.tstamp crdate');
			$o_query->add_sql('FROM tx_smileworkflow_action, pages, tx_smileworkflow_action tx_smileworkflow_action_last');
			$o_query->add_sql('WHERE pages.uid = tx_smileworkflow_action.page');
			$o_query->add_sql('AND pages.uid = tx_smileworkflow_action_last.page');
			$o_query->add_sql('AND pages.deleted = 0');
			
			if ($GLOBALS['BE_USER']->isAdmin())
			{
				$o_query->add_sql('AND tx_smileworkflow_action.statedel > 0');
			}
			else
			{
				$o_query->add_sql('AND tx_smileworkflow_action.statedel = ' . $i_role);
			}
			
			$o_query->add_sql('GROUP BY pages.uid, crdate');
			$o_query->add_sql('HAVING crdate = MAX(tx_smileworkflow_action_last.tstamp)');
			$o_query->add_sql('ORDER BY crdate');
			
			//echo $o_query->get_highlighted_sql('<br>') ;
			
			if ($o_query->execute())
			{
			    while($a_result = $o_query->fetch())
				{
					if ($GLOBALS['BE_USER']->isInWebMount($a_result['uid']))
					{
					    array_push($this->m_o_page_list_todo_delete, $a_result);
					}	
				}
			}
		}
		
		function generate()
		{
			global $LANG;
			
			$a_group_list = $GLOBALS['BE_USER']->userGroups ;
		
			$i_role = 0 ;
			
			foreach($a_group_list as $a_group)
			{
				if ($a_group['tx_smileworkflow_wrole'] > $i_role)
				{
				    $i_role = $a_group['tx_smileworkflow_wrole'] ;
				}
			}
			
			/**
			 * writing elements list
			 **/
			
			if (($i_role == 1))
			{
			    $this->create_row() ;
			
				$this->add_cell('<h3>' . $LANG->getLL("list_task_writing") . '</h3>', 470, 20, 3);
			
				$this->add_row() ;
		
				$this->create_row() ;
			
				$this->add_cell('<b>' . $LANG->getLL("title_page") . '</b>', 160, 20, 1, 'bgColor5');
				$this->add_cell('<b>' . $LANG->getLL("date_create") . '</b>', 130, 20, 1, 'bgColor5');
				$this->add_cell('<b>' . $LANG->getLL("state") . '</b>', 150, 20, 1, 'bgColor5');
			
				$this->add_row() ;
			
				foreach($this->m_o_page_list_writing as $o_page)
				{
					$s_version = (empty($o_page['t3ver_label'])) ? '' : '[' . $o_page['t3ver_label'] . ']';
				
					$s_edit_link = '<img'.t3lib_iconWorks::skinImg($GLOBALS['BACK_PATH'],'gfx/edit2.gif','width="11" height="12"').' title="Edit me" border="0" alt="" />';
			
					$s_view_link = $o_page['title'] . ' ' . $s_version ;
					
					$s_href_link = t3lib_div::getIndpEnv('TYPO3_SITE_URL') . t3lib_extMgm::siteRelPath('cms') . 'layout/db_layout.php?id=' . $o_page['uid'] ;
			
					$this->create_row() ;
			
					$this->add_cell('<a href="'. $s_href_link . '">' . $s_edit_link . '</a> ' . $s_view_link, 160, 20, 1, 'bgColor4');
					$this->add_cell(date('d/m/Y',$o_page['crdate']), 150, 20, 1, 'bgColor4');
					$this->add_cell($o_page['name'], 150, 20, 1, 'bgColor4');
			
					$this->add_row() ;
				}
			}
			
			/**
			 * standby elements list
			 **/

			if ($i_role != 3)
			{
			 	$this->create_row() ;
			
				$this->add_cell('<h3>' . $LANG->getLL("list_task_standby") . '</h3>', 470, 20, 3);
			
				$this->add_row() ;
			
				$this->create_row() ;
			
				$this->add_cell('<b>' . $LANG->getLL("title_page") . '</b>', 160, 20, 1, 'bgColor5');
				$this->add_cell('<b>' . $LANG->getLL("date_modified") . '</b>', 150, 20, 1, 'bgColor5');
				$this->add_cell('<b>' . $LANG->getLL("state") . '</b>', 150, 20, 1, 'bgColor5');
			
				$this->add_row() ;

				foreach($this->m_o_page_list_standby as $o_page)
				{
					$s_version = (empty($o_page['t3ver_label'])) ? '' : '[' . $o_page['t3ver_label'] . ']';
				
					$this->create_row() ;
			
					$this->add_cell($o_page['title'] . ' ' . $s_version, 160, 20, 1, 'bgColor4');
					$this->add_cell(date('d/m/Y',$o_page['crdate']), 150, 20, 1, 'bgColor4');
					$this->add_cell($o_page['name'], 150, 20, 1, 'bgColor4');
			
					$this->add_row() ;
				}
			}
			
			/**
			 * todo list
			 **/

			if ((($i_role > 1) || ($i_role == 0)))
			{
				$this->create_row() ;
			
				$this->add_cell('<h3>' . $LANG->getLL("list_task_todo") . '</h3>', 470, 20, 3);
			
				$this->add_row() ;
			
				$this->create_row() ;
			
				$this->add_cell('<b>' . $LANG->getLL("title_page") . '</b>', 160, 20, 1, 'bgColor5');
				$this->add_cell('<b>' . $LANG->getLL("date_modified") . '</b>', 150, 20, 1, 'bgColor5');
				$this->add_cell('<b>' . $LANG->getLL("state") . '</b>', 150, 20, 1, 'bgColor5');
			
				$this->add_row() ;
			
				foreach($this->m_o_page_list_todo as $o_page)
				{
					$s_version = (empty($o_page['t3ver_label'])) ? '' : '[' . $o_page['t3ver_label'] . ']';

					$s_view = '<img'.t3lib_iconWorks::skinImg($GLOBALS['BACK_PATH'],'gfx/zoom.gif','width="12" height="12"').' title="Edit me" border="0" alt="" />';
				
					$s_href = t3lib_div::getIndpEnv('TYPO3_SITE_URL') . 'index.php?id=' . $o_page['uid'] ;
				
					$this->create_row() ;
			
					$this->add_cell('<a href="'. $s_href .'" target="_blank">'. $s_view .'</a>&nbsp;' . $o_page['title'] . ' ' . $s_version, 160, 20, 1, 'bgColor4');
					$this->add_cell(date('d/m/Y',$o_page['crdate']) . ' ' . $LANG->getLL("by") . ' ' . $o_page['user'], 150, 20, 1, 'bgColor4');
					$this->add_cell($o_page['name'], 150, 20, 1, 'bgColor4');
			
					$this->add_row() ;
				}    
			}
			
			/**
			 * stantby elements to delete
			 **/
			 
			$this->create_row() ;
			
			$this->add_cell('<h3>' . $LANG->getLL("list_task_standby_delete") . '</h3>', 470, 20, 3);
			
			$this->add_row() ;
			
			$this->create_row() ;
			
			$this->add_cell('<b>' . $LANG->getLL("title_page") . '</b>', 160, 20, 1, 'bgColor5');
			$this->add_cell('<b>' . $LANG->getLL("date_modified") . '</b>', 150, 20, 1, 'bgColor5');
			$this->add_cell('<b>' . $LANG->getLL("state") . '</b>', 150, 20, 1, 'bgColor5');
			
			$this->add_row() ;
			
			foreach($this->m_o_page_list_standby_delete as $o_page)
			{
				$s_version = (empty($o_page['t3ver_label'])) ? '' : '[' . $o_page['t3ver_label'] . ']';
				
				$this->create_row() ;
			
				$this->add_cell($o_page['title'] . ' ' . $s_version, 160, 20, 1, 'bgColor4');
				$this->add_cell(date('d/m/Y',$o_page['crdate']) . ' ' . $LANG->getLL("by") . ' ' . $o_page['user'], 150, 20, 1, 'bgColor4');
				$this->add_cell($LANG->getLL("standby_to_delete"), 150, 20, 1, 'bgColor4');
			
				$this->add_row() ;
			} 
			
			/**
			 * to do list (delete)
			 **/
			 
			$this->create_row() ;
			
			$this->add_cell('<h3>' . $LANG->getLL("list_task_todo_delete") . '</h3>', 470, 20, 3);
			
			$this->add_row() ;
			
			$this->create_row() ;
			
			$this->add_cell('<b>' . $LANG->getLL("title_page") . '</b>', 160, 20, 1, 'bgColor5');
			$this->add_cell('<b>' . $LANG->getLL("date_modified") . '</b>', 150, 20, 1, 'bgColor5');
			$this->add_cell('<b>' . $LANG->getLL("state") . '</b>', 150, 20, 1, 'bgColor5');
			
			$this->add_row() ;
			
			foreach($this->m_o_page_list_todo_delete as $o_page)
			{
				$s_version = (empty($o_page['t3ver_label'])) ? '' : '[' . $o_page['t3ver_label'] . ']';
			
				$this->create_row() ;
			
				$this->add_cell($o_page['title'] . ' ' . $s_version, 160, 20, 1, 'bgColor4');
				$this->add_cell(date('d/m/Y',$o_page['crdate']) . ' ' . $LANG->getLL("by") . ' ' . $o_page['user'], 150, 20, 1, 'bgColor4');
				$this->add_cell($LANG->getLL("to_delete"), 150, 20, 1, 'bgColor4');
			
				$this->add_row() ;
			} 
			
			return parent::generate() ;
		}
	}

?>